/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         FRONTEND_VERILOG_YYSTYPE
#define YYLTYPE         FRONTEND_VERILOG_YYLTYPE
/* Substitute the variable and function names.  */
#define yyparse         frontend_verilog_yyparse
#define yylex           frontend_verilog_yylex
#define yyerror         frontend_verilog_yyerror
#define yydebug         frontend_verilog_yydebug
#define yynerrs         frontend_verilog_yynerrs

/* First part of user prologue.  */
#line 36 "frontends/verilog/verilog_parser.y"

#include <list>
#include <stack>
#include <string.h>
#include "frontends/verilog/verilog_frontend.h"
#include "frontends/verilog/verilog_parser.tab.hh"
#include "kernel/log.h"

#define YYLEX_PARAM &yylval, &yylloc

USING_YOSYS_NAMESPACE
using namespace AST;
using namespace VERILOG_FRONTEND;

YOSYS_NAMESPACE_BEGIN
namespace VERILOG_FRONTEND {
	int port_counter;
	dict<std::string, int> port_stubs;
	dict<IdString, AstNode*> *attr_list, default_attr_list;
	std::stack<dict<IdString, AstNode*> *> attr_list_stack;
	dict<IdString, AstNode*> *albuf;
	std::vector<UserTypeMap*> user_type_stack;
	dict<std::string, AstNode*> pkg_user_types;
	std::vector<AstNode*> ast_stack;
	struct AstNode *astbuf1, *astbuf2, *astbuf3;
	struct AstNode *current_function_or_task;
	struct AstNode *current_ast, *current_ast_mod;
	int current_function_or_task_port_id;
	std::vector<char> case_type_stack;
	bool do_not_require_port_stubs;
	bool default_nettype_wire;
	bool sv_mode, formal_mode, lib_mode, specify_mode;
	bool noassert_mode, noassume_mode, norestrict_mode;
	bool assume_asserts_mode, assert_assumes_mode;
	bool current_wire_rand, current_wire_const;
	bool current_modport_input, current_modport_output;
	std::istream *lexin;
}
YOSYS_NAMESPACE_END

#define SET_AST_NODE_LOC(WHICH, BEGIN, END) \
    do { (WHICH)->location.first_line = (BEGIN).first_line; \
    (WHICH)->location.first_column = (BEGIN).first_column; \
    (WHICH)->location.last_line = (END).last_line; \
    (WHICH)->location.last_column = (END).last_column; } while(0)

#define SET_RULE_LOC(LHS, BEGIN, END) \
    do { (LHS).first_line = (BEGIN).first_line; \
    (LHS).first_column = (BEGIN).first_column; \
    (LHS).last_line = (END).last_line; \
    (LHS).last_column = (END).last_column; } while(0)

int frontend_verilog_yylex(YYSTYPE *yylval_param, YYLTYPE *yyloc_param);

static void append_attr(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second;
	}
	delete al;
}

static void append_attr_clone(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second->clone();
	}
}

static void free_attr(dict<IdString, AstNode*> *al)
{
	for (auto &it : *al)
		delete it.second;
	delete al;
}

struct specify_target {
	char polarity_op;
	AstNode *dst, *dat;
};

struct specify_triple {
	AstNode *t_min, *t_avg, *t_max;
};

struct specify_rise_fall {
	specify_triple rise;
	specify_triple fall;
};

static void addTypedefNode(std::string *name, AstNode *node)
{
	log_assert(node);
	auto *tnode = new AstNode(AST_TYPEDEF, node);
	tnode->str = *name;
	auto user_types = user_type_stack.back();
	(*user_types)[*name] = tnode;
	if (current_ast_mod && current_ast_mod->type == AST_PACKAGE) {
		// typedef inside a package so we need the qualified name
		auto qname = current_ast_mod->str + "::" + (*name).substr(1);
		pkg_user_types[qname] = tnode;
	}
	delete name;
	ast_stack.back()->children.push_back(tnode);
}

static void enterTypeScope()
{
	auto user_types = new UserTypeMap();
	user_type_stack.push_back(user_types);
}

static void exitTypeScope()
{
	user_type_stack.pop_back();
}

static bool isInLocalScope(const std::string *name)
{
	// tests if a name was declared in the current block scope
	auto user_types = user_type_stack.back();
	return (user_types->count(*name) > 0);
}

static AstNode *getTypeDefinitionNode(std::string type_name)
{
	// return the definition nodes from the typedef statement
	auto user_types = user_type_stack.back();
	log_assert(user_types->count(type_name) > 0);
	auto typedef_node = (*user_types)[type_name];
	log_assert(typedef_node->type == AST_TYPEDEF);
	return typedef_node->children[0];
}

static AstNode *copyTypeDefinition(std::string type_name)
{
	// return a copy of the template from a typedef definition
	auto typedef_node = getTypeDefinitionNode(type_name);
	return typedef_node->clone();
}

static AstNode *makeRange(int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = new AstNode(AST_RANGE);
	range->children.push_back(AstNode::mkconst_int(msb, true));
	range->children.push_back(AstNode::mkconst_int(lsb, true));
	range->is_signed = isSigned;
	return range;
}

static void addRange(AstNode *parent, int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = makeRange(msb, lsb, isSigned);
	parent->children.push_back(range);
}

static AstNode *checkRange(AstNode *type_node, AstNode *range_node)
{
	if (type_node->range_left >= 0 && type_node->range_right >= 0) {
		// type already restricts the range
		if (range_node) {
			frontend_verilog_yyerror("integer/genvar types cannot have packed dimensions.");
		}
		else {
			range_node = makeRange(type_node->range_left, type_node->range_right, false);
		}
	}
	if (range_node && range_node->children.size() != 2) {
		frontend_verilog_yyerror("wire/reg/logic packed dimension must be of the form: [<expr>:<expr>], [<expr>+:<expr>], or [<expr>-:<expr>]");
	}
	return range_node;
}

static void rewriteRange(AstNode *rangeNode)
{
	if (rangeNode->type == AST_RANGE && rangeNode->children.size() == 1) {
		// SV array size [n], rewrite as [n-1:0]
		rangeNode->children[0] = new AstNode(AST_SUB, rangeNode->children[0], AstNode::mkconst_int(1, true));
		rangeNode->children.push_back(AstNode::mkconst_int(0, false));
	}
}

static void rewriteAsMemoryNode(AstNode *node, AstNode *rangeNode)
{
	node->type = AST_MEMORY;
	if (rangeNode->type == AST_MULTIRANGE) {
		for (auto *itr : rangeNode->children)
			rewriteRange(itr);
	} else
		rewriteRange(rangeNode);
	node->children.push_back(rangeNode);
}


#line 277 "frontends/verilog/verilog_parser.tab.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "verilog_parser.tab.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_STRING = 3,                 /* TOK_STRING  */
  YYSYMBOL_TOK_ID = 4,                     /* TOK_ID  */
  YYSYMBOL_TOK_CONSTVAL = 5,               /* TOK_CONSTVAL  */
  YYSYMBOL_TOK_REALVAL = 6,                /* TOK_REALVAL  */
  YYSYMBOL_TOK_PRIMITIVE = 7,              /* TOK_PRIMITIVE  */
  YYSYMBOL_TOK_SVA_LABEL = 8,              /* TOK_SVA_LABEL  */
  YYSYMBOL_TOK_SPECIFY_OPER = 9,           /* TOK_SPECIFY_OPER  */
  YYSYMBOL_TOK_MSG_TASKS = 10,             /* TOK_MSG_TASKS  */
  YYSYMBOL_TOK_BASE = 11,                  /* TOK_BASE  */
  YYSYMBOL_TOK_BASED_CONSTVAL = 12,        /* TOK_BASED_CONSTVAL  */
  YYSYMBOL_TOK_UNBASED_UNSIZED_CONSTVAL = 13, /* TOK_UNBASED_UNSIZED_CONSTVAL  */
  YYSYMBOL_TOK_USER_TYPE = 14,             /* TOK_USER_TYPE  */
  YYSYMBOL_TOK_PKG_USER_TYPE = 15,         /* TOK_PKG_USER_TYPE  */
  YYSYMBOL_TOK_ASSERT = 16,                /* TOK_ASSERT  */
  YYSYMBOL_TOK_ASSUME = 17,                /* TOK_ASSUME  */
  YYSYMBOL_TOK_RESTRICT = 18,              /* TOK_RESTRICT  */
  YYSYMBOL_TOK_COVER = 19,                 /* TOK_COVER  */
  YYSYMBOL_TOK_FINAL = 20,                 /* TOK_FINAL  */
  YYSYMBOL_ATTR_BEGIN = 21,                /* ATTR_BEGIN  */
  YYSYMBOL_ATTR_END = 22,                  /* ATTR_END  */
  YYSYMBOL_DEFATTR_BEGIN = 23,             /* DEFATTR_BEGIN  */
  YYSYMBOL_DEFATTR_END = 24,               /* DEFATTR_END  */
  YYSYMBOL_TOK_MODULE = 25,                /* TOK_MODULE  */
  YYSYMBOL_TOK_ENDMODULE = 26,             /* TOK_ENDMODULE  */
  YYSYMBOL_TOK_PARAMETER = 27,             /* TOK_PARAMETER  */
  YYSYMBOL_TOK_LOCALPARAM = 28,            /* TOK_LOCALPARAM  */
  YYSYMBOL_TOK_DEFPARAM = 29,              /* TOK_DEFPARAM  */
  YYSYMBOL_TOK_PACKAGE = 30,               /* TOK_PACKAGE  */
  YYSYMBOL_TOK_ENDPACKAGE = 31,            /* TOK_ENDPACKAGE  */
  YYSYMBOL_TOK_PACKAGESEP = 32,            /* TOK_PACKAGESEP  */
  YYSYMBOL_TOK_INTERFACE = 33,             /* TOK_INTERFACE  */
  YYSYMBOL_TOK_ENDINTERFACE = 34,          /* TOK_ENDINTERFACE  */
  YYSYMBOL_TOK_MODPORT = 35,               /* TOK_MODPORT  */
  YYSYMBOL_TOK_VAR = 36,                   /* TOK_VAR  */
  YYSYMBOL_TOK_WILDCARD_CONNECT = 37,      /* TOK_WILDCARD_CONNECT  */
  YYSYMBOL_TOK_INPUT = 38,                 /* TOK_INPUT  */
  YYSYMBOL_TOK_OUTPUT = 39,                /* TOK_OUTPUT  */
  YYSYMBOL_TOK_INOUT = 40,                 /* TOK_INOUT  */
  YYSYMBOL_TOK_WIRE = 41,                  /* TOK_WIRE  */
  YYSYMBOL_TOK_WAND = 42,                  /* TOK_WAND  */
  YYSYMBOL_TOK_WOR = 43,                   /* TOK_WOR  */
  YYSYMBOL_TOK_REG = 44,                   /* TOK_REG  */
  YYSYMBOL_TOK_LOGIC = 45,                 /* TOK_LOGIC  */
  YYSYMBOL_TOK_INTEGER = 46,               /* TOK_INTEGER  */
  YYSYMBOL_TOK_SIGNED = 47,                /* TOK_SIGNED  */
  YYSYMBOL_TOK_ASSIGN = 48,                /* TOK_ASSIGN  */
  YYSYMBOL_TOK_PLUS_ASSIGN = 49,           /* TOK_PLUS_ASSIGN  */
  YYSYMBOL_TOK_ALWAYS = 50,                /* TOK_ALWAYS  */
  YYSYMBOL_TOK_INITIAL = 51,               /* TOK_INITIAL  */
  YYSYMBOL_TOK_ALWAYS_FF = 52,             /* TOK_ALWAYS_FF  */
  YYSYMBOL_TOK_ALWAYS_COMB = 53,           /* TOK_ALWAYS_COMB  */
  YYSYMBOL_TOK_ALWAYS_LATCH = 54,          /* TOK_ALWAYS_LATCH  */
  YYSYMBOL_TOK_BEGIN = 55,                 /* TOK_BEGIN  */
  YYSYMBOL_TOK_END = 56,                   /* TOK_END  */
  YYSYMBOL_TOK_IF = 57,                    /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 58,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_FOR = 59,                   /* TOK_FOR  */
  YYSYMBOL_TOK_WHILE = 60,                 /* TOK_WHILE  */
  YYSYMBOL_TOK_REPEAT = 61,                /* TOK_REPEAT  */
  YYSYMBOL_TOK_DPI_FUNCTION = 62,          /* TOK_DPI_FUNCTION  */
  YYSYMBOL_TOK_POSEDGE = 63,               /* TOK_POSEDGE  */
  YYSYMBOL_TOK_NEGEDGE = 64,               /* TOK_NEGEDGE  */
  YYSYMBOL_TOK_OR = 65,                    /* TOK_OR  */
  YYSYMBOL_TOK_AUTOMATIC = 66,             /* TOK_AUTOMATIC  */
  YYSYMBOL_TOK_CASE = 67,                  /* TOK_CASE  */
  YYSYMBOL_TOK_CASEX = 68,                 /* TOK_CASEX  */
  YYSYMBOL_TOK_CASEZ = 69,                 /* TOK_CASEZ  */
  YYSYMBOL_TOK_ENDCASE = 70,               /* TOK_ENDCASE  */
  YYSYMBOL_TOK_DEFAULT = 71,               /* TOK_DEFAULT  */
  YYSYMBOL_TOK_FUNCTION = 72,              /* TOK_FUNCTION  */
  YYSYMBOL_TOK_ENDFUNCTION = 73,           /* TOK_ENDFUNCTION  */
  YYSYMBOL_TOK_TASK = 74,                  /* TOK_TASK  */
  YYSYMBOL_TOK_ENDTASK = 75,               /* TOK_ENDTASK  */
  YYSYMBOL_TOK_SPECIFY = 76,               /* TOK_SPECIFY  */
  YYSYMBOL_TOK_IGNORED_SPECIFY = 77,       /* TOK_IGNORED_SPECIFY  */
  YYSYMBOL_TOK_ENDSPECIFY = 78,            /* TOK_ENDSPECIFY  */
  YYSYMBOL_TOK_SPECPARAM = 79,             /* TOK_SPECPARAM  */
  YYSYMBOL_TOK_SPECIFY_AND = 80,           /* TOK_SPECIFY_AND  */
  YYSYMBOL_TOK_IGNORED_SPECIFY_AND = 81,   /* TOK_IGNORED_SPECIFY_AND  */
  YYSYMBOL_TOK_GENERATE = 82,              /* TOK_GENERATE  */
  YYSYMBOL_TOK_ENDGENERATE = 83,           /* TOK_ENDGENERATE  */
  YYSYMBOL_TOK_GENVAR = 84,                /* TOK_GENVAR  */
  YYSYMBOL_TOK_REAL = 85,                  /* TOK_REAL  */
  YYSYMBOL_TOK_SYNOPSYS_FULL_CASE = 86,    /* TOK_SYNOPSYS_FULL_CASE  */
  YYSYMBOL_TOK_SYNOPSYS_PARALLEL_CASE = 87, /* TOK_SYNOPSYS_PARALLEL_CASE  */
  YYSYMBOL_TOK_SUPPLY0 = 88,               /* TOK_SUPPLY0  */
  YYSYMBOL_TOK_SUPPLY1 = 89,               /* TOK_SUPPLY1  */
  YYSYMBOL_TOK_TO_SIGNED = 90,             /* TOK_TO_SIGNED  */
  YYSYMBOL_TOK_TO_UNSIGNED = 91,           /* TOK_TO_UNSIGNED  */
  YYSYMBOL_TOK_POS_INDEXED = 92,           /* TOK_POS_INDEXED  */
  YYSYMBOL_TOK_NEG_INDEXED = 93,           /* TOK_NEG_INDEXED  */
  YYSYMBOL_TOK_PROPERTY = 94,              /* TOK_PROPERTY  */
  YYSYMBOL_TOK_ENUM = 95,                  /* TOK_ENUM  */
  YYSYMBOL_TOK_TYPEDEF = 96,               /* TOK_TYPEDEF  */
  YYSYMBOL_TOK_RAND = 97,                  /* TOK_RAND  */
  YYSYMBOL_TOK_CONST = 98,                 /* TOK_CONST  */
  YYSYMBOL_TOK_CHECKER = 99,               /* TOK_CHECKER  */
  YYSYMBOL_TOK_ENDCHECKER = 100,           /* TOK_ENDCHECKER  */
  YYSYMBOL_TOK_EVENTUALLY = 101,           /* TOK_EVENTUALLY  */
  YYSYMBOL_TOK_INCREMENT = 102,            /* TOK_INCREMENT  */
  YYSYMBOL_TOK_DECREMENT = 103,            /* TOK_DECREMENT  */
  YYSYMBOL_TOK_UNIQUE = 104,               /* TOK_UNIQUE  */
  YYSYMBOL_TOK_UNIQUE0 = 105,              /* TOK_UNIQUE0  */
  YYSYMBOL_TOK_PRIORITY = 106,             /* TOK_PRIORITY  */
  YYSYMBOL_TOK_STRUCT = 107,               /* TOK_STRUCT  */
  YYSYMBOL_TOK_PACKED = 108,               /* TOK_PACKED  */
  YYSYMBOL_TOK_UNSIGNED = 109,             /* TOK_UNSIGNED  */
  YYSYMBOL_TOK_INT = 110,                  /* TOK_INT  */
  YYSYMBOL_TOK_BYTE = 111,                 /* TOK_BYTE  */
  YYSYMBOL_TOK_SHORTINT = 112,             /* TOK_SHORTINT  */
  YYSYMBOL_TOK_LONGINT = 113,              /* TOK_LONGINT  */
  YYSYMBOL_TOK_UNION = 114,                /* TOK_UNION  */
  YYSYMBOL_TOK_OR_ASSIGN = 115,            /* TOK_OR_ASSIGN  */
  YYSYMBOL_TOK_XOR_ASSIGN = 116,           /* TOK_XOR_ASSIGN  */
  YYSYMBOL_TOK_AND_ASSIGN = 117,           /* TOK_AND_ASSIGN  */
  YYSYMBOL_TOK_SUB_ASSIGN = 118,           /* TOK_SUB_ASSIGN  */
  YYSYMBOL_OP_LOR = 119,                   /* OP_LOR  */
  YYSYMBOL_OP_LAND = 120,                  /* OP_LAND  */
  YYSYMBOL_121_ = 121,                     /* '|'  */
  YYSYMBOL_OP_NOR = 122,                   /* OP_NOR  */
  YYSYMBOL_123_ = 123,                     /* '^'  */
  YYSYMBOL_OP_XNOR = 124,                  /* OP_XNOR  */
  YYSYMBOL_125_ = 125,                     /* '&'  */
  YYSYMBOL_OP_NAND = 126,                  /* OP_NAND  */
  YYSYMBOL_OP_EQ = 127,                    /* OP_EQ  */
  YYSYMBOL_OP_NE = 128,                    /* OP_NE  */
  YYSYMBOL_OP_EQX = 129,                   /* OP_EQX  */
  YYSYMBOL_OP_NEX = 130,                   /* OP_NEX  */
  YYSYMBOL_131_ = 131,                     /* '<'  */
  YYSYMBOL_OP_LE = 132,                    /* OP_LE  */
  YYSYMBOL_OP_GE = 133,                    /* OP_GE  */
  YYSYMBOL_134_ = 134,                     /* '>'  */
  YYSYMBOL_OP_SHL = 135,                   /* OP_SHL  */
  YYSYMBOL_OP_SHR = 136,                   /* OP_SHR  */
  YYSYMBOL_OP_SSHL = 137,                  /* OP_SSHL  */
  YYSYMBOL_OP_SSHR = 138,                  /* OP_SSHR  */
  YYSYMBOL_139_ = 139,                     /* '+'  */
  YYSYMBOL_140_ = 140,                     /* '-'  */
  YYSYMBOL_141_ = 141,                     /* '*'  */
  YYSYMBOL_142_ = 142,                     /* '/'  */
  YYSYMBOL_143_ = 143,                     /* '%'  */
  YYSYMBOL_OP_POW = 144,                   /* OP_POW  */
  YYSYMBOL_OP_CAST = 145,                  /* OP_CAST  */
  YYSYMBOL_UNARY_OPS = 146,                /* UNARY_OPS  */
  YYSYMBOL_FAKE_THEN = 147,                /* FAKE_THEN  */
  YYSYMBOL_148_ = 148,                     /* ','  */
  YYSYMBOL_149_ = 149,                     /* '='  */
  YYSYMBOL_150_ = 150,                     /* '.'  */
  YYSYMBOL_151_ = 151,                     /* '('  */
  YYSYMBOL_152_ = 152,                     /* ')'  */
  YYSYMBOL_153_ = 153,                     /* ';'  */
  YYSYMBOL_154_ = 154,                     /* '#'  */
  YYSYMBOL_155_ = 155,                     /* ':'  */
  YYSYMBOL_156_ = 156,                     /* '['  */
  YYSYMBOL_157_ = 157,                     /* ']'  */
  YYSYMBOL_158_ = 158,                     /* '{'  */
  YYSYMBOL_159_ = 159,                     /* '}'  */
  YYSYMBOL_160_ = 160,                     /* '@'  */
  YYSYMBOL_161_ = 161,                     /* '?'  */
  YYSYMBOL_162_ = 162,                     /* '~'  */
  YYSYMBOL_163_ = 163,                     /* '!'  */
  YYSYMBOL_YYACCEPT = 164,                 /* $accept  */
  YYSYMBOL_input = 165,                    /* input  */
  YYSYMBOL_166_1 = 166,                    /* $@1  */
  YYSYMBOL_design = 167,                   /* design  */
  YYSYMBOL_attr = 168,                     /* attr  */
  YYSYMBOL_169_2 = 169,                    /* $@2  */
  YYSYMBOL_attr_opt = 170,                 /* attr_opt  */
  YYSYMBOL_defattr = 171,                  /* defattr  */
  YYSYMBOL_172_3 = 172,                    /* $@3  */
  YYSYMBOL_173_4 = 173,                    /* $@4  */
  YYSYMBOL_opt_attr_list = 174,            /* opt_attr_list  */
  YYSYMBOL_attr_list = 175,                /* attr_list  */
  YYSYMBOL_attr_assign = 176,              /* attr_assign  */
  YYSYMBOL_hierarchical_id = 177,          /* hierarchical_id  */
  YYSYMBOL_hierarchical_type_id = 178,     /* hierarchical_type_id  */
  YYSYMBOL_module = 179,                   /* module  */
  YYSYMBOL_180_5 = 180,                    /* $@5  */
  YYSYMBOL_181_6 = 181,                    /* $@6  */
  YYSYMBOL_module_para_opt = 182,          /* module_para_opt  */
  YYSYMBOL_183_7 = 183,                    /* $@7  */
  YYSYMBOL_184_8 = 184,                    /* $@8  */
  YYSYMBOL_module_para_list = 185,         /* module_para_list  */
  YYSYMBOL_single_module_para = 186,       /* single_module_para  */
  YYSYMBOL_187_9 = 187,                    /* $@9  */
  YYSYMBOL_188_10 = 188,                   /* $@10  */
  YYSYMBOL_module_args_opt = 189,          /* module_args_opt  */
  YYSYMBOL_module_args = 190,              /* module_args  */
  YYSYMBOL_optional_comma = 191,           /* optional_comma  */
  YYSYMBOL_module_arg_opt_assignment = 192, /* module_arg_opt_assignment  */
  YYSYMBOL_module_arg = 193,               /* module_arg  */
  YYSYMBOL_194_11 = 194,                   /* $@11  */
  YYSYMBOL_195_12 = 195,                   /* $@12  */
  YYSYMBOL_196_13 = 196,                   /* $@13  */
  YYSYMBOL_197_14 = 197,                   /* $@14  */
  YYSYMBOL_package = 198,                  /* package  */
  YYSYMBOL_199_15 = 199,                   /* $@15  */
  YYSYMBOL_200_16 = 200,                   /* $@16  */
  YYSYMBOL_package_body = 201,             /* package_body  */
  YYSYMBOL_package_body_stmt = 202,        /* package_body_stmt  */
  YYSYMBOL_interface = 203,                /* interface  */
  YYSYMBOL_204_17 = 204,                   /* $@17  */
  YYSYMBOL_205_18 = 205,                   /* $@18  */
  YYSYMBOL_interface_body = 206,           /* interface_body  */
  YYSYMBOL_interface_body_stmt = 207,      /* interface_body_stmt  */
  YYSYMBOL_mintypmax_expr = 208,           /* mintypmax_expr  */
  YYSYMBOL_non_opt_delay = 209,            /* non_opt_delay  */
  YYSYMBOL_delay = 210,                    /* delay  */
  YYSYMBOL_io_wire_type = 211,             /* io_wire_type  */
  YYSYMBOL_212_19 = 212,                   /* $@19  */
  YYSYMBOL_non_io_wire_type = 213,         /* non_io_wire_type  */
  YYSYMBOL_214_20 = 214,                   /* $@20  */
  YYSYMBOL_wire_type = 215,                /* wire_type  */
  YYSYMBOL_wire_type_token_io = 216,       /* wire_type_token_io  */
  YYSYMBOL_wire_type_signedness = 217,     /* wire_type_signedness  */
  YYSYMBOL_wire_type_const_rand = 218,     /* wire_type_const_rand  */
  YYSYMBOL_opt_wire_type_token = 219,      /* opt_wire_type_token  */
  YYSYMBOL_wire_type_token = 220,          /* wire_type_token  */
  YYSYMBOL_logic_type = 221,               /* logic_type  */
  YYSYMBOL_integer_atom_type = 222,        /* integer_atom_type  */
  YYSYMBOL_non_opt_range = 223,            /* non_opt_range  */
  YYSYMBOL_non_opt_multirange = 224,       /* non_opt_multirange  */
  YYSYMBOL_range = 225,                    /* range  */
  YYSYMBOL_range_or_multirange = 226,      /* range_or_multirange  */
  YYSYMBOL_module_body = 227,              /* module_body  */
  YYSYMBOL_module_body_stmt = 228,         /* module_body_stmt  */
  YYSYMBOL_checker_decl = 229,             /* checker_decl  */
  YYSYMBOL_230_21 = 230,                   /* $@21  */
  YYSYMBOL_task_func_decl = 231,           /* task_func_decl  */
  YYSYMBOL_232_22 = 232,                   /* $@22  */
  YYSYMBOL_233_23 = 233,                   /* $@23  */
  YYSYMBOL_234_24 = 234,                   /* $@24  */
  YYSYMBOL_235_25 = 235,                   /* $@25  */
  YYSYMBOL_236_26 = 236,                   /* $@26  */
  YYSYMBOL_func_return_type = 237,         /* func_return_type  */
  YYSYMBOL_opt_type_vec = 238,             /* opt_type_vec  */
  YYSYMBOL_opt_signedness_default_signed = 239, /* opt_signedness_default_signed  */
  YYSYMBOL_opt_signedness_default_unsigned = 240, /* opt_signedness_default_unsigned  */
  YYSYMBOL_dpi_function_arg = 241,         /* dpi_function_arg  */
  YYSYMBOL_opt_dpi_function_args = 242,    /* opt_dpi_function_args  */
  YYSYMBOL_dpi_function_args = 243,        /* dpi_function_args  */
  YYSYMBOL_opt_automatic = 244,            /* opt_automatic  */
  YYSYMBOL_task_func_args_opt = 245,       /* task_func_args_opt  */
  YYSYMBOL_246_27 = 246,                   /* $@27  */
  YYSYMBOL_247_28 = 247,                   /* $@28  */
  YYSYMBOL_task_func_args = 248,           /* task_func_args  */
  YYSYMBOL_task_func_port = 249,           /* task_func_port  */
  YYSYMBOL_250_29 = 250,                   /* $@29  */
  YYSYMBOL_251_30 = 251,                   /* $@30  */
  YYSYMBOL_task_func_body = 252,           /* task_func_body  */
  YYSYMBOL_specify_block = 253,            /* specify_block  */
  YYSYMBOL_specify_item_list = 254,        /* specify_item_list  */
  YYSYMBOL_specify_item = 255,             /* specify_item  */
  YYSYMBOL_specify_opt_triple = 256,       /* specify_opt_triple  */
  YYSYMBOL_specify_if = 257,               /* specify_if  */
  YYSYMBOL_specify_condition = 258,        /* specify_condition  */
  YYSYMBOL_specify_target = 259,           /* specify_target  */
  YYSYMBOL_specify_edge = 260,             /* specify_edge  */
  YYSYMBOL_specify_rise_fall = 261,        /* specify_rise_fall  */
  YYSYMBOL_specify_triple = 262,           /* specify_triple  */
  YYSYMBOL_ignored_specify_block = 263,    /* ignored_specify_block  */
  YYSYMBOL_ignored_specify_item_opt = 264, /* ignored_specify_item_opt  */
  YYSYMBOL_ignored_specify_item = 265,     /* ignored_specify_item  */
  YYSYMBOL_specparam_declaration = 266,    /* specparam_declaration  */
  YYSYMBOL_specparam_range = 267,          /* specparam_range  */
  YYSYMBOL_list_of_specparam_assignments = 268, /* list_of_specparam_assignments  */
  YYSYMBOL_specparam_assignment = 269,     /* specparam_assignment  */
  YYSYMBOL_ignspec_opt_cond = 270,         /* ignspec_opt_cond  */
  YYSYMBOL_path_declaration = 271,         /* path_declaration  */
  YYSYMBOL_simple_path_declaration = 272,  /* simple_path_declaration  */
  YYSYMBOL_path_delay_value = 273,         /* path_delay_value  */
  YYSYMBOL_list_of_path_delay_extra_expressions = 274, /* list_of_path_delay_extra_expressions  */
  YYSYMBOL_specify_edge_identifier = 275,  /* specify_edge_identifier  */
  YYSYMBOL_parallel_path_description = 276, /* parallel_path_description  */
  YYSYMBOL_full_path_description = 277,    /* full_path_description  */
  YYSYMBOL_list_of_path_inputs = 278,      /* list_of_path_inputs  */
  YYSYMBOL_more_path_inputs = 279,         /* more_path_inputs  */
  YYSYMBOL_list_of_path_outputs = 280,     /* list_of_path_outputs  */
  YYSYMBOL_opt_polarity_operator = 281,    /* opt_polarity_operator  */
  YYSYMBOL_specify_input_terminal_descriptor = 282, /* specify_input_terminal_descriptor  */
  YYSYMBOL_specify_output_terminal_descriptor = 283, /* specify_output_terminal_descriptor  */
  YYSYMBOL_system_timing_declaration = 284, /* system_timing_declaration  */
  YYSYMBOL_system_timing_arg = 285,        /* system_timing_arg  */
  YYSYMBOL_system_timing_args = 286,       /* system_timing_args  */
  YYSYMBOL_ignspec_constant_expression = 287, /* ignspec_constant_expression  */
  YYSYMBOL_ignspec_expr = 288,             /* ignspec_expr  */
  YYSYMBOL_ignspec_id = 289,               /* ignspec_id  */
  YYSYMBOL_290_31 = 290,                   /* $@31  */
  YYSYMBOL_param_signed = 291,             /* param_signed  */
  YYSYMBOL_param_integer = 292,            /* param_integer  */
  YYSYMBOL_param_real = 293,               /* param_real  */
  YYSYMBOL_param_range = 294,              /* param_range  */
  YYSYMBOL_param_integer_type = 295,       /* param_integer_type  */
  YYSYMBOL_param_range_type = 296,         /* param_range_type  */
  YYSYMBOL_param_implicit_type = 297,      /* param_implicit_type  */
  YYSYMBOL_param_type = 298,               /* param_type  */
  YYSYMBOL_param_decl = 299,               /* param_decl  */
  YYSYMBOL_300_32 = 300,                   /* $@32  */
  YYSYMBOL_localparam_decl = 301,          /* localparam_decl  */
  YYSYMBOL_302_33 = 302,                   /* $@33  */
  YYSYMBOL_param_decl_list = 303,          /* param_decl_list  */
  YYSYMBOL_single_param_decl = 304,        /* single_param_decl  */
  YYSYMBOL_single_param_decl_ident = 305,  /* single_param_decl_ident  */
  YYSYMBOL_defparam_decl = 306,            /* defparam_decl  */
  YYSYMBOL_defparam_decl_list = 307,       /* defparam_decl_list  */
  YYSYMBOL_single_defparam_decl = 308,     /* single_defparam_decl  */
  YYSYMBOL_enum_type = 309,                /* enum_type  */
  YYSYMBOL_310_34 = 310,                   /* $@34  */
  YYSYMBOL_enum_base_type = 311,           /* enum_base_type  */
  YYSYMBOL_type_atom = 312,                /* type_atom  */
  YYSYMBOL_type_vec = 313,                 /* type_vec  */
  YYSYMBOL_type_signing = 314,             /* type_signing  */
  YYSYMBOL_enum_name_list = 315,           /* enum_name_list  */
  YYSYMBOL_enum_name_decl = 316,           /* enum_name_decl  */
  YYSYMBOL_opt_enum_init = 317,            /* opt_enum_init  */
  YYSYMBOL_enum_var_list = 318,            /* enum_var_list  */
  YYSYMBOL_enum_var = 319,                 /* enum_var  */
  YYSYMBOL_enum_decl = 320,                /* enum_decl  */
  YYSYMBOL_struct_decl = 321,              /* struct_decl  */
  YYSYMBOL_struct_type = 322,              /* struct_type  */
  YYSYMBOL_323_35 = 323,                   /* $@35  */
  YYSYMBOL_struct_union = 324,             /* struct_union  */
  YYSYMBOL_struct_body = 325,              /* struct_body  */
  YYSYMBOL_opt_packed = 326,               /* opt_packed  */
  YYSYMBOL_opt_signed_struct = 327,        /* opt_signed_struct  */
  YYSYMBOL_struct_member_list = 328,       /* struct_member_list  */
  YYSYMBOL_struct_member = 329,            /* struct_member  */
  YYSYMBOL_member_name_list = 330,         /* member_name_list  */
  YYSYMBOL_member_name = 331,              /* member_name  */
  YYSYMBOL_332_36 = 332,                   /* $@36  */
  YYSYMBOL_struct_member_type = 333,       /* struct_member_type  */
  YYSYMBOL_334_37 = 334,                   /* $@37  */
  YYSYMBOL_member_type_token = 335,        /* member_type_token  */
  YYSYMBOL_336_38 = 336,                   /* $@38  */
  YYSYMBOL_member_type = 337,              /* member_type  */
  YYSYMBOL_struct_var_list = 338,          /* struct_var_list  */
  YYSYMBOL_struct_var = 339,               /* struct_var  */
  YYSYMBOL_wire_decl = 340,                /* wire_decl  */
  YYSYMBOL_341_39 = 341,                   /* $@39  */
  YYSYMBOL_342_40 = 342,                   /* $@40  */
  YYSYMBOL_343_41 = 343,                   /* $@41  */
  YYSYMBOL_344_42 = 344,                   /* $@42  */
  YYSYMBOL_opt_supply_wires = 345,         /* opt_supply_wires  */
  YYSYMBOL_wire_name_list = 346,           /* wire_name_list  */
  YYSYMBOL_wire_name_and_opt_assign = 347, /* wire_name_and_opt_assign  */
  YYSYMBOL_wire_name = 348,                /* wire_name  */
  YYSYMBOL_assign_stmt = 349,              /* assign_stmt  */
  YYSYMBOL_assign_expr_list = 350,         /* assign_expr_list  */
  YYSYMBOL_assign_expr = 351,              /* assign_expr  */
  YYSYMBOL_type_name = 352,                /* type_name  */
  YYSYMBOL_typedef_decl = 353,             /* typedef_decl  */
  YYSYMBOL_non_wire_data_type = 354,       /* non_wire_data_type  */
  YYSYMBOL_cell_stmt = 355,                /* cell_stmt  */
  YYSYMBOL_356_43 = 356,                   /* $@43  */
  YYSYMBOL_357_44 = 357,                   /* $@44  */
  YYSYMBOL_tok_prim_wrapper = 358,         /* tok_prim_wrapper  */
  YYSYMBOL_cell_list = 359,                /* cell_list  */
  YYSYMBOL_single_cell = 360,              /* single_cell  */
  YYSYMBOL_361_45 = 361,                   /* $@45  */
  YYSYMBOL_362_46 = 362,                   /* $@46  */
  YYSYMBOL_prim_list = 363,                /* prim_list  */
  YYSYMBOL_single_prim = 364,              /* single_prim  */
  YYSYMBOL_365_47 = 365,                   /* $@47  */
  YYSYMBOL_cell_parameter_list_opt = 366,  /* cell_parameter_list_opt  */
  YYSYMBOL_cell_parameter_list = 367,      /* cell_parameter_list  */
  YYSYMBOL_cell_parameter = 368,           /* cell_parameter  */
  YYSYMBOL_cell_port_list = 369,           /* cell_port_list  */
  YYSYMBOL_cell_port_list_rules = 370,     /* cell_port_list_rules  */
  YYSYMBOL_cell_port = 371,                /* cell_port  */
  YYSYMBOL_always_comb_or_latch = 372,     /* always_comb_or_latch  */
  YYSYMBOL_always_or_always_ff = 373,      /* always_or_always_ff  */
  YYSYMBOL_always_stmt = 374,              /* always_stmt  */
  YYSYMBOL_375_48 = 375,                   /* $@48  */
  YYSYMBOL_376_49 = 376,                   /* $@49  */
  YYSYMBOL_377_50 = 377,                   /* $@50  */
  YYSYMBOL_378_51 = 378,                   /* $@51  */
  YYSYMBOL_always_cond = 379,              /* always_cond  */
  YYSYMBOL_always_events = 380,            /* always_events  */
  YYSYMBOL_always_event = 381,             /* always_event  */
  YYSYMBOL_opt_label = 382,                /* opt_label  */
  YYSYMBOL_opt_sva_label = 383,            /* opt_sva_label  */
  YYSYMBOL_opt_property = 384,             /* opt_property  */
  YYSYMBOL_modport_stmt = 385,             /* modport_stmt  */
  YYSYMBOL_386_52 = 386,                   /* $@52  */
  YYSYMBOL_387_53 = 387,                   /* $@53  */
  YYSYMBOL_modport_args_opt = 388,         /* modport_args_opt  */
  YYSYMBOL_modport_args = 389,             /* modport_args  */
  YYSYMBOL_modport_arg = 390,              /* modport_arg  */
  YYSYMBOL_modport_member = 391,           /* modport_member  */
  YYSYMBOL_modport_type_token = 392,       /* modport_type_token  */
  YYSYMBOL_assert = 393,                   /* assert  */
  YYSYMBOL_assert_property = 394,          /* assert_property  */
  YYSYMBOL_simple_behavioral_stmt = 395,   /* simple_behavioral_stmt  */
  YYSYMBOL_behavioral_stmt = 396,          /* behavioral_stmt  */
  YYSYMBOL_397_54 = 397,                   /* $@54  */
  YYSYMBOL_398_55 = 398,                   /* $@55  */
  YYSYMBOL_399_56 = 399,                   /* $@56  */
  YYSYMBOL_400_57 = 400,                   /* $@57  */
  YYSYMBOL_401_58 = 401,                   /* $@58  */
  YYSYMBOL_402_59 = 402,                   /* $@59  */
  YYSYMBOL_403_60 = 403,                   /* $@60  */
  YYSYMBOL_404_61 = 404,                   /* $@61  */
  YYSYMBOL_405_62 = 405,                   /* $@62  */
  YYSYMBOL_406_63 = 406,                   /* $@63  */
  YYSYMBOL_407_64 = 407,                   /* $@64  */
  YYSYMBOL_408_65 = 408,                   /* $@65  */
  YYSYMBOL_case_attr = 409,                /* case_attr  */
  YYSYMBOL_case_type = 410,                /* case_type  */
  YYSYMBOL_opt_synopsys_attr = 411,        /* opt_synopsys_attr  */
  YYSYMBOL_behavioral_stmt_list = 412,     /* behavioral_stmt_list  */
  YYSYMBOL_optional_else = 413,            /* optional_else  */
  YYSYMBOL_414_66 = 414,                   /* $@66  */
  YYSYMBOL_case_body = 415,                /* case_body  */
  YYSYMBOL_case_item = 416,                /* case_item  */
  YYSYMBOL_417_67 = 417,                   /* $@67  */
  YYSYMBOL_418_68 = 418,                   /* $@68  */
  YYSYMBOL_gen_case_body = 419,            /* gen_case_body  */
  YYSYMBOL_gen_case_item = 420,            /* gen_case_item  */
  YYSYMBOL_421_69 = 421,                   /* $@69  */
  YYSYMBOL_422_70 = 422,                   /* $@70  */
  YYSYMBOL_case_select = 423,              /* case_select  */
  YYSYMBOL_case_expr_list = 424,           /* case_expr_list  */
  YYSYMBOL_rvalue = 425,                   /* rvalue  */
  YYSYMBOL_lvalue = 426,                   /* lvalue  */
  YYSYMBOL_lvalue_concat_list = 427,       /* lvalue_concat_list  */
  YYSYMBOL_opt_arg_list = 428,             /* opt_arg_list  */
  YYSYMBOL_arg_list = 429,                 /* arg_list  */
  YYSYMBOL_arg_list2 = 430,                /* arg_list2  */
  YYSYMBOL_single_arg = 431,               /* single_arg  */
  YYSYMBOL_module_gen_body = 432,          /* module_gen_body  */
  YYSYMBOL_gen_stmt_or_module_body_stmt = 433, /* gen_stmt_or_module_body_stmt  */
  YYSYMBOL_gen_stmt = 434,                 /* gen_stmt  */
  YYSYMBOL_435_71 = 435,                   /* $@71  */
  YYSYMBOL_436_72 = 436,                   /* $@72  */
  YYSYMBOL_437_73 = 437,                   /* $@73  */
  YYSYMBOL_438_74 = 438,                   /* $@74  */
  YYSYMBOL_439_75 = 439,                   /* $@75  */
  YYSYMBOL_gen_block = 440,                /* gen_block  */
  YYSYMBOL_441_76 = 441,                   /* $@76  */
  YYSYMBOL_442_77 = 442,                   /* $@77  */
  YYSYMBOL_gen_stmt_block = 443,           /* gen_stmt_block  */
  YYSYMBOL_444_78 = 444,                   /* $@78  */
  YYSYMBOL_opt_gen_else = 445,             /* opt_gen_else  */
  YYSYMBOL_expr = 446,                     /* expr  */
  YYSYMBOL_basic_expr = 447,               /* basic_expr  */
  YYSYMBOL_448_79 = 448,                   /* $@79  */
  YYSYMBOL_concat_list = 449,              /* concat_list  */
  YYSYMBOL_integral_number = 450           /* integral_number  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL \
             && defined FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2789

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  164
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  287
/* YYNRULES -- Number of rules.  */
#define YYNRULES  649
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1275

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   392


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   163,     2,   154,     2,   143,   125,     2,
     151,   152,   141,   139,   148,   140,   150,   142,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   155,   153,
     131,   149,   134,   161,   160,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   156,     2,   157,   123,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   158,   121,   159,   162,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   122,   124,   126,   127,
     128,   129,   130,   132,   133,   135,   136,   137,   138,   144,
     145,   146,   147
};

#if FRONTEND_VERILOG_YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   328,   328,   328,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   351,   351,   367,   370,   373,   380,   373,
     391,   391,   394,   395,   398,   404,   412,   415,   423,   433,
     434,   435,   439,   441,   439,   464,   464,   464,   464,   467,
     467,   470,   471,   471,   477,   477,   483,   486,   486,   486,
     489,   489,   492,   492,   495,   512,   515,   515,   529,   534,
     529,   544,   544,   560,   565,   567,   565,   581,   581,   584,
     584,   584,   587,   589,   587,   610,   610,   613,   613,   613,
     613,   613,   613,   613,   614,   617,   618,   621,   622,   623,
     624,   625,   626,   629,   629,   632,   632,   637,   637,   642,
     643,   646,   649,   652,   658,   659,   660,   663,   667,   670,
     673,   676,   676,   679,   684,   687,   691,   693,   696,   699,
     703,   706,   709,   712,   721,   723,   730,   731,   732,   733,
     734,   737,   742,   748,   754,   760,   763,   769,   772,   777,
     778,   781,   783,   784,   785,   786,   789,   789,   789,   789,
     789,   789,   789,   789,   789,   789,   790,   790,   791,   791,
     791,   791,   791,   791,   794,   794,   805,   805,   815,   815,
     826,   826,   838,   838,   850,   850,   874,   877,   881,   886,
     887,   888,   892,   893,   894,   897,   898,   899,   903,   908,
     914,   915,   918,   919,   920,   921,   924,   925,   928,   928,
     928,   932,   928,   940,   940,   943,   943,   964,   964,   978,
     979,   984,   987,   988,   991,  1075,  1147,  1150,  1155,  1158,
    1163,  1166,  1171,  1177,  1183,  1189,  1197,  1198,  1199,  1202,
    1210,  1217,  1226,  1238,  1258,  1264,  1274,  1275,  1278,  1279,
    1282,  1285,  1286,  1290,  1291,  1297,  1300,  1300,  1303,  1306,
    1306,  1309,  1315,  1316,  1320,  1321,  1322,  1326,  1327,  1331,
    1331,  1334,  1335,  1336,  1339,  1340,  1341,  1345,  1346,  1349,
    1350,  1353,  1354,  1357,  1357,  1357,  1361,  1365,  1368,  1371,
    1372,  1373,  1376,  1377,  1378,  1385,  1388,  1389,  1396,  1396,
    1402,  1404,  1406,  1409,  1414,  1419,  1425,  1427,  1430,  1433,
    1436,  1436,  1436,  1436,  1437,  1444,  1444,  1453,  1453,  1462,
    1462,  1465,  1471,  1484,  1501,  1504,  1504,  1507,  1520,  1520,
    1542,  1543,  1544,  1548,  1554,  1555,  1559,  1560,  1561,  1564,
    1565,  1569,  1584,  1585,  1589,  1590,  1593,  1605,  1612,  1615,
    1615,  1619,  1620,  1623,  1627,  1628,  1631,  1632,  1633,  1636,
    1637,  1640,  1644,  1645,  1648,  1648,  1657,  1657,  1661,  1662,
    1679,  1679,  1691,  1692,  1695,  1696,  1699,  1712,  1716,  1712,
    1722,  1722,  1730,  1730,  1740,  1741,  1752,  1752,  1755,  1797,
    1825,  1871,  1874,  1874,  1877,  1883,  1884,  1888,  1901,  1905,
    1906,  1910,  1910,  1919,  1919,  1929,  1932,  1937,  1938,  1941,
    1941,  1950,  1950,  1961,  1962,  1965,  1966,  1966,  1974,  1974,
    1977,  1977,  1980,  1981,  1986,  1989,  1998,  2025,  2025,  2028,
    2033,  2039,  2047,  2054,  2063,  2070,  2073,  2078,  2081,  2086,
    2093,  2086,  2106,  2106,  2122,  2122,  2136,  2137,  2138,  2139,
    2140,  2141,  2144,  2145,  2146,  2149,  2155,  2161,  2168,  2171,
    2176,  2179,  2184,  2187,  2190,  2195,  2201,  2195,  2207,  2207,
    2210,  2210,  2213,  2214,  2217,  2227,  2227,  2230,  2243,  2256,
    2269,  2282,  2291,  2300,  2309,  2324,  2341,  2350,  2359,  2368,
    2377,  2386,  2399,  2414,  2420,  2426,  2432,  2438,  2446,  2454,
    2462,  2470,  2481,  2481,  2481,  2481,  2481,  2481,  2482,  2483,
    2484,  2487,  2487,  2497,  2497,  2507,  2509,  2507,  2535,  2540,
    2542,  2535,  2553,  2553,  2567,  2567,  2581,  2592,  2581,  2599,
    2599,  2612,  2615,  2619,  2623,  2630,  2633,  2636,  2641,  2645,
    2649,  2652,  2653,  2656,  2656,  2667,  2670,  2671,  2674,  2680,
    2674,  2693,  2694,  2697,  2703,  2697,  2712,  2713,  2716,  2721,
    2728,  2731,  2736,  2741,  2751,  2759,  2762,  2767,  2771,  2777,
    2778,  2781,  2782,  2785,  2786,  2789,  2794,  2795,  2796,  2799,
    2799,  2800,  2806,  2810,  2806,  2816,  2816,  2825,  2825,  2834,
    2834,  2846,  2848,  2846,  2865,  2865,  2872,  2875,  2875,  2878,
    2881,  2891,  2894,  2904,  2918,  2925,  2937,  2942,  2942,  2953,
    2957,  2961,  2964,  2969,  2972,  2975,  2980,  2985,  2990,  2995,
    3000,  3005,  3010,  3015,  3021,  3026,  3033,  3038,  3043,  3048,
    3053,  3058,  3063,  3068,  3073,  3078,  3083,  3088,  3093,  3098,
    3103,  3108,  3113,  3118,  3123,  3128,  3133,  3138,  3143,  3148,
    3153,  3158,  3164,  3170,  3178,  3181,  3187,  3188,  3189,  3194
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_STRING", "TOK_ID",
  "TOK_CONSTVAL", "TOK_REALVAL", "TOK_PRIMITIVE", "TOK_SVA_LABEL",
  "TOK_SPECIFY_OPER", "TOK_MSG_TASKS", "TOK_BASE", "TOK_BASED_CONSTVAL",
  "TOK_UNBASED_UNSIZED_CONSTVAL", "TOK_USER_TYPE", "TOK_PKG_USER_TYPE",
  "TOK_ASSERT", "TOK_ASSUME", "TOK_RESTRICT", "TOK_COVER", "TOK_FINAL",
  "ATTR_BEGIN", "ATTR_END", "DEFATTR_BEGIN", "DEFATTR_END", "TOK_MODULE",
  "TOK_ENDMODULE", "TOK_PARAMETER", "TOK_LOCALPARAM", "TOK_DEFPARAM",
  "TOK_PACKAGE", "TOK_ENDPACKAGE", "TOK_PACKAGESEP", "TOK_INTERFACE",
  "TOK_ENDINTERFACE", "TOK_MODPORT", "TOK_VAR", "TOK_WILDCARD_CONNECT",
  "TOK_INPUT", "TOK_OUTPUT", "TOK_INOUT", "TOK_WIRE", "TOK_WAND",
  "TOK_WOR", "TOK_REG", "TOK_LOGIC", "TOK_INTEGER", "TOK_SIGNED",
  "TOK_ASSIGN", "TOK_PLUS_ASSIGN", "TOK_ALWAYS", "TOK_INITIAL",
  "TOK_ALWAYS_FF", "TOK_ALWAYS_COMB", "TOK_ALWAYS_LATCH", "TOK_BEGIN",
  "TOK_END", "TOK_IF", "TOK_ELSE", "TOK_FOR", "TOK_WHILE", "TOK_REPEAT",
  "TOK_DPI_FUNCTION", "TOK_POSEDGE", "TOK_NEGEDGE", "TOK_OR",
  "TOK_AUTOMATIC", "TOK_CASE", "TOK_CASEX", "TOK_CASEZ", "TOK_ENDCASE",
  "TOK_DEFAULT", "TOK_FUNCTION", "TOK_ENDFUNCTION", "TOK_TASK",
  "TOK_ENDTASK", "TOK_SPECIFY", "TOK_IGNORED_SPECIFY", "TOK_ENDSPECIFY",
  "TOK_SPECPARAM", "TOK_SPECIFY_AND", "TOK_IGNORED_SPECIFY_AND",
  "TOK_GENERATE", "TOK_ENDGENERATE", "TOK_GENVAR", "TOK_REAL",
  "TOK_SYNOPSYS_FULL_CASE", "TOK_SYNOPSYS_PARALLEL_CASE", "TOK_SUPPLY0",
  "TOK_SUPPLY1", "TOK_TO_SIGNED", "TOK_TO_UNSIGNED", "TOK_POS_INDEXED",
  "TOK_NEG_INDEXED", "TOK_PROPERTY", "TOK_ENUM", "TOK_TYPEDEF", "TOK_RAND",
  "TOK_CONST", "TOK_CHECKER", "TOK_ENDCHECKER", "TOK_EVENTUALLY",
  "TOK_INCREMENT", "TOK_DECREMENT", "TOK_UNIQUE", "TOK_UNIQUE0",
  "TOK_PRIORITY", "TOK_STRUCT", "TOK_PACKED", "TOK_UNSIGNED", "TOK_INT",
  "TOK_BYTE", "TOK_SHORTINT", "TOK_LONGINT", "TOK_UNION", "TOK_OR_ASSIGN",
  "TOK_XOR_ASSIGN", "TOK_AND_ASSIGN", "TOK_SUB_ASSIGN", "OP_LOR",
  "OP_LAND", "'|'", "OP_NOR", "'^'", "OP_XNOR", "'&'", "OP_NAND", "OP_EQ",
  "OP_NE", "OP_EQX", "OP_NEX", "'<'", "OP_LE", "OP_GE", "'>'", "OP_SHL",
  "OP_SHR", "OP_SSHL", "OP_SSHR", "'+'", "'-'", "'*'", "'/'", "'%'",
  "OP_POW", "OP_CAST", "UNARY_OPS", "FAKE_THEN", "','", "'='", "'.'",
  "'('", "')'", "';'", "'#'", "':'", "'['", "']'", "'{'", "'}'", "'@'",
  "'?'", "'~'", "'!'", "$accept", "input", "$@1", "design", "attr", "$@2",
  "attr_opt", "defattr", "$@3", "$@4", "opt_attr_list", "attr_list",
  "attr_assign", "hierarchical_id", "hierarchical_type_id", "module",
  "$@5", "$@6", "module_para_opt", "$@7", "$@8", "module_para_list",
  "single_module_para", "$@9", "$@10", "module_args_opt", "module_args",
  "optional_comma", "module_arg_opt_assignment", "module_arg", "$@11",
  "$@12", "$@13", "$@14", "package", "$@15", "$@16", "package_body",
  "package_body_stmt", "interface", "$@17", "$@18", "interface_body",
  "interface_body_stmt", "mintypmax_expr", "non_opt_delay", "delay",
  "io_wire_type", "$@19", "non_io_wire_type", "$@20", "wire_type",
  "wire_type_token_io", "wire_type_signedness", "wire_type_const_rand",
  "opt_wire_type_token", "wire_type_token", "logic_type",
  "integer_atom_type", "non_opt_range", "non_opt_multirange", "range",
  "range_or_multirange", "module_body", "module_body_stmt", "checker_decl",
  "$@21", "task_func_decl", "$@22", "$@23", "$@24", "$@25", "$@26",
  "func_return_type", "opt_type_vec", "opt_signedness_default_signed",
  "opt_signedness_default_unsigned", "dpi_function_arg",
  "opt_dpi_function_args", "dpi_function_args", "opt_automatic",
  "task_func_args_opt", "$@27", "$@28", "task_func_args", "task_func_port",
  "$@29", "$@30", "task_func_body", "specify_block", "specify_item_list",
  "specify_item", "specify_opt_triple", "specify_if", "specify_condition",
  "specify_target", "specify_edge", "specify_rise_fall", "specify_triple",
  "ignored_specify_block", "ignored_specify_item_opt",
  "ignored_specify_item", "specparam_declaration", "specparam_range",
  "list_of_specparam_assignments", "specparam_assignment",
  "ignspec_opt_cond", "path_declaration", "simple_path_declaration",
  "path_delay_value", "list_of_path_delay_extra_expressions",
  "specify_edge_identifier", "parallel_path_description",
  "full_path_description", "list_of_path_inputs", "more_path_inputs",
  "list_of_path_outputs", "opt_polarity_operator",
  "specify_input_terminal_descriptor",
  "specify_output_terminal_descriptor", "system_timing_declaration",
  "system_timing_arg", "system_timing_args", "ignspec_constant_expression",
  "ignspec_expr", "ignspec_id", "$@31", "param_signed", "param_integer",
  "param_real", "param_range", "param_integer_type", "param_range_type",
  "param_implicit_type", "param_type", "param_decl", "$@32",
  "localparam_decl", "$@33", "param_decl_list", "single_param_decl",
  "single_param_decl_ident", "defparam_decl", "defparam_decl_list",
  "single_defparam_decl", "enum_type", "$@34", "enum_base_type",
  "type_atom", "type_vec", "type_signing", "enum_name_list",
  "enum_name_decl", "opt_enum_init", "enum_var_list", "enum_var",
  "enum_decl", "struct_decl", "struct_type", "$@35", "struct_union",
  "struct_body", "opt_packed", "opt_signed_struct", "struct_member_list",
  "struct_member", "member_name_list", "member_name", "$@36",
  "struct_member_type", "$@37", "member_type_token", "$@38", "member_type",
  "struct_var_list", "struct_var", "wire_decl", "$@39", "$@40", "$@41",
  "$@42", "opt_supply_wires", "wire_name_list", "wire_name_and_opt_assign",
  "wire_name", "assign_stmt", "assign_expr_list", "assign_expr",
  "type_name", "typedef_decl", "non_wire_data_type", "cell_stmt", "$@43",
  "$@44", "tok_prim_wrapper", "cell_list", "single_cell", "$@45", "$@46",
  "prim_list", "single_prim", "$@47", "cell_parameter_list_opt",
  "cell_parameter_list", "cell_parameter", "cell_port_list",
  "cell_port_list_rules", "cell_port", "always_comb_or_latch",
  "always_or_always_ff", "always_stmt", "$@48", "$@49", "$@50", "$@51",
  "always_cond", "always_events", "always_event", "opt_label",
  "opt_sva_label", "opt_property", "modport_stmt", "$@52", "$@53",
  "modport_args_opt", "modport_args", "modport_arg", "modport_member",
  "modport_type_token", "assert", "assert_property",
  "simple_behavioral_stmt", "behavioral_stmt", "$@54", "$@55", "$@56",
  "$@57", "$@58", "$@59", "$@60", "$@61", "$@62", "$@63", "$@64", "$@65",
  "case_attr", "case_type", "opt_synopsys_attr", "behavioral_stmt_list",
  "optional_else", "$@66", "case_body", "case_item", "$@67", "$@68",
  "gen_case_body", "gen_case_item", "$@69", "$@70", "case_select",
  "case_expr_list", "rvalue", "lvalue", "lvalue_concat_list",
  "opt_arg_list", "arg_list", "arg_list2", "single_arg", "module_gen_body",
  "gen_stmt_or_module_body_stmt", "gen_stmt", "$@71", "$@72", "$@73",
  "$@74", "$@75", "gen_block", "$@76", "$@77", "gen_stmt_block", "$@78",
  "opt_gen_else", "expr", "basic_expr", "$@79", "concat_list",
  "integral_number", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   124,   376,    94,   377,    38,   378,   379,   380,   381,
     382,    60,   383,   384,    62,   385,   386,   387,   388,    43,
      45,    42,    47,    37,   389,   390,   391,   392,    44,    61,
      46,    40,    41,    59,    35,    58,    91,    93,   123,   125,
      64,    63,   126,    33
};
#endif

#define YYPACT_NINF (-980)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-549)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -980,   115,   234,  -980,  -980,  -980,    59,  -980,   713,  -980,
     234,   234,   234,   234,   234,   234,   234,   234,   132,   164,
    -980,  -980,  -980,    35,   315,  -980,  -980,  -980,   309,  -980,
    -980,  -980,  -980,   205,   151,   151,   251,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,    98,  -980,    52,
    -980,   313,  2045,  -980,   309,   186,  -980,   712,   266,  -980,
    -980,   233,   415,   520,   520,   423,    71,  -980,   331,   430,
     132,   413,   132,   450,  2045,   467,   323,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,   328,    66,    66,  -980,   498,
    -980,   503,  -980,   377,  -980,  -980,   414,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  2045,  2045,  -980,  -980,   109,
    -980,   170,  1400,  -980,    35,  -980,  -980,  -980,   357,   468,
    -980,  -980,  -980,  -980,  -980,   561,  -980,   222,  -980,  -980,
     235,  -980,   419,  -980,  -980,  -980,  -980,  -980,  -980,    35,
     281,  -980,  -980,  -980,  -980,   581,  -980,   281,   581,  -980,
    -980,   591,   604,  -980,  -980,   282,   612,   296,  -980,   596,
    -980,  -980,  -980,  -980,  -980,   455,   470,   638,  -980,  -980,
    -980,    35,   622,  -980,   489,   499,   504,   510,  2045,  2045,
    2045,  2045,  2045,  2045,  2045,  2045,    -4,   223,   506,  2045,
    2045,  2045,  -980,    35,    35,  -980,  -980,  2045,  2045,  2045,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,   512,  -980,    35,
    -980,   530,  -980,  -980,  -980,   525,  -980,  -980,  -980,  -980,
    -980,  -980,  -980,   323,  -980,  -980,  -980,  -980,   201,  -980,
     544,    35,   283,   552,   559,   709,   573,  -980,  -980,  -980,
    -980,  -980,  -980,    35,   574,  -980,  -980,    88,   576,   597,
      23,  -980,  -980,  -980,  2045,  2045,  2045,  2045,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  -980,   476,  2045,  2045,  2045,
    -980,  -980,  -980,   225,   585,  -980,  -980,   590,   594,   616,
    2045,  2045,  2045,  2045,  2045,  2045,  2045,  2045,  2045,  2045,
    2045,  2045,  2045,  2045,  2045,  2045,  2045,  2045,  2045,  2045,
    2045,  2045,  2045,  2045,  2045,  2045,  2045,  2045,  -980,  -980,
     600,  -980,   757,   670,   470,   581,  -980,  2045,  -980,  -980,
    -980,   770,   623,  -980,   775,   574,  -980,   634,   635,   100,
     785,   640,  -980,   587,   644,  -980,  -980,  2045,  -980,   638,
    -980,   642,   643,   646,   647,  -980,   657,   649,  -980,   656,
     650,  2045,  -980,  -980,  -980,  2598,  2623,  1358,  1358,  2644,
    2644,  1800,  1800,  1213,  1213,  1213,  1213,   962,   962,   962,
     962,   458,   458,   458,   458,   448,   448,   493,   493,   493,
     648,   664,   662,  -980,  -980,  -980,   304,  -980,  -980,    66,
      66,  -980,  -980,  -980,   665,  -980,  -980,   118,   798,  -980,
     -15,  -980,   559,   815,   673,  -980,   823,  -980,   652,   680,
    -980,  -980,   681,   825,   689,  -980,   636,  -980,    35,   114,
     688,   349,  1613,  -980,  -980,  -980,  -980,  -980,  2045,   682,
     132,   694,  -980,  -980,  -980,  -980,  2045,    35,   757,  -980,
    -980,    35,   266,  -980,   691,   676,  -980,  -980,  -980,  -980,
    -980,   770,  -980,   696,  -980,  -980,   587,   699,  -980,   840,
     260,  -980,  -980,   100,   700,  2045,  -980,  -980,  -980,  -980,
    -980,  -980,   315,   847,  -980,  -980,    35,  -980,   852,   704,
    1038,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,
     707,  -980,    99,  -980,  2045,   708,  -980,  -980,  -980,  -980,
    -980,  2346,   857,  -980,  -980,  -980,   559,   392,    35,    81,
    -980,    35,  -980,   710,  -980,   120,   584,  -980,   524,  -980,
    -980,  -980,  -980,   630,  -980,   711,  -980,   601,   520,   520,
    -980,  -980,  -980,   681,   712,  -980,   132,   305,  -980,  -980,
    -980,    70,  -980,  -980,  -980,  -980,  -980,   858,   862,    35,
    -980,  -980,  -980,  -980,  -980,  -980,   691,  -980,   716,   717,
    -980,  -980,  -980,   107,   269,    75,  -980,   865,  -980,  2628,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,
     866,  -980,  -980,   867,  -980,  -980,  -980,  -980,  -980,   641,
    -980,   721,  -980,  -980,  -980,   720,  -980,  -980,  -980,   724,
    -980,  -980,  -980,  -980,  -980,  2045,  -980,  -980,   726,   727,
     729,   731,  -980,  -980,  -980,  -980,  2045,    91,  -980,   579,
    -980,   112,   112,   112,    58,  -980,   732,   581,   581,  -980,
     222,  -980,   681,   736,    35,  -980,   735,   351,  -980,   738,
     524,  -980,  -980,  -980,   524,   728,   739,  -980,   691,  2045,
    -980,   740,   741,   819,   107,   742,  -980,   748,  -980,   316,
    -980,  -980,   749,  -980,   750,  -980,   751,  2045,   897,   358,
    -980,   759,  2454,   753,  -980,  -980,  -980,   704,  -980,   376,
    -980,  -980,   385,  -980,   822,   824,   826,   830,  2045,  -980,
     840,  -980,   348,   771,   739,   691,  2045,  -980,  2045,  2045,
     769,   783,   739,   704,  -980,  -980,   704,   704,   704,   704,
     704,   704,  -980,  -980,   784,   786,   788,  -980,   789,  2045,
    -980,  -980,  -980,  -980,  2045,  -980,   104,  -980,    70,  -980,
    2045,  -980,  -980,  -980,   704,  -980,    62,  -980,  2045,   781,
    -980,   790,  -980,   645,  2045,  -980,  -980,   645,    35,  2045,
    -980,  -980,   277,   787,   795,  -980,  1068,   791,  -980,   391,
     897,  -980,  2045,  -980,  2279,  -980,  -980,  -980,  -980,  -980,
     807,  -980,   866,  -980,   867,  -980,   792,   797,   812,   813,
     793,  -980,  2045,  -980,  2045,   816,  -980,   814,  -980,   818,
     827,  -980,  2045,   829,  2045,  2045,  2045,  2045,  2045,  2045,
    2045,  1458,  1503,  1549,  1673,   828,  -980,  -980,  -980,  -980,
    -980,   820,  -980,  -980,   973,   831,  -980,  -980,   397,   400,
     840,   833,  -980,   832,   524,   694,  -980,  -980,  -980,    70,
     835,  -980,  -980,  2045,   834,  2045,  -980,   837,   838,  -980,
    -980,   897,   851,   290,  -980,  2090,  2090,   897,   897,  -980,
      26,  -980,  2045,  -980,  -980,  -980,  -980,  -980,   846,   974,
     974,  -980,  -980,  1718,  1763,  1857,  2045,  -980,   422,   843,
    -980,  -980,  -980,   849,  -980,  -980,  -980,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  2045,   848,  2045,   853,  2045,
     859,   860,   863,  -980,   131,   864,  -980,  -980,  1000,  -980,
    -980,   869,  -980,   870,  -980,  -980,  2045,  2045,   871,   102,
    -980,  -980,  -980,   872,  2487,   963,  2045,   941,  -980,  1013,
    -980,  2045,   885,   334,   893,  -980,  -980,   897,   345,   880,
    2045,  -980,   882,  -980,  -980,  -980,  1068,  1068,   879,   876,
    2379,  1902,    35,   401,  -980,  -980,   407,  -980,   883,  2045,
     884,  2045,   886,  2045,   887,   890,  -980,  2045,  -980,  2045,
     500,   524,  2045,   524,   524,   892,   894,   896,   898,   900,
     901,  -980,   902,  -980,  -980,  -980,  -980,   840,   903,  2045,
    -980,  -980,  -980,  1251,  1251,  -980,  -980,   691,  -980,   977,
    2562,  -980,  2045,   889,  2142,   895,   911,   919,  -980,   897,
    -980,   897,  -980,   924,   882,   200,  2045,  -980,  -980,  -980,
    -980,  -980,  -980,  1055,   424,  -980,  -980,  -980,   909,   974,
    -980,   974,  -980,  -980,   912,   908,   915,   910,   916,   917,
     927,   999,   930,  -980,   691,  -980,  -980,  -980,  -980,  -980,
     931,  -980,   932,  -980,   933,  -980,  -980,   632,  -980,  -980,
    -980,  -980,  -980,  -980,   963,  -980,  -980,   940,  -980,   645,
    2045,   942,  -980,  2045,   944,   957,   434,  -980,  -980,  -980,
     897,   958,  2045,   882,   960,  1902,  -980,   965,  -980,  -980,
    -980,  1296,   966,   935,  -980,   964,  -980,   968,  -980,   969,
    -980,  -980,  -980,  -980,  1317,  -980,  -980,  1061,   970,  -980,
    -980,  -980,  -980,  -980,  1054,  -980,  -980,  2045,    64,   976,
    -980,   897,   897,   897,  -980,   978,  -980,   979,  -980,  1948,
    -980,  -980,   981,  -980,  1131,  -980,  -980,  -980,  -980,  -980,
    -980,  -980,    49,  -980,   224,  -980,  -980,  -980,  -980,  -980,
    -980,  1317,   984,   941,  2045,  2045,  2045,  2187,   259,   194,
    -980,  -980,  2045,  -980,   985,   987,  -980,   989,  -980,   963,
    2045,  -980,   524,   991,  -980,   963,   993,   994,   995,   237,
    2045,   992,  -980,  1005,  2045,  1009,  2045,  1011,   707,  -980,
    -980,  1999,  -980,  -980,  -980,  -980,   524,  -980,  2045,  -980,
    -980,  -980,  1020,   406,  -980,  2045,   996,  2045,  1017,  2045,
    -980,  1018,   524,  -980,  1023,  2045,  2045,  1021,  1026,  1027,
    1028,  1029,  -980,  -980,  2045,  1030,   435,  1032,  2045,  -980,
    1031,  -980,  1033,  -980,  1019,  2045,  -980,  2045,  -980,  -980,
    -980,  -980,   461,   707,  2045,  -980,  1025,  2045,  1040,  2045,
     462,  2045,  -980,  1048,  2045,  1049,  2045,  1050,  2045,  1051,
    2045,  1052,  2045,  1053,  -980
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,    13,     1,    17,    72,    97,     3,     0,    16,
      13,    13,    13,    13,    13,    13,    13,    13,    21,     0,
     318,   341,   342,   138,   110,   389,   390,   339,     0,    32,
     305,   307,    64,     0,   197,   197,    14,     5,     4,    10,
      11,     6,     7,     8,     9,    26,    18,    20,    22,    24,
      73,   322,     0,   137,     0,   109,   108,     0,   345,   385,
     386,     0,     0,   292,   292,     0,     0,   196,   179,     0,
      21,     0,     0,     0,     0,     0,    38,   324,   325,   126,
     127,   130,   128,   129,   323,     0,   328,   328,   596,   646,
     595,     0,   647,     0,    13,    13,     0,    13,    13,    13,
      13,    13,    13,    13,    13,     0,     0,    13,    13,   138,
     591,     0,   589,   594,   138,   107,    29,    30,   120,   116,
     115,   114,   118,   124,   123,     0,   113,   106,   122,   125,
     348,   340,     0,   388,    33,   290,   294,   291,   304,   138,
     292,   301,   300,   302,   303,     0,   293,   292,     0,    65,
     166,     0,     0,   180,   181,   182,     0,   185,   172,     0,
      19,    23,    27,    25,    28,     0,    48,     0,   326,   327,
     320,   138,     0,   648,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   644,     0,     0,
       0,     0,   597,   137,   554,   553,   593,     0,     0,     0,
     134,    13,    13,    13,    13,    13,    13,    13,    13,    13,
      13,    13,    13,    13,    13,    13,    13,    13,    13,    13,
      13,    13,    13,    13,    13,    13,    13,     0,    13,   140,
     139,     0,   119,   121,   117,     0,   104,   105,    98,   346,
     347,   344,   356,    38,   295,   299,   296,   313,     0,   309,
     312,   297,     0,     0,   191,     0,     0,   183,   184,   178,
     174,   186,   187,   176,   199,    15,    35,    13,     0,   333,
       0,   329,   321,   649,     0,     0,     0,     0,   614,   615,
     616,   617,   612,   613,   636,   637,   601,     0,     0,     0,
     603,   605,   640,     0,     0,   135,   136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   387,    31,
     356,   349,     0,     0,    48,     0,   306,     0,   298,   308,
      68,   195,     0,   168,     0,   199,   177,   200,     0,    13,
      56,     0,    47,    97,    53,    50,    76,     0,   331,     0,
     319,     0,     0,     0,     0,   592,     0,   644,   645,     0,
     134,   562,   132,   133,   131,   639,   638,   608,   609,   610,
     611,   606,   607,   624,   625,   626,   627,   622,   623,   628,
     629,   618,   619,   620,   621,   630,   631,   632,   633,   634,
     635,     0,     0,   343,   350,   354,     0,   352,   359,   328,
     328,   360,   357,   358,     0,   310,   311,    13,   189,   194,
       0,   167,   191,     0,     0,   198,    13,   210,     0,    36,
      39,    46,    55,     0,     0,    99,     0,   100,   138,    13,
       0,    13,   332,   330,   641,   599,   600,   642,     0,     0,
       0,    53,   561,   563,   565,   643,     0,   138,     0,   351,
     362,   138,   345,   145,   449,     0,    67,    71,    70,    69,
     188,   193,   190,     0,   170,   210,    97,    53,   203,     0,
      13,    42,    44,    13,     0,     0,    57,    59,    63,   101,
     102,   103,   110,     0,    51,    49,   138,    74,     0,    94,
      97,    75,    77,    78,    80,    81,    83,    79,    82,    84,
       0,   604,   138,   552,    52,     0,   590,   355,   353,   363,
     361,    13,     0,    66,   192,   169,   191,    13,   138,    13,
     201,   138,   208,     0,   173,     0,    97,   492,    13,   495,
     496,   494,   497,     0,   493,     0,   209,     0,   292,   292,
      40,    37,    54,    55,   112,    61,     0,     0,   315,   455,
      93,     0,   427,   434,   428,   425,   426,     0,     0,   138,
     432,   429,   602,   564,   598,   579,   449,   581,     0,     0,
     525,   526,   527,   213,   250,     0,   568,     0,   144,    97,
     160,   141,   162,   146,   147,   163,   152,   148,   149,   151,
       0,   156,   157,     0,   153,   154,   150,   155,   158,     0,
     161,     0,   142,   143,   448,     0,   175,   205,   204,     0,
     380,   450,    87,    88,    89,     0,   503,   505,     0,     0,
       0,     0,   524,   522,   523,   500,     0,   138,   555,     0,
     498,   454,   454,   454,   454,   499,     0,     0,     0,    60,
     106,   111,    55,     0,   138,   314,     0,     0,   382,     0,
      13,   370,   372,   367,    13,   441,   560,    34,   449,     0,
     572,     0,     0,     0,   213,     0,   288,     0,   237,   250,
     239,   240,     0,   241,     0,   242,     0,     0,     0,     0,
     246,     0,    13,     0,   391,   395,   396,    94,   336,     0,
     334,   366,     0,   364,     0,     0,     0,     0,     0,   171,
       0,   202,     0,    85,   560,   449,     0,   508,     0,     0,
       0,   557,   560,    94,   484,   485,    94,    94,    94,    94,
      94,    94,   453,   452,     0,     0,     0,   473,     0,     0,
      43,    45,    96,    62,     0,   316,     0,   456,     0,   381,
       0,   435,   374,   374,    94,   433,     0,   430,   562,     0,
     582,     0,    13,   228,     0,   211,   212,   228,   138,     0,
     236,   238,     0,     0,     0,   251,     0,     0,   285,     0,
       0,   243,     0,   159,    97,   570,   566,   569,   567,   164,
     409,   393,     0,   337,     0,   338,     0,     0,     0,     0,
       0,   206,     0,    90,     0,     0,   506,     0,    13,     0,
       0,   556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   317,   464,   465,   466,
     458,    53,   460,   463,     0,     0,   383,   384,     0,     0,
       0,     0,   440,     0,    13,    53,   580,   568,   575,     0,
       0,   226,   227,     0,     0,     0,   289,     0,   286,   259,
     260,     0,     0,   275,   276,     0,     0,     0,     0,   282,
       0,   281,     0,   244,   247,   248,   571,   145,     0,     0,
     406,   335,   365,     0,     0,     0,     0,   577,     0,     0,
     504,   532,   516,     0,   512,   514,   558,   502,   489,   488,
     487,   491,   490,   486,   483,     0,     0,     0,     0,     0,
       0,     0,     0,   519,    52,     0,   462,   457,     0,   371,
     373,   368,   376,   378,   438,   439,     0,     0,     0,     0,
     442,   447,   431,     0,    13,   584,     0,   221,   218,     0,
     249,     0,     0,   275,     0,   273,   274,     0,   275,   267,
       0,   252,   255,   253,   279,   280,     0,     0,     0,     0,
      13,   412,   399,     0,   397,   405,     0,   403,     0,     0,
       0,     0,     0,     0,     0,     0,   542,     0,    91,     0,
      13,    13,     0,    13,    13,     0,     0,     0,     0,     0,
       0,   472,     0,   530,   461,   459,   375,     0,     0,     0,
     445,   446,   437,     0,     0,   436,   559,   449,   586,   588,
      13,   573,     0,     0,     0,     0,     0,     0,   267,     0,
     269,     0,   268,     0,     0,   286,     0,   256,   283,   284,
     278,   245,   165,     0,     0,   410,   413,   401,     0,     0,
     392,   406,   394,    13,     0,     0,     0,     0,     0,     0,
       0,   543,     0,    86,   449,   531,   517,   509,   513,   515,
       0,   467,     0,   468,     0,   474,   471,   537,   377,   369,
     379,   443,   444,   583,   584,   576,   585,     0,   220,   228,
       0,     0,   222,     0,     0,     0,     0,   271,   277,   270,
       0,     0,     0,   257,     0,   412,   408,     0,    13,   398,
     404,   419,     0,   416,   417,     0,   476,     0,   477,     0,
     481,   480,   578,   541,     0,    92,   507,   535,     0,   469,
     470,   475,   528,   529,   538,   587,    13,     0,     0,     0,
     287,     0,     0,     0,   264,     0,   254,     0,   258,     0,
     411,    13,     0,   424,     0,   420,   407,    13,   478,   479,
     482,   549,   547,   544,     0,   550,   533,   518,    13,   520,
     536,     0,     0,   221,     0,     0,     0,     0,   275,   275,
     272,   261,     0,   414,     0,     0,   400,   423,   418,   584,
       0,   546,    13,     0,   539,   584,     0,     0,     0,     0,
       0,     0,   229,   234,     0,     0,     0,     0,   287,   415,
     402,     0,   545,   551,   534,   510,    13,   574,     0,   225,
     224,   223,     0,   234,   214,     0,     0,     0,     0,     0,
     422,     0,    13,   540,   217,     0,     0,     0,     0,     0,
       0,     0,   421,   511,     0,     0,     0,     0,     0,   266,
       0,   263,     0,   216,     0,     0,   230,     0,   235,   265,
     262,   215,     0,   235,     0,   231,     0,     0,     0,     0,
       0,     0,   232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   233
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -980,  -980,  -980,   794,    86,  -980,  -980,    47,  -980,  -980,
    1105,  -980,  1129,     1,   -53,  -980,  -980,  -980,   959,  -980,
    -980,  -980,   723,  -980,  -980,   875,  -980,  -365,  -447,   764,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -732,  -361,   184,  -980,  -980,  1198,
    -980,  -266,  -980,   560,   719,  -980,   659,   602,     9,   -33,
    -106,   -18,  -426,   337,  -514,  -980,  -980,  -513,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,   744,  -328,  -980,
    1181,   873,  -980,  -980,  -980,   692,  -980,  -980,   745,  -980,
     543,  -980,  -980,  -980,    60,  -980,  -733,  -980,  -258,  -980,
    -980,   545,  -467,  -980,   534,   445,  -980,  -980,  -980,   362,
    -935,  -980,  -980,  -980,   368,  -980,   101,  -853,  -792,  -745,
    -980,  -225,  -980,   363,  -689,  -529,  -980,    25,  -980,  -980,
    -980,  -980,  -980,  -980,   -58,    -1,  -980,    15,  -980,  1086,
    -284,  -980,   796,  -980,   582,  1232,  -980,  -980,   -11,    17,
     -49,  -980,   881,  -980,  -980,   447,  -980,  -980,  1235,  -980,
     913,   780,  -980,  -980,  -980,   918,  -980,   800,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,   449,  -439,  -980,  -980,  -980,
    -980,   492,  -980,   250,  -440,   808,  -980,   502,  1197,    31,
    -980,  -980,  -980,  -980,  -980,  -980,  -807,  -980,  -980,  -980,
     211,  -980,  -980,  -980,   158,  -979,  -980,   113,  -980,  -980,
     877,  -980,  -980,  -980,  -980,  -980,  -980,  -270,  -552,  -484,
      57,  -980,  -980,  -980,  -980,  -980,   347,   425,  -980,  -980,
    -980,  -741,  -520,  -980,  -980,  -980,  -980,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  -980,   718,  -980,  -980,  -980,
    -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,  -980,   105,
    -980,  -427,  -509,   451,  -522,   509,  -980,   754,   457,   261,
    -501,  -980,  -980,  -980,  -980,  -980,  -485,  -980,  -980,  -964,
    -980,  -980,   -52,   972,  -980,   456,   -59
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     7,   536,     9,    36,   537,    18,    71,
      46,    47,    48,   109,   138,    11,    62,   243,   166,   349,
     484,   429,   430,   548,   549,   268,   354,   440,   486,   355,
     432,   433,   553,   652,    12,    65,   253,   417,   466,    13,
      19,    76,   441,   501,   712,   538,   561,   435,   436,   437,
      24,   569,   492,   238,    57,   650,   127,   128,    84,    53,
     229,   230,   231,   521,   785,   592,   877,    14,   254,   422,
     526,   264,   345,   156,   157,   259,   263,   419,   342,   420,
      68,   348,   426,   619,   477,   478,   710,   479,   480,   594,
     673,   674,  1235,   675,  1013,  1081,   853,  1191,  1192,   595,
     679,   680,   596,   688,   689,   690,   682,   683,   684,   951,
    1027,   861,   773,   774,   862,   948,  1086,   949,   863,  1087,
     685,   869,   870,   777,   871,  1088,   768,   139,   140,   141,
     245,   142,   143,   144,   145,   539,    63,   540,    64,   248,
     249,   250,   599,   557,   558,   600,    51,    85,   146,   147,
     170,   270,   271,   358,   699,   700,   601,   602,   603,    58,
      27,   131,   132,   241,   330,   331,   406,   407,   457,   332,
     333,   412,   462,   413,   702,   703,   541,   754,   998,   752,
     753,   838,   921,   922,   923,   605,   657,   658,    61,   542,
      28,   607,   790,   880,   697,   963,   965,  1038,  1097,   966,
     967,   968,   879,  1034,  1035,  1102,  1103,  1104,   570,   571,
     608,   665,   844,   664,   660,   757,   929,   930,   523,   543,
     734,   509,   656,   835,   747,   831,   832,   833,   834,   544,
     610,   545,   546,   722,   714,   715,   891,   808,  1118,  1222,
     983,   984,   981,  1117,   993,   547,   611,  1067,   980,  1157,
    1182,  1124,  1160,  1161,  1206,  1051,  1113,  1114,  1179,  1153,
    1154,   110,   639,   720,   759,   451,   452,   453,   692,   786,
     787,   762,  1077,   935,   976,   666,  1008,   668,   847,  1009,
    1010,  1075,  1193,   112,   294,   188,   113
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     111,    15,   505,   194,   126,    54,   148,   591,   593,    15,
      15,    15,    15,    15,    15,    15,    15,    16,   640,    49,
     612,   850,   163,   513,   667,    16,    16,    16,    16,    16,
      16,    16,    16,    17,   855,   519,   613,   609,   171,   532,
      86,    17,    17,    17,    17,    17,    17,    17,    17,    10,
     196,   415,   659,   186,   187,   686,   691,    10,    10,    10,
      10,    10,    10,    10,    10,   431,   129,   893,    87,   943,
     888,    49,   964,    49,    45,   150,   193,   155,   732,   676,
     857,   193,   604,   841,    73,  -207,   515,   438,     8,  1091,
    1018,   195,   350,   875,   473,  1022,     8,     8,     8,     8,
       8,     8,     8,     8,   247,   620,   649,   956,   827,   638,
    1125,   671,   530,   168,    89,     3,   760,   681,   350,  1142,
      91,   244,    92,    73,   622,   623,   624,   129,   129,   653,
     -13,    73,   732,   471,   638,   827,    45,   472,   560,   293,
     751,    73,   828,   829,   755,   297,   298,   299,   286,   464,
     686,   287,   733,   272,    20,  1020,  1164,  1165,  1138,   691,
     295,   296,  1175,   806,   672,   246,    21,  1003,    50,   828,
     829,   359,   251,    22,   957,   169,   952,   952,   958,   593,
     175,   176,   360,   178,   179,   180,   181,   182,   183,   184,
     185,    52,   805,   189,   190,   192,   296,  -548,   615,   431,
     813,    74,    75,   842,  -548,   743,   733,   788,   609,    66,
     528,   737,   681,   843,     6,  1202,   286,    67,   338,  1166,
     151,  1207,   361,   362,   363,   364,   152,   365,   636,  1089,
     346,   687,  1099,   -52,   -12,   366,   367,   367,   351,   659,
     352,    75,  -501,   864,  -501,  1052,    72,   191,   -41,    75,
    1004,   691,   -41,   604,  1005,   191,   830,     4,  -219,    75,
     -13,  1024,   197,   198,   351,   191,   -52,     5,   533,   236,
     801,   625,    70,   676,   401,   402,  -451,  -451,  -451,  -451,
     408,   676,   239,     4,   115,   416,  1196,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,    59,   327,  1195,  1197,   197,   198,   454,
     676,   638,   409,    60,   932,   199,   677,   200,   135,   257,
       6,   237,   864,   945,   946,   534,   560,  1093,   954,   955,
     859,   860,   856,   261,   240,  1135,  1127,   678,   585,   335,
     410,  1194,   286,   353,   336,  1092,     6,    77,    78,    79,
     460,   461,   560,   740,   741,   560,   560,   560,   560,   560,
     560,   288,  1180,   677,   130,   153,   154,    79,   496,  1181,
     199,   289,   370,   497,   498,  1162,   133,  1169,  1170,  1211,
     137,   258,   448,   560,   770,   585,   510,   499,   945,   946,
     533,   232,   123,    79,   516,   262,   194,  1133,  -451,  -451,
    -451,  -451,    55,    56,   535,     4,   467,  1183,   864,   134,
     493,   593,   638,    80,    81,    82,    83,   149,   193,   945,
     946,   335,   468,   552,   158,   428,   339,   160,   947,   517,
     502,    80,    81,    82,    83,     6,   591,   593,   469,   788,
     609,   512,   458,   654,   162,  1073,   503,   459,   655,   612,
    1055,  1056,   454,  1058,  1059,   616,   915,    80,    81,    82,
      83,   164,   507,   945,   946,   613,   609,   165,   556,   193,
     933,    89,   947,  1017,   945,   946,   167,    91,     6,    92,
     647,   648,   864,  1021,   195,   604,   802,   593,   193,   748,
     803,   126,  1116,   465,   749,  1216,   780,  1218,   533,   172,
     617,   781,   476,   123,    79,   173,  -451,  -451,  -451,  -451,
     597,   604,   174,     4,   792,   353,   609,   500,  1229,   793,
    1231,   194,   533,   794,   116,   117,   598,   637,   795,   780,
    -451,  -451,  -451,  -451,   873,   918,   535,     4,   918,  1039,
     919,   663,   606,   920,  1040,  1041,  1054,   512,   286,   177,
    1042,  1226,   512,   129,    77,    78,    79,   135,   590,   428,
     977,   604,  1095,   713,   978,   235,  1096,   242,    80,    81,
      82,    83,  1133,  1245,   721,   247,  1134,  1246,    45,   223,
     224,   225,   226,   227,   626,   255,     6,   221,   222,   223,
     224,   225,   226,   227,   193,   136,   266,   589,   256,  1254,
    1261,    30,    31,  1255,  1262,   476,   260,   761,   265,   195,
       6,   267,   -95,   -95,   -95,   -95,   -95,   -95,   723,   137,
      80,    81,    82,    83,   273,   778,   556,   226,   227,   627,
     274,   628,   269,   629,   630,   631,   641,   642,   643,   644,
     275,  -521,  -521,  -521,   535,   276,   800,   704,   705,   706,
     707,   277,  1204,   326,   807,   290,   809,   810,   580,   581,
     582,   125,   567,   568,   489,   490,   491,   329,   535,   481,
     482,   724,   725,   328,   116,   117,  1223,   825,   632,   633,
     634,   597,   826,   337,   726,   727,   728,   729,   837,   735,
     736,   738,  1233,    30,    31,   340,   454,   598,   851,   852,
     341,   730,   854,   343,    77,    78,    79,   858,  1122,  1123,
     233,   234,   344,   606,   858,   347,   116,   117,   731,   356,
     858,  1028,  1029,  1071,  1072,   193,   371,   635,    29,   590,
      30,    31,   636,    32,   368,   369,   357,   372,   118,   512,
     713,   373,   889,   119,   120,   121,   122,   123,    79,   403,
     721,   405,   898,   899,   900,   901,   902,   903,   904,   906,
     908,   910,   912,   374,   418,    33,   421,    21,   784,   423,
      80,    81,    82,    83,    22,    34,   425,    35,   427,   -58,
     434,   931,   439,   227,   444,   445,   124,   288,   446,   447,
     450,   937,   470,   939,    37,    38,    39,    40,    41,    42,
      43,    44,   448,   858,   858,   449,   455,   456,   463,   474,
     778,   125,    80,    81,    82,    83,   475,  -207,   483,   487,
     485,   970,   972,   974,   975,    88,    45,    89,    90,   488,
     495,   511,   514,    91,   531,    92,   522,   529,   849,   525,
     512,   555,   551,   985,   925,   987,   559,   989,   535,   572,
     574,   614,   661,   125,   645,   621,   662,   669,   670,   693,
     698,   701,   708,   709,  1000,  1001,   711,   716,   717,    93,
     718,   791,   719,   739,  1011,   744,   746,   750,   756,  1015,
     758,   763,   764,   767,   849,   926,   927,   765,  1025,   769,
     772,   676,   776,   775,   858,   858,   789,   814,   782,  1036,
     815,   816,   817,   818,   819,   820,   796,  1044,   797,  1046,
     798,  1048,    94,    95,   799,   713,   804,  1053,   811,  1037,
    1057,   812,  1212,   597,   846,   821,   865,   822,   840,   823,
     824,    96,   848,   883,   866,   887,   872,  1070,   884,   598,
    1224,   931,   931,    97,    98,    99,   100,   101,   102,   597,
    1078,   878,  1082,   885,   886,   606,   892,  1236,   914,   890,
     894,   103,   104,   928,   858,   598,  1243,   827,   962,   895,
     913,   590,   897,   105,   917,   924,   938,  1252,   936,   940,
     106,   606,   944,   941,   107,   108,  1256,   961,   979,  1258,
     986,  1260,   982,  1263,   996,   988,  1265,   590,  1267,   597,
    1269,   990,  1271,   991,  1273,   992,   995,   997,   577,   999,
     784,  1012,  1014,  1002,  1006,   598,  1016,  1019,  1128,  1023,
    1026,  1130,  1030,  1031,  1043,  1074,  1045,  1079,  1047,  1049,
    1137,   606,  1050,  1036,  1060,  1084,   589,  1061,  1062,  1145,
    1083,  1063,  1064,  1085,  1065,  1066,  1069,   590,  1090,  1094,
    1098,  1106,  1155,  1108,  1105,    30,    31,  1107,  1109,  1112,
    1110,    88,    45,    89,    90,  1163,   -95,   -95,   -95,    91,
    1111,    92,  1115,  1147,  1119,  1120,  1121,  1174,   562,   563,
     564,   565,   566,  1126,  1129,  1131,   784,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,  1132,  1155,
    1136,  1139,  1187,  1188,  1189,    93,  1141,  1148,  1146,  1156,
    1198,  1149,  1150,  1158,  1159,  1167,   567,   568,  1203,  1101,
    1171,   867,   868,  1176,  1172,  1177,  1185,  1199,  1213,  1200,
    1201,  1208,   858,  1205,   858,  1214,  1209,  1210,  1228,  1221,
     278,   279,   280,   281,   282,   283,   284,   285,    94,    95,
    1215,   291,   292,  1227,  1217,   858,  1219,   858,  1225,  1230,
    1232,  1234,  1251,  1257,  1237,   159,  1238,    96,  1239,  1240,
    1241,  1242,  1244,  1249,  1101,  1250,  1248,  1247,  1259,    97,
      98,    99,   100,   101,   102,  1253,  1264,  1266,  1268,  1270,
    1272,   161,   334,   494,    23,  1274,   550,   103,   104,   414,
     742,   554,   849,   651,   960,   524,    69,   766,   424,   105,
     527,   618,   779,  1186,   771,   874,   106,  1101,   953,   942,
     107,   108,  1168,  1101,   252,   959,   745,   504,    25,   881,
     443,    26,   520,   882,   849,   839,   411,  1068,   404,   506,
     836,   114,  1100,  1140,    88,    45,    89,    90,   518,   916,
    1178,   994,    91,   896,    92,   646,  1184,   845,   573,     0,
       0,  1076,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,    93,    88,
      45,    89,    90,     0,   934,     0,     0,    91,     0,    92,
       0,     0,     0,     0,   926,   927,     0,     0,   508,     0,
      88,    45,    89,    90,     0,  1151,     0,     0,    91,   442,
      92,     0,     0,  1143,     0,     0,     0,     0,     0,     0,
       0,    94,    95,    93,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
      96,     0,     0,     0,    93,     0,     0,     0,     0,     0,
       0,     0,    97,    98,    99,   100,   101,   102,     0,     0,
       0,     0,     0,     0,     0,     0,    94,    95,  1152,     0,
     103,   104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   105,     0,     0,    96,     0,    94,    95,   106,
       0,     0,     0,   107,   108,     0,     0,    97,    98,    99,
     100,   101,   102,     0,     0,     0,    96,     0,     0,     0,
       0,     0,     0,     0,     0,   103,   104,     0,    97,    98,
      99,   100,   101,   102,     0,     0,  1144,   105,     0,     0,
       0,     0,     0,     0,   106,     0,   103,   104,   107,   108,
       0,    88,    45,    89,    90,     0,     0,     0,   105,    91,
       0,    92,     0,     0,     0,   106,     0,     0,     0,   107,
     108,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,     0,    93,    88,    45,    89,    90,
       0,     0,     0,     0,    91,     0,    92,     0,     0,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,     0,    94,    95,
      93,     0,    88,    45,    89,    90,     0,     0,     0,   905,
      91,   228,    92,     0,     0,     0,     0,    96,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    97,
      98,    99,   100,   101,   102,     0,     0,     0,     0,     0,
       0,     0,     0,    94,    95,     0,    93,   103,   104,     0,
       0,     0,     0,     0,   907,     0,     0,     0,     0,   105,
       0,     0,    96,     0,     0,     0,   106,     0,     0,     0,
     107,   108,     0,     0,    97,    98,    99,   100,   101,   102,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    94,
      95,     0,   103,   104,     0,     0,     0,     0,     0,     0,
     909,     0,     0,     0,   105,     0,     0,     0,    96,     0,
       0,   106,     0,     0,     0,   107,   108,     0,     0,     0,
      97,    98,    99,   100,   101,   102,    88,    45,    89,    90,
       0,     0,     0,     0,    91,     0,    92,     0,   103,   104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,   106,     0,     0,
       0,   107,   108,     0,     0,     0,     0,     0,     0,     0,
      93,    88,    45,    89,    90,     0,     0,     0,     0,    91,
       0,    92,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
       0,     0,     0,    94,    95,    93,    88,    45,    89,    90,
       0,     0,     0,     0,    91,     0,    92,     0,     0,     0,
       0,     0,    96,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    97,    98,    99,   100,   101,   102,
       0,     0,     0,     0,     0,     0,     0,     0,    94,    95,
      93,     0,   103,   104,     0,     0,     0,     0,     0,   969,
       0,     0,     0,     0,   105,   911,     0,    96,     0,     0,
       0,   106,     0,     0,     0,   107,   108,     0,     0,    97,
      98,    99,   100,   101,   102,     0,     0,     0,     0,     0,
       0,     0,     0,    94,    95,     0,     0,   103,   104,     0,
      88,    45,    89,    90,   971,     0,     0,     0,    91,   105,
      92,     0,    96,     0,     0,     0,   106,     0,     0,     0,
     107,   108,     0,     0,    97,    98,    99,   100,   101,   102,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   103,   104,    93,    88,    45,    89,    90,     0,
       0,     0,     0,    91,   105,    92,     0,     0,     0,     0,
       0,   106,     0,     0,     0,   107,   108,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,    94,    95,    93,
       0,    88,    45,    89,    90,     0,     0,     0,   973,    91,
       0,    92,     0,     0,     0,     0,    96,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    97,    98,
      99,   100,   101,   102,     0,     0,     0,     0,     0,     0,
       0,     0,    94,    95,     0,    93,   103,   104,     0,     0,
       0,     0,    88,    45,    89,    90,     0,     0,   105,     0,
      91,    96,    92,     0,     0,   106,     0,     0,     0,   107,
     108,     0,     0,    97,    98,    99,   100,   101,   102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    94,    95,
       0,   103,   104,     0,     0,     0,    93,     0,    88,    45,
      89,    90,  1033,   105,     0,     0,    91,    96,    92,     0,
     106,     0,     0,     0,   107,   108,     0,     0,     0,    97,
      98,    99,   100,   101,   102,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   104,    94,
      95,     0,    93,    88,    45,    89,    90,     0,     0,   105,
    1173,    91,     0,    92,     0,     0,   106,     0,    96,     0,
     107,   108,     0,     0,     0,     0,     0,     0,     0,     0,
      97,    98,    99,   100,   101,   102,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    94,    95,    93,   103,   104,
       0,     0,     0,     0,     0,    88,    45,    89,    90,     0,
     105,  1220,     0,    91,    96,    92,     0,   106,     0,     0,
       0,   107,   108,     0,     0,     0,    97,    98,    99,   100,
     101,   102,     0,     0,     0,     0,     0,     0,     0,     0,
      94,    95,     0,     0,   103,   104,     0,     0,     0,    93,
      88,    45,    89,    90,     0,     0,   105,     0,    91,    96,
      92,     0,     0,   106,     0,     0,     0,   107,   108,     0,
       0,    97,    98,    99,   100,   101,   102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   103,
     104,     0,    94,    95,    93,     0,     0,     0,     0,     0,
       0,   950,     0,     0,     0,     0,     0,     0,   106,     0,
       0,    96,   107,   108,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    97,    98,    99,   100,   101,   102,     0,
       0,     0,     0,     0,     0,     0,     0,    94,    95,     0,
       0,   103,   104,   694,     0,     0,   695,     0,     0,     0,
       0,     0,     0,  1080,     0,     0,    96,     0,     0,     0,
     106,     0,     0,     0,   107,   108,    30,    31,    97,    98,
      99,   100,   101,   102,     0,     0,     0,   -95,   -95,   -95,
       0,     0,     0,     0,     0,     0,   103,   104,     0,   562,
     563,   564,   565,   566,     0,     0,     0,     0,  1190,     0,
       0,    33,     0,     0,   696,   106,     0,     0,     0,   107,
     108,    34,     0,    35,   533,     0,   575,     0,     0,     0,
       0,     0,  -451,  -451,  -451,  -451,     0,   567,   568,     4,
       0,     0,   576,     0,     0,   496,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   533,     0,   575,
       0,     0,     0,     0,   499,  -451,  -451,  -451,  -451,     0,
       0,   577,     4,   578,     0,   579,     0,     0,   496,     0,
       0,     0,     0,   580,   581,   582,     0,     0,     0,     0,
       0,     0,   583,   584,     0,   585,     0,   499,   586,     0,
       0,     0,   876,     0,   577,     0,   578,     0,   579,     0,
       0,    20,     6,     0,     0,   587,   580,   581,   582,     0,
       0,     0,     0,    21,     0,   583,   584,     0,   585,     0,
      22,   586,   533,     0,   575,     0,     0,     0,     0,     0,
    -451,  -451,  -451,  -451,    20,     6,     0,     4,   587,  1032,
       0,     0,     0,   496,     0,     0,    21,     0,     0,     0,
       0,     0,     0,    22,     0,   533,     0,   575,     0,   588,
       0,     0,   499,  -451,  -451,  -451,  -451,     0,     0,   577,
       4,   578,     0,   579,     0,     0,   496,     0,     0,     0,
       0,   580,   581,   582,     0,     0,     0,     0,     0,     0,
     583,   584,   588,   585,     0,   499,   586,   783,     0,     0,
       0,     0,   577,  1007,   578,     0,   579,     0,     0,    20,
       6,     0,     0,   587,   580,   581,   582,     0,     0,     0,
       0,    21,     0,   583,   584,     0,   585,     0,    22,   586,
     533,     0,   575,     0,     0,     0,     0,     0,  -451,  -451,
    -451,  -451,    20,     6,     0,     4,   587,     0,     0,     0,
       0,   496,     0,     0,    21,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     0,     0,     0,     0,
     499,     0,     0,     0,     0,     0,     0,     0,     0,   578,
       0,   579,     0,     0,     0,     0,     0,     0,     0,   580,
     581,   582,   694,     0,     0,   695,     0,     0,   583,   584,
       0,   585,     0,     0,   586,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    30,    31,    20,     6,     0,
       0,   587,     0,     0,     0,     0,   -95,   -95,   -95,    21,
       0,     0,     0,     0,     0,     0,    22,     0,   562,   563,
     564,   565,   566,     0,     0,     0,     0,     0,     0,     0,
      33,     0,     0,   696,     0,     0,     0,     0,     0,     0,
      34,     0,    35,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   567,   568,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227
};

static const yytype_int16 yycheck[] =
{
      52,     2,   441,   109,    57,    23,    64,   521,   521,    10,
      11,    12,    13,    14,    15,    16,    17,     2,   538,    18,
     521,   762,    74,   450,   576,    10,    11,    12,    13,    14,
      15,    16,    17,     2,   767,   461,   521,   521,    87,   479,
      51,    10,    11,    12,    13,    14,    15,    16,    17,     2,
     109,   335,   561,   105,   106,   584,   585,    10,    11,    12,
      13,    14,    15,    16,    17,   349,    57,   808,    51,   861,
     802,    70,   879,    72,     4,     4,   109,    68,    20,     4,
     769,   114,   521,    21,    32,     4,   451,   353,     2,  1024,
     943,   109,     4,   782,   422,   948,    10,    11,    12,    13,
      14,    15,    16,    17,     4,   531,   553,    81,     4,   536,
    1074,     4,   477,    47,     5,     0,   668,   584,     4,  1098,
      11,   139,    13,    32,     4,     5,     6,   118,   119,   556,
      21,    32,    20,   148,   561,     4,     4,   152,   499,   191,
     660,    32,    38,    39,   664,   197,   198,   199,   152,    31,
     679,   155,    94,   171,    95,   947,    92,    93,  1093,   688,
     193,   194,  1141,   715,    57,   140,   107,    65,     4,    38,
      39,   148,   147,   114,   148,   109,   865,   866,   152,   692,
      94,    95,   159,    97,    98,    99,   100,   101,   102,   103,
     104,   156,   714,   107,   108,   109,   229,   148,   526,   483,
     722,   149,   150,   141,   155,   652,    94,   692,   692,     4,
     476,   153,   679,   151,    96,  1179,   152,    66,   251,   155,
     149,  1185,   274,   275,   276,   277,   155,   286,   158,  1021,
     263,   156,  1039,   152,     0,   287,   288,   289,   150,   748,
     152,   150,   151,   772,   153,   977,   148,   156,   148,   150,
     148,   780,   152,   692,   152,   156,   152,    23,   151,   150,
     151,   950,    92,    93,   150,   156,   152,    33,     8,    47,
     710,   151,    21,     4,   326,   327,    16,    17,    18,    19,
     333,     4,    47,    23,    98,   337,    92,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,     4,   228,  1168,  1169,    92,    93,   371,
       4,   748,   333,    14,   844,   155,    57,   157,    47,    47,
      96,   109,   861,   139,   140,    75,   697,  1026,   867,   868,
      63,    64,   768,    47,   109,  1090,  1079,    78,    79,   148,
     333,    92,   152,   267,   153,   155,    96,    44,    45,    46,
     409,   410,   723,   647,   648,   726,   727,   728,   729,   730,
     731,   148,   148,    57,   108,    44,    45,    46,    29,   155,
     155,   158,   157,    34,    35,  1126,   153,  1132,  1133,   152,
     109,   109,   155,   754,    78,    79,   448,    48,   139,   140,
       8,    44,    45,    46,   456,   109,   512,   148,    16,    17,
      18,    19,    97,    98,   154,    23,   417,  1158,   947,     4,
     438,   934,   849,   110,   111,   112,   113,     4,   461,   139,
     140,   148,   417,   485,     4,   349,   153,    24,   148,   457,
     441,   110,   111,   112,   113,    96,   960,   960,   417,   934,
     934,   450,   148,   148,     4,  1007,   441,   153,   153,   960,
     980,   981,   514,   983,   984,    73,   831,   110,   111,   112,
     113,     4,   441,   139,   140,   960,   960,   154,   496,   512,
     845,     5,   148,   149,   139,   140,   158,    11,    96,    13,
     548,   549,  1021,   148,   512,   934,   148,  1010,   531,   148,
     152,   554,  1054,   417,   153,  1194,   148,  1196,     8,    11,
     528,   153,   426,    45,    46,    12,    16,    17,    18,    19,
     521,   960,   145,    23,   148,   439,  1010,   441,  1217,   153,
    1219,   637,     8,   148,    14,    15,   521,   536,   153,   148,
      16,    17,    18,    19,   153,   148,   154,    23,   148,   148,
     153,   569,   521,   153,   153,   148,    56,   556,   152,   145,
     153,   155,   561,   554,    44,    45,    46,    47,   521,   483,
     148,  1010,   148,   625,   152,    14,   152,   158,   110,   111,
     112,   113,   148,   148,   636,     4,   152,   152,     4,   141,
     142,   143,   144,   145,    10,     4,    96,   139,   140,   141,
     142,   143,   144,   145,   637,    85,   151,   521,     4,   148,
     148,    27,    28,   152,   152,   529,     4,   669,    22,   637,
      96,   151,    38,    39,    40,    38,    39,    40,    49,   109,
     110,   111,   112,   113,    12,   687,   654,   144,   145,    55,
     151,    57,     4,    59,    60,    61,    16,    17,    18,    19,
     151,    67,    68,    69,   154,   151,   708,    16,    17,    18,
      19,   151,  1182,   151,   716,   159,   718,   719,    67,    68,
      69,   151,    88,    89,    38,    39,    40,   152,   154,    27,
      28,   102,   103,   153,    14,    15,  1206,   739,   104,   105,
     106,   692,   744,   149,   115,   116,   117,   118,   750,   642,
     643,   644,  1222,    27,    28,   153,   758,   692,    63,    64,
     151,   132,   764,     4,    44,    45,    46,   769,    86,    87,
     118,   119,   149,   692,   776,   151,    14,    15,   149,   153,
     782,   956,   957,  1003,  1004,   768,   151,   153,    25,   692,
      27,    28,   158,    30,   288,   289,   149,   157,    36,   748,
     802,   157,   804,    41,    42,    43,    44,    45,    46,   159,
     812,     4,   814,   815,   816,   817,   818,   819,   820,   821,
     822,   823,   824,   157,     4,    62,   153,   107,   692,     4,
     110,   111,   112,   113,   114,    72,   152,    74,   153,     4,
     150,   843,   148,   145,   152,   152,    84,   148,   152,   152,
     150,   853,     4,   855,    10,    11,    12,    13,    14,    15,
      16,    17,   155,   865,   866,   159,   152,   155,   153,     4,
     872,   151,   110,   111,   112,   113,   153,     4,   148,     4,
     149,   883,   884,   885,   886,     3,     4,     5,     6,   150,
     152,   159,   148,    11,     4,    13,   155,   148,   762,   153,
     849,     4,   152,   905,    22,   907,     4,   909,   154,   152,
     152,     4,     4,   151,   153,   155,     4,   151,   151,     4,
       4,     4,   151,   153,   926,   927,   152,   151,   151,    47,
     151,   697,   151,   151,   936,   149,   151,   149,   160,   941,
     151,   151,   151,   151,   808,    63,    64,    78,   950,   151,
     151,     4,   151,   153,   956,   957,   153,   723,   149,   961,
     726,   727,   728,   729,   730,   731,    94,   969,    94,   971,
      94,   973,    90,    91,    94,   977,   155,   979,   159,   962,
     982,   148,  1190,   934,   153,   151,   149,   151,   754,   151,
     151,   109,   152,   151,   149,   152,   155,   999,   151,   934,
    1208,  1003,  1004,   121,   122,   123,   124,   125,   126,   960,
    1012,   154,  1014,   151,   151,   934,   152,  1225,   148,   153,
     152,   139,   140,   141,  1026,   960,  1234,     4,     4,   152,
     152,   934,   153,   151,   153,   152,   152,  1245,   153,   152,
     158,   960,   141,   155,   162,   163,  1254,   151,   155,  1257,
     152,  1259,   153,  1261,     4,   152,  1264,   960,  1266,  1010,
    1268,   152,  1270,   153,  1272,   152,   152,   148,    55,   149,
     934,    80,     9,   152,   152,  1010,   141,   134,  1080,   149,
     148,  1083,   153,   157,   151,    58,   152,   148,   152,   152,
    1092,  1010,   152,  1095,   152,   134,   960,   153,   152,  1101,
     155,   153,   152,   134,   153,   153,   153,  1010,   134,     4,
     151,   153,  1114,   153,   152,    27,    28,   152,   152,    70,
     153,     3,     4,     5,     6,  1127,    38,    39,    40,    11,
     153,    13,   152,   148,   153,   153,   153,  1139,    50,    51,
      52,    53,    54,   153,   152,   151,  1010,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   151,  1161,
     152,   151,  1164,  1165,  1166,    47,   151,   153,   152,    58,
    1172,   153,   153,   153,    70,   149,    88,    89,  1180,  1043,
     152,    63,    64,   152,   155,     4,   152,   152,  1190,   152,
     151,   148,  1194,   152,  1196,   153,   152,   152,   152,  1201,
     178,   179,   180,   181,   182,   183,   184,   185,    90,    91,
     155,   189,   190,  1215,   155,  1217,   155,  1219,   148,   152,
     152,   148,   153,   148,  1226,    70,   155,   109,   152,   152,
     152,   152,   152,   152,  1098,   152,  1238,   155,   148,   121,
     122,   123,   124,   125,   126,  1247,   148,   148,   148,   148,
     148,    72,   243,   439,     6,   152,   483,   139,   140,   334,
     650,   492,  1126,   554,   877,   471,    35,   674,   345,   151,
     475,   529,   688,  1163,   679,   780,   158,  1141,   866,   861,
     162,   163,  1131,  1147,   148,   872,   654,   441,     6,   792,
     359,     6,   462,   794,  1158,   753,   333,   997,   330,   441,
     748,    54,  1041,  1095,     3,     4,     5,     6,   458,   834,
    1147,   914,    11,   812,    13,   547,  1161,   758,   514,    -1,
      -1,  1010,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    47,     3,
       4,     5,     6,    -1,   847,    -1,    -1,    11,    -1,    13,
      -1,    -1,    -1,    -1,    63,    64,    -1,    -1,   441,    -1,
       3,     4,     5,     6,    -1,     8,    -1,    -1,    11,   357,
      13,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    91,    47,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
     109,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   121,   122,   123,   124,   125,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    71,    -1,
     139,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151,    -1,    -1,   109,    -1,    90,    91,   158,
      -1,    -1,    -1,   162,   163,    -1,    -1,   121,   122,   123,
     124,   125,   126,    -1,    -1,    -1,   109,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,   140,    -1,   121,   122,
     123,   124,   125,   126,    -1,    -1,   150,   151,    -1,    -1,
      -1,    -1,    -1,    -1,   158,    -1,   139,   140,   162,   163,
      -1,     3,     4,     5,     6,    -1,    -1,    -1,   151,    11,
      -1,    13,    -1,    -1,    -1,   158,    -1,    -1,    -1,   162,
     163,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,    -1,    47,     3,     4,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    13,    -1,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,    -1,    90,    91,
      47,    -1,     3,     4,     5,     6,    -1,    -1,    -1,   101,
      11,   161,    13,    -1,    -1,    -1,    -1,   109,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,
     122,   123,   124,   125,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    -1,    47,   139,   140,    -1,
      -1,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,   151,
      -1,    -1,   109,    -1,    -1,    -1,   158,    -1,    -1,    -1,
     162,   163,    -1,    -1,   121,   122,   123,   124,   125,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    -1,   139,   140,    -1,    -1,    -1,    -1,    -1,    -1,
     101,    -1,    -1,    -1,   151,    -1,    -1,    -1,   109,    -1,
      -1,   158,    -1,    -1,    -1,   162,   163,    -1,    -1,    -1,
     121,   122,   123,   124,   125,   126,     3,     4,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    13,    -1,   139,   140,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     151,    -1,    -1,    -1,    -1,    -1,    -1,   158,    -1,    -1,
      -1,   162,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,     3,     4,     5,     6,    -1,    -1,    -1,    -1,    11,
      -1,    13,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,    -1,
      -1,    -1,    -1,    90,    91,    47,     3,     4,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    13,    -1,    -1,    -1,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   121,   122,   123,   124,   125,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      47,    -1,   139,   140,    -1,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,   151,   152,    -1,   109,    -1,    -1,
      -1,   158,    -1,    -1,    -1,   162,   163,    -1,    -1,   121,
     122,   123,   124,   125,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    91,    -1,    -1,   139,   140,    -1,
       3,     4,     5,     6,   101,    -1,    -1,    -1,    11,   151,
      13,    -1,   109,    -1,    -1,    -1,   158,    -1,    -1,    -1,
     162,   163,    -1,    -1,   121,   122,   123,   124,   125,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,   140,    47,     3,     4,     5,     6,    -1,
      -1,    -1,    -1,    11,   151,    13,    -1,    -1,    -1,    -1,
      -1,   158,    -1,    -1,    -1,   162,   163,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,    -1,    90,    91,    47,
      -1,     3,     4,     5,     6,    -1,    -1,    -1,   101,    11,
      -1,    13,    -1,    -1,    -1,    -1,   109,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   121,   122,
     123,   124,   125,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    -1,    47,   139,   140,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,    -1,    -1,   151,    -1,
      11,   109,    13,    -1,    -1,   158,    -1,    -1,    -1,   162,
     163,    -1,    -1,   121,   122,   123,   124,   125,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      -1,   139,   140,    -1,    -1,    -1,    47,    -1,     3,     4,
       5,     6,   150,   151,    -1,    -1,    11,   109,    13,    -1,
     158,    -1,    -1,    -1,   162,   163,    -1,    -1,    -1,   121,
     122,   123,   124,   125,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,   140,    90,
      91,    -1,    47,     3,     4,     5,     6,    -1,    -1,   151,
     152,    11,    -1,    13,    -1,    -1,   158,    -1,   109,    -1,
     162,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     121,   122,   123,   124,   125,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    47,   139,   140,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,    -1,
     151,   152,    -1,    11,   109,    13,    -1,   158,    -1,    -1,
      -1,   162,   163,    -1,    -1,    -1,   121,   122,   123,   124,
     125,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    91,    -1,    -1,   139,   140,    -1,    -1,    -1,    47,
       3,     4,     5,     6,    -1,    -1,   151,    -1,    11,   109,
      13,    -1,    -1,   158,    -1,    -1,    -1,   162,   163,    -1,
      -1,   121,   122,   123,   124,   125,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
     140,    -1,    90,    91,    47,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,   158,    -1,
      -1,   109,   162,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   121,   122,   123,   124,   125,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    -1,
      -1,   139,   140,     4,    -1,    -1,     7,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,   109,    -1,    -1,    -1,
     158,    -1,    -1,    -1,   162,   163,    27,    28,   121,   122,
     123,   124,   125,   126,    -1,    -1,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    -1,   139,   140,    -1,    50,
      51,    52,    53,    54,    -1,    -1,    -1,    -1,   151,    -1,
      -1,    62,    -1,    -1,    65,   158,    -1,    -1,    -1,   162,
     163,    72,    -1,    74,     8,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    16,    17,    18,    19,    -1,    88,    89,    23,
      -1,    -1,    26,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    10,
      -1,    -1,    -1,    -1,    48,    16,    17,    18,    19,    -1,
      -1,    55,    23,    57,    -1,    59,    -1,    -1,    29,    -1,
      -1,    -1,    -1,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    -1,    79,    -1,    48,    82,    -1,
      -1,    -1,   153,    -1,    55,    -1,    57,    -1,    59,    -1,
      -1,    95,    96,    -1,    -1,    99,    67,    68,    69,    -1,
      -1,    -1,    -1,   107,    -1,    76,    77,    -1,    79,    -1,
     114,    82,     8,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      16,    17,    18,    19,    95,    96,    -1,    23,    99,   100,
      -1,    -1,    -1,    29,    -1,    -1,   107,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,     8,    -1,    10,    -1,   153,
      -1,    -1,    48,    16,    17,    18,    19,    -1,    -1,    55,
      23,    57,    -1,    59,    -1,    -1,    29,    -1,    -1,    -1,
      -1,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,   153,    79,    -1,    48,    82,    83,    -1,    -1,
      -1,    -1,    55,    56,    57,    -1,    59,    -1,    -1,    95,
      96,    -1,    -1,    99,    67,    68,    69,    -1,    -1,    -1,
      -1,   107,    -1,    76,    77,    -1,    79,    -1,   114,    82,
       8,    -1,    10,    -1,    -1,    -1,    -1,    -1,    16,    17,
      18,    19,    95,    96,    -1,    23,    99,    -1,    -1,    -1,
      -1,    29,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      68,    69,     4,    -1,    -1,     7,    -1,    -1,    76,    77,
      -1,    79,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    28,    95,    96,    -1,
      -1,    99,    -1,    -1,    -1,    -1,    38,    39,    40,   107,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      62,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   165,   166,     0,    23,    33,    96,   167,   168,   169,
     171,   179,   198,   203,   231,   299,   301,   353,   172,   204,
      95,   107,   114,   213,   214,   309,   322,   324,   354,    25,
      27,    28,    30,    62,    72,    74,   170,   167,   167,   167,
     167,   167,   167,   167,   167,     4,   174,   175,   176,   177,
       4,   310,   156,   223,   225,    97,    98,   218,   323,     4,
      14,   352,   180,   300,   302,   199,     4,    66,   244,   244,
      21,   173,   148,    32,   149,   150,   205,    44,    45,    46,
     110,   111,   112,   113,   222,   311,   312,   313,     3,     5,
       6,    11,    13,    47,    90,    91,   109,   121,   122,   123,
     124,   125,   126,   139,   140,   151,   158,   162,   163,   177,
     425,   446,   447,   450,   352,    98,    14,    15,    36,    41,
      42,    43,    44,    45,    84,   151,   178,   220,   221,   222,
     108,   325,   326,   153,     4,    47,    85,   109,   178,   291,
     292,   293,   295,   296,   297,   298,   312,   313,   298,     4,
       4,   149,   155,    44,    45,   222,   237,   238,     4,   174,
      24,   176,     4,   446,     4,   154,   182,   158,    47,   109,
     314,   314,    11,    12,   145,   168,   168,   145,   168,   168,
     168,   168,   168,   168,   168,   168,   446,   446,   449,   168,
     168,   156,   168,   223,   224,   225,   450,    92,    93,   155,
     157,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   161,   224,
     225,   226,    44,   221,   221,    14,    47,   109,   217,    47,
     109,   327,   158,   181,   225,   294,   291,     4,   303,   304,
     305,   291,   303,   200,   232,     4,     4,    47,   109,   239,
       4,    47,   109,   240,   235,    22,   151,   151,   189,     4,
     315,   316,   225,    12,   151,   151,   151,   151,   447,   447,
     447,   447,   447,   447,   447,   447,   152,   155,   148,   158,
     159,   447,   447,   446,   448,   223,   223,   446,   446,   446,
     168,   168,   168,   168,   168,   168,   168,   168,   168,   168,
     168,   168,   168,   168,   168,   168,   168,   168,   168,   168,
     168,   168,   168,   168,   168,   168,   151,   168,   153,   152,
     328,   329,   333,   334,   182,   148,   153,   149,   223,   153,
     153,   151,   242,     4,   149,   236,   223,   151,   245,   183,
       4,   150,   152,   168,   190,   193,   153,   149,   317,   148,
     159,   446,   446,   446,   446,   450,   446,   446,   449,   449,
     157,   151,   157,   157,   157,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   446,   446,   159,   329,     4,   330,   331,   178,   312,
     313,   324,   335,   337,   189,   304,   446,   201,     4,   241,
     243,   153,   233,     4,   245,   152,   246,   153,   168,   185,
     186,   304,   194,   195,   150,   211,   212,   213,   215,   148,
     191,   206,   447,   316,   152,   152,   152,   152,   155,   159,
     150,   429,   430,   431,   446,   152,   155,   332,   148,   153,
     314,   314,   336,   153,    31,   168,   202,   299,   301,   353,
       4,   148,   152,   242,     4,   153,   168,   248,   249,   251,
     252,    27,    28,   148,   184,   149,   192,     4,   150,    38,
      39,    40,   216,   225,   193,   152,    29,    34,    35,    48,
     168,   207,   299,   301,   306,   340,   349,   353,   374,   385,
     446,   159,   177,   425,   148,   191,   446,   225,   331,   226,
     325,   227,   155,   382,   241,   153,   234,   252,   215,   148,
     191,     4,   348,     8,    75,   154,   168,   171,   209,   299,
     301,   340,   353,   383,   393,   395,   396,   409,   187,   188,
     186,   152,   446,   196,   218,     4,   225,   307,   308,     4,
     209,   210,    50,    51,    52,    53,    54,    88,    89,   215,
     372,   373,   152,   431,   152,    10,    26,    55,    57,    59,
      67,    68,    69,    76,    77,    79,    82,    99,   153,   168,
     171,   228,   229,   231,   253,   263,   266,   299,   301,   306,
     309,   320,   321,   322,   340,   349,   353,   355,   374,   383,
     394,   410,   434,   440,     4,   242,    73,   225,   249,   247,
     226,   155,     4,     5,     6,   151,    10,    55,    57,    59,
      60,    61,   104,   105,   106,   153,   158,   177,   425,   426,
     396,    16,    17,    18,    19,   153,   410,   298,   298,   192,
     219,   220,   197,   425,   148,   153,   386,   350,   351,   426,
     378,     4,     4,   225,   377,   375,   439,   382,   441,   151,
     151,     4,    57,   254,   255,   257,     4,    57,    78,   264,
     265,   266,   270,   271,   272,   284,   289,   156,   267,   268,
     269,   289,   432,     4,     4,     7,    65,   358,     4,   318,
     319,     4,   338,   339,    16,    17,    18,    19,   151,   153,
     250,   152,   208,   446,   398,   399,   151,   151,   151,   151,
     427,   446,   397,    49,   102,   103,   115,   116,   117,   118,
     132,   149,    20,    94,   384,   384,   384,   153,   384,   151,
     304,   304,   217,   192,   149,   308,   151,   388,   148,   153,
     149,   396,   343,   344,   341,   396,   160,   379,   151,   428,
     382,   446,   435,   151,   151,    78,   254,   151,   290,   151,
      78,   265,   151,   276,   277,   153,   151,   287,   446,   268,
     148,   153,   149,    83,   168,   228,   433,   434,   440,   153,
     356,   210,   148,   153,   148,   153,    94,    94,    94,    94,
     446,   348,   148,   152,   155,   428,   382,   446,   401,   446,
     446,   159,   148,   428,   210,   210,   210,   210,   210,   210,
     210,   151,   151,   151,   151,   446,   446,     4,    38,    39,
     152,   389,   390,   391,   392,   387,   351,   446,   345,   345,
     210,    21,   141,   151,   376,   429,   153,   442,   152,   168,
     395,    63,    64,   260,   446,   260,   226,   288,   446,    63,
      64,   275,   278,   282,   289,   149,   149,    63,    64,   285,
     286,   288,   155,   153,   269,   288,   153,   230,   154,   366,
     357,   319,   339,   151,   151,   151,   151,   152,   208,   446,
     153,   400,   152,   395,   152,   152,   427,   153,   446,   446,
     446,   446,   446,   446,   446,   101,   446,   101,   446,   101,
     446,   152,   446,   152,   148,   191,   391,   153,   148,   153,
     153,   346,   347,   348,   152,    22,    63,    64,   141,   380,
     381,   446,   396,   191,   432,   437,   153,   446,   152,   446,
     152,   155,   278,   282,   141,   139,   140,   148,   279,   281,
     151,   273,   288,   273,   289,   289,    81,   148,   152,   287,
     227,   151,     4,   359,   360,   360,   363,   364,   365,   101,
     446,   101,   446,   101,   446,   446,   438,   148,   152,   155,
     412,   406,   153,   404,   405,   446,   152,   446,   152,   446,
     152,   153,   152,   408,   390,   152,     4,   148,   342,   149,
     446,   446,   152,    65,   148,   152,   152,    56,   440,   443,
     444,   446,    80,   258,     9,   446,   141,   149,   281,   134,
     282,   148,   281,   149,   288,   446,   148,   274,   285,   285,
     153,   157,   100,   150,   367,   368,   446,   223,   361,   148,
     153,   148,   153,   151,   446,   152,   446,   152,   446,   152,
     152,   419,   208,   446,    56,   396,   396,   446,   396,   396,
     152,   153,   152,   153,   152,   153,   153,   411,   347,   153,
     446,   381,   381,   382,    58,   445,   433,   436,   446,   148,
     151,   259,   446,   155,   134,   134,   280,   283,   289,   282,
     134,   274,   155,   288,     4,   148,   152,   362,   151,   360,
     364,   168,   369,   370,   371,   152,   153,   152,   153,   152,
     153,   153,    70,   420,   421,   152,   382,   407,   402,   153,
     153,   153,    86,    87,   415,   443,   153,   260,   446,   152,
     446,   151,   151,   148,   152,   283,   152,   446,   274,   151,
     368,   151,   369,    37,   150,   446,   152,   148,   153,   153,
     153,     8,    71,   423,   424,   446,    58,   413,   153,    70,
     416,   417,   395,   446,    92,    93,   155,   149,   280,   283,
     283,   152,   155,   152,   446,   369,   152,     4,   371,   422,
     148,   155,   414,   395,   423,   152,   258,   446,   446,   446,
     151,   261,   262,   446,    92,   281,    92,   281,   446,   152,
     152,   151,   443,   446,   396,   152,   418,   443,   148,   152,
     152,   152,   262,   446,   153,   155,   288,   155,   288,   155,
     152,   446,   403,   396,   262,   148,   155,   446,   152,   288,
     152,   288,   152,   396,   148,   256,   262,   446,   155,   152,
     152,   152,   152,   262,   152,   148,   152,   155,   446,   152,
     152,   153,   262,   446,   148,   152,   262,   148,   262,   148,
     262,   148,   152,   262,   148,   262,   148,   262,   148,   262,
     148,   262,   148,   262,   152
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   164,   166,   165,   167,   167,   167,   167,   167,   167,
     167,   167,   167,   169,   168,   170,   170,   172,   173,   171,
     174,   174,   175,   175,   176,   176,   177,   177,   177,   178,
     178,   178,   180,   181,   179,   183,   184,   182,   182,   185,
     185,   186,   187,   186,   188,   186,   186,   189,   189,   189,
     190,   190,   191,   191,   192,   192,   194,   193,   195,   196,
     193,   197,   193,   193,   199,   200,   198,   201,   201,   202,
     202,   202,   204,   205,   203,   206,   206,   207,   207,   207,
     207,   207,   207,   207,   207,   208,   208,   209,   209,   209,
     209,   209,   209,   210,   210,   212,   211,   214,   213,   215,
     215,   216,   216,   216,   217,   217,   217,   218,   218,   218,
     218,   219,   219,   220,   220,   220,   220,   220,   220,   220,
     220,   220,   220,   220,   221,   221,   222,   222,   222,   222,
     222,   223,   223,   223,   223,   224,   224,   225,   225,   226,
     226,   227,   227,   227,   227,   227,   228,   228,   228,   228,
     228,   228,   228,   228,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   228,   230,   229,   232,   231,   233,   231,
     234,   231,   235,   231,   236,   231,   237,   237,   237,   238,
     238,   238,   239,   239,   239,   240,   240,   240,   241,   241,
     242,   242,   243,   243,   243,   243,   244,   244,   245,   245,
     246,   247,   245,   248,   248,   250,   249,   251,   249,   252,
     252,   253,   254,   254,   255,   255,   256,   256,   257,   257,
     258,   258,   259,   259,   259,   259,   260,   260,   260,   261,
     261,   261,   261,   261,   262,   262,   263,   263,   264,   264,
     265,   265,   265,   266,   266,   267,   268,   268,   269,   270,
     270,   271,   272,   272,   273,   273,   273,   274,   274,   275,
     275,   276,   276,   276,   277,   277,   277,   278,   278,   279,
     279,   280,   280,   281,   281,   281,   282,   283,   284,   285,
     285,   285,   286,   286,   286,   287,   288,   288,   290,   289,
     291,   291,   291,   292,   293,   294,   295,   296,   296,   297,
     298,   298,   298,   298,   298,   300,   299,   302,   301,   303,
     303,   304,   304,   305,   306,   307,   307,   308,   310,   309,
     311,   311,   311,   312,   313,   313,   314,   314,   314,   315,
     315,   316,   317,   317,   318,   318,   319,   320,   321,   323,
     322,   324,   324,   325,   326,   326,   327,   327,   327,   328,
     328,   329,   330,   330,   332,   331,   334,   333,   335,   335,
     336,   335,   337,   337,   338,   338,   339,   341,   342,   340,
     343,   340,   344,   340,   345,   345,   346,   346,   347,   347,
     348,   349,   350,   350,   351,   352,   352,   353,   353,   354,
     354,   356,   355,   357,   355,   358,   358,   359,   359,   361,
     360,   362,   360,   363,   363,   364,   365,   364,   366,   366,
     367,   367,   368,   368,   368,   368,   369,   370,   370,   371,
     371,   371,   371,   371,   371,   372,   372,   373,   373,   375,
     376,   374,   377,   374,   378,   374,   379,   379,   379,   379,
     379,   379,   380,   380,   380,   381,   381,   381,   382,   382,
     383,   383,   384,   384,   384,   386,   387,   385,   388,   388,
     389,   389,   390,   390,   391,   392,   392,   393,   393,   393,
     393,   393,   393,   393,   393,   393,   394,   394,   394,   394,
     394,   394,   394,   395,   395,   395,   395,   395,   395,   395,
     395,   395,   396,   396,   396,   396,   396,   396,   396,   396,
     396,   397,   396,   398,   396,   399,   400,   396,   401,   402,
     403,   396,   404,   396,   405,   396,   406,   407,   396,   408,
     396,   409,   409,   409,   409,   410,   410,   410,   411,   411,
     411,   412,   412,   414,   413,   413,   415,   415,   417,   418,
     416,   419,   419,   421,   422,   420,   423,   423,   424,   424,
     424,   424,   425,   425,   425,   426,   426,   427,   427,   428,
     428,   429,   429,   430,   430,   431,   432,   432,   432,   433,
     433,   433,   435,   436,   434,   437,   434,   438,   434,   439,
     434,   441,   442,   440,   444,   443,   443,   445,   445,   446,
     446,   447,   447,   447,   447,   447,   447,   448,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   447,   447,   447,   447,   447,   447,
     447,   447,   447,   447,   449,   449,   450,   450,   450,   450
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     0,     0,     2,     4,     0,     0,     0,     5,
       1,     0,     1,     3,     1,     3,     1,     3,     3,     1,
       1,     3,     0,     0,    11,     0,     0,     6,     0,     1,
       3,     0,     0,     5,     0,     5,     1,     2,     0,     4,
       1,     3,     1,     0,     2,     0,     0,     3,     0,     0,
       5,     0,     6,     3,     0,     0,     9,     2,     0,     1,
       1,     1,     0,     0,     9,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     2,     2,     2,
       4,     6,     8,     1,     0,     0,     5,     0,     4,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     1,     1,
       0,     1,     0,     1,     1,     1,     1,     2,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     5,     5,     3,     2,     2,     1,     0,     1,
       1,     2,     2,     2,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     1,     1,     0,     6,     0,     7,     0,     9,
       0,    11,     0,     9,     0,    10,     2,     3,     2,     0,
       1,     1,     0,     1,     1,     0,     1,     1,     2,     1,
       3,     0,     3,     2,     1,     0,     1,     0,     2,     0,
       0,     0,     6,     1,     3,     0,     5,     0,     2,     2,
       0,     3,     2,     0,    10,    14,     2,     0,     4,     0,
       2,     0,     1,     5,     5,     5,     1,     1,     0,     1,
       5,     7,    13,    25,     1,     5,     3,     2,     2,     1,
       1,     1,     1,     3,     4,     5,     1,     3,     3,     4,
       0,     2,     4,     4,     4,     1,     2,     2,     3,     1,
       1,     7,    12,    11,     6,    12,    11,     2,     3,     2,
       3,     1,     3,     1,     1,     0,     1,     1,     5,     2,
       2,     1,     1,     3,     3,     1,     1,     5,     0,     3,
       1,     1,     0,     1,     1,     1,     2,     2,     3,     2,
       1,     1,     1,     1,     1,     0,     6,     0,     6,     1,
       3,     3,     1,     1,     3,     1,     3,     4,     0,     6,
       2,     3,     0,     1,     1,     1,     1,     1,     0,     1,
       3,     2,     2,     0,     1,     3,     1,     3,     3,     0,
       3,     1,     1,     4,     2,     0,     1,     1,     0,     1,
       2,     3,     1,     3,     0,     3,     0,     2,     1,     1,
       0,     3,     2,     3,     1,     3,     1,     0,     0,     8,
       0,     6,     0,     6,     0,     3,     1,     3,     1,     3,
       2,     4,     1,     3,     3,     1,     1,     6,     4,     1,
       1,     0,     6,     0,     6,     1,     1,     1,     3,     0,
       5,     0,     6,     1,     3,     1,     0,     4,     4,     0,
       1,     3,     0,     1,     4,     5,     1,     1,     3,     1,
       2,     6,     5,     3,     2,     1,     1,     1,     1,     0,
       0,     6,     0,     4,     0,     4,     4,     4,     3,     3,
       2,     0,     1,     3,     3,     2,     2,     1,     2,     0,
       2,     0,     1,     1,     0,     0,     0,     6,     2,     4,
       1,     3,     2,     1,     1,     1,     1,     7,     7,     8,
       8,     7,     6,     3,     7,     8,     7,     7,     8,     8,
       7,     7,     8,     5,     3,     3,     5,     5,     5,     5,
       5,     5,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     0,     5,     0,     5,     0,     0,     8,     0,     0,
       0,    13,     0,     7,     0,     7,     0,     0,     9,     0,
       9,     1,     2,     2,     2,     1,     1,     1,     2,     2,
       0,     2,     0,     0,     3,     0,     2,     0,     0,     0,
       4,     2,     0,     0,     0,     4,     2,     1,     1,     1,
       1,     3,     6,     2,     2,     1,     3,     1,     3,     4,
       0,     1,     0,     1,     3,     1,     2,     2,     0,     1,
       1,     2,     0,     0,    11,     0,     7,     0,     7,     0,
       4,     0,     0,     7,     0,     2,     1,     2,     0,     1,
       6,     1,     4,     2,     1,     1,     1,     0,     7,     5,
       5,     3,     7,     3,     6,     3,     4,     4,     4,     4,
       4,     4,     3,     3,     3,     3,     3,     3,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     3,     3,     4,     4,
       3,     5,     5,     5,     1,     3,     1,     1,     2,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = FRONTEND_VERILOG_YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == FRONTEND_VERILOG_YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use FRONTEND_VERILOG_YYerror or FRONTEND_VERILOG_YYUNDEF. */
#define YYERRCODE FRONTEND_VERILOG_YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if FRONTEND_VERILOG_YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !FRONTEND_VERILOG_YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !FRONTEND_VERILOG_YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if FRONTEND_VERILOG_YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          goto yyexhaustedlab;                                          \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if FRONTEND_VERILOG_YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if FRONTEND_VERILOG_YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = FRONTEND_VERILOG_YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == FRONTEND_VERILOG_YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc);
    }

  if (yychar <= FRONTEND_VERILOG_YYEOF)
    {
      yychar = FRONTEND_VERILOG_YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == FRONTEND_VERILOG_YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = FRONTEND_VERILOG_YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      YY_LAC_ESTABLISH;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = FRONTEND_VERILOG_YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 2: /* $@1: %empty  */
#line 328 "frontends/verilog/verilog_parser.y"
       {
	ast_stack.clear();
	ast_stack.push_back(current_ast);
}
#line 3627 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 3: /* input: $@1 design  */
#line 331 "frontends/verilog/verilog_parser.y"
         {
	ast_stack.pop_back();
	log_assert(GetSize(ast_stack) == 0);
	for (auto &it : default_attr_list)
		delete it.second;
	default_attr_list.clear();
}
#line 3639 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 13: /* $@2: %empty  */
#line 351 "frontends/verilog/verilog_parser.y"
        {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			(*attr_list)[it.first] = it.second->clone();
	}
#line 3651 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 14: /* attr: $@2 attr_opt  */
#line 357 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.al) = attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3664 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 15: /* attr_opt: attr_opt ATTR_BEGIN opt_attr_list ATTR_END  */
#line 367 "frontends/verilog/verilog_parser.y"
                                                   {
		SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc));
	}
#line 3672 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 17: /* $@3: %empty  */
#line 373 "frontends/verilog/verilog_parser.y"
                      {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			delete it.second;
		default_attr_list.clear();
	}
#line 3685 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 18: /* $@4: %empty  */
#line 380 "frontends/verilog/verilog_parser.y"
                        {
		attr_list->swap(default_attr_list);
		delete attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3699 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 24: /* attr_assign: hierarchical_id  */
#line 398 "frontends/verilog/verilog_parser.y"
                        {
		if (attr_list->count(*(yyvsp[0].string)) != 0)
			delete (*attr_list)[*(yyvsp[0].string)];
		(*attr_list)[*(yyvsp[0].string)] = AstNode::mkconst_int(1, false);
		delete (yyvsp[0].string);
	}
#line 3710 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 25: /* attr_assign: hierarchical_id '=' expr  */
#line 404 "frontends/verilog/verilog_parser.y"
                                 {
		if (attr_list->count(*(yyvsp[-2].string)) != 0)
			delete (*attr_list)[*(yyvsp[-2].string)];
		(*attr_list)[*(yyvsp[-2].string)] = (yyvsp[0].ast);
		delete (yyvsp[-2].string);
	}
#line 3721 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 26: /* hierarchical_id: TOK_ID  */
#line 412 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = (yyvsp[0].string);
	}
#line 3729 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 27: /* hierarchical_id: hierarchical_id TOK_PACKAGESEP TOK_ID  */
#line 415 "frontends/verilog/verilog_parser.y"
                                              {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "::" + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "::" + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3742 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 28: /* hierarchical_id: hierarchical_id '.' TOK_ID  */
#line 423 "frontends/verilog/verilog_parser.y"
                                   {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "." + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "." + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3755 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 31: /* hierarchical_type_id: '(' TOK_USER_TYPE ')'  */
#line 435 "frontends/verilog/verilog_parser.y"
                                { (yyval.string) = (yyvsp[-1].string); }
#line 3761 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 32: /* $@5: %empty  */
#line 439 "frontends/verilog/verilog_parser.y"
                        {
		enterTypeScope();
	}
#line 3769 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 33: /* $@6: %empty  */
#line 441 "frontends/verilog/verilog_parser.y"
                 {
		do_not_require_port_stubs = false;
		AstNode *mod = new AstNode(AST_MODULE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		port_stubs.clear();
		port_counter = 0;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
		delete (yyvsp[0].string);
	}
#line 3786 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 34: /* module: attr TOK_MODULE $@5 TOK_ID $@6 module_para_opt module_args_opt ';' module_body TOK_ENDMODULE opt_label  */
#line 452 "frontends/verilog/verilog_parser.y"
                                                                                  {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
					port_stubs.begin()->first.c_str());
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-9]), (yyloc));
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		current_ast_mod = NULL;
		exitTypeScope();
	}
#line 3801 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 35: /* $@7: %empty  */
#line 464 "frontends/verilog/verilog_parser.y"
                { astbuf1 = nullptr; }
#line 3807 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 36: /* $@8: %empty  */
#line 464 "frontends/verilog/verilog_parser.y"
                                                        { if (astbuf1) delete astbuf1; }
#line 3813 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 42: /* $@9: %empty  */
#line 471 "frontends/verilog/verilog_parser.y"
                           {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 3824 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 44: /* $@10: %empty  */
#line 477 "frontends/verilog/verilog_parser.y"
                            {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 3835 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 54: /* module_arg_opt_assignment: '=' expr  */
#line 495 "frontends/verilog/verilog_parser.y"
                 {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			AstNode *wire = new AstNode(AST_IDENTIFIER);
			wire->str = ast_stack.back()->children.back()->str;
			if (ast_stack.back()->children.back()->is_input) {
				AstNode *n = ast_stack.back()->children.back();
				if (n->attributes.count(ID::defaultvalue))
					delete n->attributes.at(ID::defaultvalue);
				n->attributes[ID::defaultvalue] = (yyvsp[0].ast);
			} else
			if (ast_stack.back()->children.back()->is_reg || ast_stack.back()->children.back()->is_logic)
				ast_stack.back()->children.push_back(new AstNode(AST_INITIAL, new AstNode(AST_BLOCK, new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast)))));
			else
				ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast)));
		} else
			frontend_verilog_yyerror("SystemVerilog interface in module port list cannot have a default value.");
	}
#line 3857 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 56: /* $@11: %empty  */
#line 515 "frontends/verilog/verilog_parser.y"
               {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			AstNode *node = ast_stack.back()->children.back()->clone();
			node->str = *(yyvsp[0].string);
			node->port_id = ++port_counter;
			ast_stack.back()->children.push_back(node);
			SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		} else {
			if (port_stubs.count(*(yyvsp[0].string)) != 0)
				frontend_verilog_yyerror("Duplicate module port `%s'.", (yyvsp[0].string)->c_str());
			port_stubs[*(yyvsp[0].string)] = ++port_counter;
		}
		delete (yyvsp[0].string);
	}
#line 3876 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 58: /* $@12: %empty  */
#line 529 "frontends/verilog/verilog_parser.y"
               {
		astbuf1 = new AstNode(AST_INTERFACEPORT);
		astbuf1->children.push_back(new AstNode(AST_INTERFACEPORTTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 3887 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 59: /* $@13: %empty  */
#line 534 "frontends/verilog/verilog_parser.y"
                 {  /* SV interfaces */
		if (!sv_mode)
			frontend_verilog_yyerror("Interface found in port list (%s). This is not supported unless read_verilog is called with -sv!", (yyvsp[0].string)->c_str());
		astbuf2 = astbuf1->clone(); // really only needed if multiple instances of same type.
		astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		astbuf2->port_id = ++port_counter;
		ast_stack.back()->children.push_back(astbuf2);
		delete astbuf1; // really only needed if multiple instances of same type.
	}
#line 3902 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 61: /* $@14: %empty  */
#line 544 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = (yyvsp[-2].ast);
		node->str = *(yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->port_id = ++port_counter;
		AstNode *range = checkRange(node, (yyvsp[-1].ast));
		if (range != NULL)
			node->children.push_back(range);
		if (!node->is_input && !node->is_output)
			frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[0].string)->c_str());
		if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
			frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[0].string)->c_str());
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		delete (yyvsp[0].string);
	}
#line 3923 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 63: /* module_arg: '.' '.' '.'  */
#line 560 "frontends/verilog/verilog_parser.y"
                    {
		do_not_require_port_stubs = true;
	}
#line 3931 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 64: /* $@15: %empty  */
#line 565 "frontends/verilog/verilog_parser.y"
                         {
		enterTypeScope();
	}
#line 3939 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 65: /* $@16: %empty  */
#line 567 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *mod = new AstNode(AST_PACKAGE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
	}
#line 3952 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 66: /* package: attr TOK_PACKAGE $@15 TOK_ID $@16 ';' package_body TOK_ENDPACKAGE opt_label  */
#line 574 "frontends/verilog/verilog_parser.y"
                                                    {
		ast_stack.pop_back();
		current_ast_mod = NULL;
		exitTypeScope();
	}
#line 3962 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 72: /* $@17: %empty  */
#line 587 "frontends/verilog/verilog_parser.y"
                      {
		enterTypeScope();
	}
#line 3970 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 73: /* $@18: %empty  */
#line 589 "frontends/verilog/verilog_parser.y"
                 {
		do_not_require_port_stubs = false;
		AstNode *intf = new AstNode(AST_INTERFACE);
		ast_stack.back()->children.push_back(intf);
		ast_stack.push_back(intf);
		current_ast_mod = intf;
		port_stubs.clear();
		port_counter = 0;
		intf->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 3986 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 74: /* interface: TOK_INTERFACE $@17 TOK_ID $@18 module_para_opt module_args_opt ';' interface_body TOK_ENDINTERFACE  */
#line 599 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
				port_stubs.begin()->first.c_str());
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		current_ast_mod = NULL;
		exitTypeScope();
	}
#line 4000 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 85: /* mintypmax_expr: expr  */
#line 617 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 4006 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 86: /* mintypmax_expr: expr ':' expr ':' expr  */
#line 618 "frontends/verilog/verilog_parser.y"
                               { delete (yyvsp[-4].ast); delete (yyvsp[-2].ast); delete (yyvsp[0].ast); }
#line 4012 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 87: /* non_opt_delay: '#' TOK_ID  */
#line 621 "frontends/verilog/verilog_parser.y"
                   { delete (yyvsp[0].string); }
#line 4018 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 88: /* non_opt_delay: '#' TOK_CONSTVAL  */
#line 622 "frontends/verilog/verilog_parser.y"
                         { delete (yyvsp[0].string); }
#line 4024 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 89: /* non_opt_delay: '#' TOK_REALVAL  */
#line 623 "frontends/verilog/verilog_parser.y"
                        { delete (yyvsp[0].string); }
#line 4030 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 95: /* $@19: %empty  */
#line 632 "frontends/verilog/verilog_parser.y"
        { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4036 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 96: /* io_wire_type: $@19 wire_type_token_io wire_type_const_rand opt_wire_type_token wire_type_signedness  */
#line 634 "frontends/verilog/verilog_parser.y"
        { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-3]), (yyloc)); }
#line 4042 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 97: /* $@20: %empty  */
#line 637 "frontends/verilog/verilog_parser.y"
        { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4048 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 98: /* non_io_wire_type: $@20 wire_type_const_rand wire_type_token wire_type_signedness  */
#line 639 "frontends/verilog/verilog_parser.y"
        { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc)); }
#line 4054 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 101: /* wire_type_token_io: TOK_INPUT  */
#line 646 "frontends/verilog/verilog_parser.y"
                  {
		astbuf3->is_input = true;
	}
#line 4062 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 102: /* wire_type_token_io: TOK_OUTPUT  */
#line 649 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->is_output = true;
	}
#line 4070 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 103: /* wire_type_token_io: TOK_INOUT  */
#line 652 "frontends/verilog/verilog_parser.y"
                  {
		astbuf3->is_input = true;
		astbuf3->is_output = true;
	}
#line 4079 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 104: /* wire_type_signedness: TOK_SIGNED  */
#line 658 "frontends/verilog/verilog_parser.y"
                     { astbuf3->is_signed = true;  }
#line 4085 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 105: /* wire_type_signedness: TOK_UNSIGNED  */
#line 659 "frontends/verilog/verilog_parser.y"
                     { astbuf3->is_signed = false; }
#line 4091 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 107: /* wire_type_const_rand: TOK_RAND TOK_CONST  */
#line 663 "frontends/verilog/verilog_parser.y"
                           {
	    current_wire_rand = true;
	    current_wire_const = true;
	}
#line 4100 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 108: /* wire_type_const_rand: TOK_CONST  */
#line 667 "frontends/verilog/verilog_parser.y"
                  {
	    current_wire_const = true;
	}
#line 4108 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 109: /* wire_type_const_rand: TOK_RAND  */
#line 670 "frontends/verilog/verilog_parser.y"
                 {
	    current_wire_rand = true;
	}
#line 4116 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 113: /* wire_type_token: hierarchical_type_id  */
#line 679 "frontends/verilog/verilog_parser.y"
                             {
		astbuf3->is_custom_type = true;
		astbuf3->children.push_back(new AstNode(AST_WIRETYPE));
		astbuf3->children.back()->str = *(yyvsp[0].string);
	}
#line 4126 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 114: /* wire_type_token: TOK_WOR  */
#line 684 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_wor = true;
	}
#line 4134 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 115: /* wire_type_token: TOK_WAND  */
#line 687 "frontends/verilog/verilog_parser.y"
                 {
		astbuf3->is_wand = true;
	}
#line 4142 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 116: /* wire_type_token: TOK_WIRE  */
#line 691 "frontends/verilog/verilog_parser.y"
                 {
	}
#line 4149 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 117: /* wire_type_token: TOK_WIRE logic_type  */
#line 693 "frontends/verilog/verilog_parser.y"
                            {
	}
#line 4156 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 118: /* wire_type_token: TOK_REG  */
#line 696 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_reg = true;
	}
#line 4164 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 119: /* wire_type_token: TOK_VAR TOK_REG  */
#line 699 "frontends/verilog/verilog_parser.y"
                        {
		astbuf3->is_reg = true;
	}
#line 4172 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 120: /* wire_type_token: TOK_VAR  */
#line 703 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_logic = true;
	}
#line 4180 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 121: /* wire_type_token: TOK_VAR logic_type  */
#line 706 "frontends/verilog/verilog_parser.y"
                           {
		astbuf3->is_logic = true;
	}
#line 4188 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 122: /* wire_type_token: logic_type  */
#line 709 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->is_logic = true;
	}
#line 4196 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 123: /* wire_type_token: TOK_GENVAR  */
#line 712 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->type = AST_GENVAR;
		astbuf3->is_reg = true;
		astbuf3->is_signed = true;
		astbuf3->range_left = 31;
		astbuf3->range_right = 0;
	}
#line 4208 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 124: /* logic_type: TOK_LOGIC  */
#line 721 "frontends/verilog/verilog_parser.y"
                  {
	}
#line 4215 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 125: /* logic_type: integer_atom_type  */
#line 723 "frontends/verilog/verilog_parser.y"
                          {
		astbuf3->range_left = (yyvsp[0].integer) - 1;
		astbuf3->range_right = 0;
		astbuf3->is_signed = true;
	}
#line 4225 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 126: /* integer_atom_type: TOK_INTEGER  */
#line 730 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 32; }
#line 4231 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 127: /* integer_atom_type: TOK_INT  */
#line 731 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 32; }
#line 4237 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 128: /* integer_atom_type: TOK_SHORTINT  */
#line 732 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 16; }
#line 4243 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 129: /* integer_atom_type: TOK_LONGINT  */
#line 733 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 64; }
#line 4249 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 130: /* integer_atom_type: TOK_BYTE  */
#line 734 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) =  8; }
#line 4255 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 131: /* non_opt_range: '[' expr ':' expr ']'  */
#line 737 "frontends/verilog/verilog_parser.y"
                              {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-3].ast));
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4265 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 132: /* non_opt_range: '[' expr TOK_POS_INDEXED expr ']'  */
#line 742 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), (yyvsp[-1].ast)), AstNode::mkconst_int(1, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
	}
#line 4276 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 133: /* non_opt_range: '[' expr TOK_NEG_INDEXED expr ']'  */
#line 748 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), AstNode::mkconst_int(1, true)), (yyvsp[-1].ast)));
	}
#line 4287 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 134: /* non_opt_range: '[' expr ']'  */
#line 754 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4296 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 135: /* non_opt_multirange: non_opt_range non_opt_range  */
#line 760 "frontends/verilog/verilog_parser.y"
                                    {
		(yyval.ast) = new AstNode(AST_MULTIRANGE, (yyvsp[-1].ast), (yyvsp[0].ast));
	}
#line 4304 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 136: /* non_opt_multirange: non_opt_multirange non_opt_range  */
#line 763 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = (yyvsp[-1].ast);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 4313 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 137: /* range: non_opt_range  */
#line 769 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 4321 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 138: /* range: %empty  */
#line 772 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = NULL;
	}
#line 4329 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 139: /* range_or_multirange: range  */
#line 777 "frontends/verilog/verilog_parser.y"
              { (yyval.ast) = (yyvsp[0].ast); }
#line 4335 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 140: /* range_or_multirange: non_opt_multirange  */
#line 778 "frontends/verilog/verilog_parser.y"
                           { (yyval.ast) = (yyvsp[0].ast); }
#line 4341 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 164: /* $@21: %empty  */
#line 794 "frontends/verilog/verilog_parser.y"
                               {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = *(yyvsp[-1].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 4352 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 165: /* checker_decl: TOK_CHECKER TOK_ID ';' $@21 module_body TOK_ENDCHECKER  */
#line 799 "frontends/verilog/verilog_parser.y"
                                     {
		delete (yyvsp[-4].string);
		ast_stack.pop_back();
	}
#line 4361 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 166: /* $@22: %empty  */
#line 805 "frontends/verilog/verilog_parser.y"
                                            {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[0].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4374 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 167: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID TOK_ID $@22 opt_dpi_function_args ';'  */
#line 812 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4382 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 168: /* $@23: %empty  */
#line 815 "frontends/verilog/verilog_parser.y"
                                                       {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-3].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-5].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4396 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 169: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID '=' TOK_ID TOK_ID $@23 opt_dpi_function_args ';'  */
#line 823 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4404 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 170: /* $@24: %empty  */
#line 826 "frontends/verilog/verilog_parser.y"
                                                                  {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-5].string) + ":" + RTLIL::unescape_id(*(yyvsp[-3].string))));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-7].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-5].string);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4419 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 171: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID ':' TOK_ID '=' TOK_ID TOK_ID $@24 opt_dpi_function_args ';'  */
#line 835 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4427 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 172: /* $@25: %empty  */
#line 838 "frontends/verilog/verilog_parser.y"
                                           {
		current_function_or_task = new AstNode(AST_TASK);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4441 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 173: /* task_func_decl: attr TOK_TASK opt_automatic TOK_ID $@25 task_func_args_opt ';' task_func_body TOK_ENDTASK  */
#line 846 "frontends/verilog/verilog_parser.y"
                                                            {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4450 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 174: /* $@26: %empty  */
#line 850 "frontends/verilog/verilog_parser.y"
                                                                {
		current_function_or_task = new AstNode(AST_FUNCTION);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-4].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		AstNode *outreg = new AstNode(AST_WIRE);
		outreg->str = *(yyvsp[0].string);
		outreg->is_signed = false;
		outreg->is_reg = true;
		if ((yyvsp[-1].ast) != NULL) {
			outreg->children.push_back((yyvsp[-1].ast));
			outreg->is_signed = (yyvsp[-1].ast)->is_signed;
			(yyvsp[-1].ast)->is_signed = false;
		}
		current_function_or_task->children.push_back(outreg);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4474 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 175: /* task_func_decl: attr TOK_FUNCTION opt_automatic func_return_type TOK_ID $@26 task_func_args_opt ';' task_func_body TOK_ENDFUNCTION  */
#line 868 "frontends/verilog/verilog_parser.y"
                                                                {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4483 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 176: /* func_return_type: opt_type_vec opt_signedness_default_unsigned  */
#line 874 "frontends/verilog/verilog_parser.y"
                                                     {
		(yyval.ast) = makeRange(0, 0, (yyvsp[0].boolean));
	}
#line 4491 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 177: /* func_return_type: opt_type_vec opt_signedness_default_unsigned non_opt_range  */
#line 877 "frontends/verilog/verilog_parser.y"
                                                                   {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->is_signed = (yyvsp[-1].boolean);
	}
#line 4500 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 178: /* func_return_type: integer_atom_type opt_signedness_default_signed  */
#line 881 "frontends/verilog/verilog_parser.y"
                                                        {
		(yyval.ast) = makeRange((yyvsp[-1].integer) - 1, 0, (yyvsp[0].boolean));
	}
#line 4508 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 182: /* opt_signedness_default_signed: %empty  */
#line 892 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4514 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 183: /* opt_signedness_default_signed: TOK_SIGNED  */
#line 893 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4520 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 184: /* opt_signedness_default_signed: TOK_UNSIGNED  */
#line 894 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4526 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 185: /* opt_signedness_default_unsigned: %empty  */
#line 897 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4532 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 186: /* opt_signedness_default_unsigned: TOK_SIGNED  */
#line 898 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4538 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 187: /* opt_signedness_default_unsigned: TOK_UNSIGNED  */
#line 899 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4544 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 188: /* dpi_function_arg: TOK_ID TOK_ID  */
#line 903 "frontends/verilog/verilog_parser.y"
                      {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[-1].string)));
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4554 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 189: /* dpi_function_arg: TOK_ID  */
#line 908 "frontends/verilog/verilog_parser.y"
               {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[0].string)));
		delete (yyvsp[0].string);
	}
#line 4563 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 200: /* $@27: %empty  */
#line 928 "frontends/verilog/verilog_parser.y"
                               {
		albuf = nullptr;
		astbuf1 = nullptr;
		astbuf2 = nullptr;
	}
#line 4573 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 201: /* $@28: %empty  */
#line 932 "frontends/verilog/verilog_parser.y"
                                        {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 4584 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 205: /* $@29: %empty  */
#line 943 "frontends/verilog/verilog_parser.y"
                             {
		bool prev_was_input = true;
		bool prev_was_output = false;
		if (albuf) {
			prev_was_input = astbuf1->is_input;
			prev_was_output = astbuf1->is_output;
			delete astbuf1;
			if (astbuf2 != NULL)
				delete astbuf2;
			free_attr(albuf);
		}
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
		if (!astbuf1->is_input && !astbuf1->is_output) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			astbuf1->is_input = prev_was_input;
			astbuf1->is_output = prev_was_output;
		}
	}
#line 4610 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 207: /* $@30: %empty  */
#line 964 "frontends/verilog/verilog_parser.y"
        {
		if (!astbuf1) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			albuf = new dict<IdString, AstNode*>;
			astbuf1 = new AstNode(AST_WIRE);
			current_wire_rand = false;
			current_wire_const = false;
			astbuf1->is_input = true;
			astbuf2 = NULL;
		}
	}
#line 4627 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 214: /* specify_item: specify_if '(' specify_edge expr TOK_SPECIFY_OPER specify_target ')' '=' specify_rise_fall ';'  */
#line 991 "frontends/verilog/verilog_parser.y"
                                                                                                       {
		AstNode *en_expr = (yyvsp[-9].ast);
		char specify_edge = (yyvsp[-7].ch);
		AstNode *src_expr = (yyvsp[-6].ast);
		string *oper = (yyvsp[-5].string);
		specify_target *target = (yyvsp[-4].specify_target_ptr);
		specify_rise_fall *timing = (yyvsp[-1].specify_rise_fall_ptr);

		if (specify_edge != 0 && target->dat == nullptr)
			frontend_verilog_yyerror("Found specify edge but no data spec.\n");

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = target->dat ? "$specify3" : "$specify2";
		SET_AST_NODE_LOC(cell, en_expr ? (yylsp[-9]) : (yylsp[-8]), (yylsp[0]));

		char oper_polarity = 0;
		char oper_type = oper->at(0);

		if (oper->size() == 3) {
			oper_polarity = oper->at(0);
			oper_type = oper->at(1);
		}

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_type == '*', false, 1)));
		cell->children.back()->str = "\\FULL";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity != 0, false, 1)));
		cell->children.back()->str = "\\SRC_DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity == '+', false, 1)));
		cell->children.back()->str = "\\SRC_DST_POL";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_min));
		cell->children.back()->str = "\\T_RISE_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_avg));
		cell->children.back()->str = "\\T_RISE_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_max));
		cell->children.back()->str = "\\T_RISE_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_min));
		cell->children.back()->str = "\\T_FALL_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_avg));
		cell->children.back()->str = "\\T_FALL_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_max));
		cell->children.back()->str = "\\T_FALL_MAX";

		cell->children.push_back(new AstNode(AST_ARGUMENT, en_expr ? en_expr : AstNode::mkconst_int(1, false, 1)));
		cell->children.back()->str = "\\EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, target->dst));
		cell->children.back()->str = "\\DST";

		if (target->dat)
		{
			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge != 0, false, 1)));
			cell->children.back()->str = "\\EDGE_EN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge == 'p', false, 1)));
			cell->children.back()->str = "\\EDGE_POL";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op != 0, false, 1)));
			cell->children.back()->str = "\\DAT_DST_PEN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op == '+', false, 1)));
			cell->children.back()->str = "\\DAT_DST_POL";

			cell->children.push_back(new AstNode(AST_ARGUMENT, target->dat));
			cell->children.back()->str = "\\DAT";
		}

		delete oper;
		delete target;
		delete timing;
	}
#line 4716 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 215: /* specify_item: TOK_ID '(' specify_edge expr specify_condition ',' specify_edge expr specify_condition ',' specify_triple specify_opt_triple ')' ';'  */
#line 1075 "frontends/verilog/verilog_parser.y"
                                                                                                                                             {
		if (*(yyvsp[-13].string) != "$setup" && *(yyvsp[-13].string) != "$hold" && *(yyvsp[-13].string) != "$setuphold" && *(yyvsp[-13].string) != "$removal" && *(yyvsp[-13].string) != "$recovery" &&
				*(yyvsp[-13].string) != "$recrem" && *(yyvsp[-13].string) != "$skew" && *(yyvsp[-13].string) != "$timeskew" && *(yyvsp[-13].string) != "$fullskew" && *(yyvsp[-13].string) != "$nochange")
			frontend_verilog_yyerror("Unsupported specify rule type: %s\n", (yyvsp[-13].string)->c_str());

		AstNode *src_pen = AstNode::mkconst_int((yyvsp[-11].ch) != 0, false, 1);
		AstNode *src_pol = AstNode::mkconst_int((yyvsp[-11].ch) == 'p', false, 1);
		AstNode *src_expr = (yyvsp[-10].ast), *src_en = (yyvsp[-9].ast) ? (yyvsp[-9].ast) : AstNode::mkconst_int(1, false, 1);

		AstNode *dst_pen = AstNode::mkconst_int((yyvsp[-7].ch) != 0, false, 1);
		AstNode *dst_pol = AstNode::mkconst_int((yyvsp[-7].ch) == 'p', false, 1);
		AstNode *dst_expr = (yyvsp[-6].ast), *dst_en = (yyvsp[-5].ast) ? (yyvsp[-5].ast) : AstNode::mkconst_int(1, false, 1);

		specify_triple *limit = (yyvsp[-3].specify_triple_ptr);
		specify_triple *limit2 = (yyvsp[-2].specify_triple_ptr);

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = "$specrule";
		SET_AST_NODE_LOC(cell, (yylsp[-13]), (yylsp[0]));

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_str(*(yyvsp[-13].string))));
		cell->children.back()->str = "\\TYPE";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_min));
		cell->children.back()->str = "\\T_LIMIT_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_avg));
		cell->children.back()->str = "\\T_LIMIT_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_max));
		cell->children.back()->str = "\\T_LIMIT_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_min : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_avg : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_max : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, src_pen));
		cell->children.back()->str = "\\SRC_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, src_pol));
		cell->children.back()->str = "\\SRC_POL";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pen));
		cell->children.back()->str = "\\DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pol));
		cell->children.back()->str = "\\DST_POL";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_en));
		cell->children.back()->str = "\\SRC_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_en));
		cell->children.back()->str = "\\DST_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_expr));
		cell->children.back()->str = "\\DST";

		delete (yyvsp[-13].string);
	}
#line 4791 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 216: /* specify_opt_triple: ',' specify_triple  */
#line 1147 "frontends/verilog/verilog_parser.y"
                           {
		(yyval.specify_triple_ptr) = (yyvsp[0].specify_triple_ptr);
	}
#line 4799 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 217: /* specify_opt_triple: %empty  */
#line 1150 "frontends/verilog/verilog_parser.y"
               {
		(yyval.specify_triple_ptr) = nullptr;
	}
#line 4807 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 218: /* specify_if: TOK_IF '(' expr ')'  */
#line 1155 "frontends/verilog/verilog_parser.y"
                            {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 4815 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 219: /* specify_if: %empty  */
#line 1158 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = nullptr;
	}
#line 4823 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 220: /* specify_condition: TOK_SPECIFY_AND expr  */
#line 1163 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 4831 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 221: /* specify_condition: %empty  */
#line 1166 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = nullptr;
	}
#line 4839 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 222: /* specify_target: expr  */
#line 1171 "frontends/verilog/verilog_parser.y"
             {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[0].ast);
		(yyval.specify_target_ptr)->dat = nullptr;
	}
#line 4850 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 223: /* specify_target: '(' expr ':' expr ')'  */
#line 1177 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 4861 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 224: /* specify_target: '(' expr TOK_NEG_INDEXED expr ')'  */
#line 1183 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '-';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 4872 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 225: /* specify_target: '(' expr TOK_POS_INDEXED expr ')'  */
#line 1189 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '+';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 4883 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 226: /* specify_edge: TOK_POSEDGE  */
#line 1197 "frontends/verilog/verilog_parser.y"
                    { (yyval.ch) = 'p'; }
#line 4889 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 227: /* specify_edge: TOK_NEGEDGE  */
#line 1198 "frontends/verilog/verilog_parser.y"
                    { (yyval.ch) = 'n'; }
#line 4895 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 228: /* specify_edge: %empty  */
#line 1199 "frontends/verilog/verilog_parser.y"
               { (yyval.ch) = 0; }
#line 4901 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 229: /* specify_rise_fall: specify_triple  */
#line 1202 "frontends/verilog/verilog_parser.y"
                       {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[0].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall.t_min = (yyvsp[0].specify_triple_ptr)->t_min->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_avg = (yyvsp[0].specify_triple_ptr)->t_avg->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_max = (yyvsp[0].specify_triple_ptr)->t_max->clone();
		delete (yyvsp[0].specify_triple_ptr);
	}
#line 4914 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 230: /* specify_rise_fall: '(' specify_triple ',' specify_triple ')'  */
#line 1210 "frontends/verilog/verilog_parser.y"
                                                  {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-3].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-1].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
	}
#line 4926 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 231: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1217 "frontends/verilog/verilog_parser.y"
                                                                     {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-5].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 4940 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 232: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1226 "frontends/verilog/verilog_parser.y"
                                                                                                                              {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-11].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 4957 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 233: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1238 "frontends/verilog/verilog_parser.y"
                                                                                                                                                                                                                                                {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-23].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-23].specify_triple_ptr);
		delete (yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-19].specify_triple_ptr);
		delete (yyvsp[-17].specify_triple_ptr);
		delete (yyvsp[-15].specify_triple_ptr);
		delete (yyvsp[-13].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 4980 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 234: /* specify_triple: expr  */
#line 1258 "frontends/verilog/verilog_parser.y"
             {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[0].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[0].ast)->clone();
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast)->clone();
	}
#line 4991 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 235: /* specify_triple: expr ':' expr ':' expr  */
#line 1264 "frontends/verilog/verilog_parser.y"
                               {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[-4].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[-2].ast);
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast);
	}
#line 5002 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 285: /* ignspec_constant_expression: expr  */
#line 1385 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 5008 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 286: /* ignspec_expr: expr  */
#line 1388 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 5014 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 287: /* ignspec_expr: expr ':' expr ':' expr  */
#line 1389 "frontends/verilog/verilog_parser.y"
                               {
		delete (yyvsp[-4].ast);
		delete (yyvsp[-2].ast);
		delete (yyvsp[0].ast);
	}
#line 5024 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 288: /* $@31: %empty  */
#line 1396 "frontends/verilog/verilog_parser.y"
               { delete (yyvsp[0].string); }
#line 5030 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 289: /* ignspec_id: TOK_ID $@31 range_or_multirange  */
#line 1397 "frontends/verilog/verilog_parser.y"
                            { delete (yyvsp[0].ast); }
#line 5036 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 290: /* param_signed: TOK_SIGNED  */
#line 1402 "frontends/verilog/verilog_parser.y"
                   {
		astbuf1->is_signed = true;
	}
#line 5044 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 291: /* param_signed: TOK_UNSIGNED  */
#line 1404 "frontends/verilog/verilog_parser.y"
                         {
		astbuf1->is_signed = false;
	}
#line 5052 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 293: /* param_integer: type_atom  */
#line 1409 "frontends/verilog/verilog_parser.y"
                  {
		astbuf1->is_reg = false;
	}
#line 5060 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 294: /* param_real: TOK_REAL  */
#line 1414 "frontends/verilog/verilog_parser.y"
                 {
		astbuf1->children.push_back(new AstNode(AST_REALVALUE));
	}
#line 5068 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 295: /* param_range: range  */
#line 1419 "frontends/verilog/verilog_parser.y"
              {
		if ((yyvsp[0].ast) != NULL) {
			astbuf1->children.push_back((yyvsp[0].ast));
		}
	}
#line 5078 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 297: /* param_range_type: type_vec param_signed  */
#line 1427 "frontends/verilog/verilog_parser.y"
                              {
		addRange(astbuf1, 0, 0);
	}
#line 5086 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 298: /* param_range_type: type_vec param_signed non_opt_range  */
#line 1430 "frontends/verilog/verilog_parser.y"
                                            {
		astbuf1->children.push_back((yyvsp[0].ast));
	}
#line 5094 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 304: /* param_type: hierarchical_type_id  */
#line 1437 "frontends/verilog/verilog_parser.y"
                             {
		astbuf1->is_custom_type = true;
		astbuf1->children.push_back(new AstNode(AST_WIRETYPE));
		astbuf1->children.back()->str = *(yyvsp[0].string);
	}
#line 5104 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 305: /* $@32: %empty  */
#line 1444 "frontends/verilog/verilog_parser.y"
                           {
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5114 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 306: /* param_decl: attr TOK_PARAMETER $@32 param_type param_decl_list ';'  */
#line 1448 "frontends/verilog/verilog_parser.y"
                                         {
		delete astbuf1;
	}
#line 5122 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 307: /* $@33: %empty  */
#line 1453 "frontends/verilog/verilog_parser.y"
                            {
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5132 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 308: /* localparam_decl: attr TOK_LOCALPARAM $@33 param_type param_decl_list ';'  */
#line 1457 "frontends/verilog/verilog_parser.y"
                                         {
		delete astbuf1;
	}
#line 5140 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 311: /* single_param_decl: single_param_decl_ident '=' expr  */
#line 1465 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *decl = ast_stack.back()->children.back();
		log_assert(decl->type == AST_PARAMETER || decl->type == AST_LOCALPARAM);
		delete decl->children[0];
		decl->children[0] = (yyvsp[0].ast);
	}
#line 5151 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 312: /* single_param_decl: single_param_decl_ident  */
#line 1471 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *decl = ast_stack.back()->children.back();
		if (decl->type != AST_PARAMETER) {
			log_assert(decl->type == AST_LOCALPARAM);
			frontend_verilog_yyerror("localparam initialization is missing!");
		}
		if (!sv_mode)
			frontend_verilog_yyerror("Parameter defaults can only be omitted in SystemVerilog mode!");
		delete decl->children[0];
		decl->children.erase(decl->children.begin());
	}
#line 5167 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 313: /* single_param_decl_ident: TOK_ID  */
#line 1484 "frontends/verilog/verilog_parser.y"
               {
		AstNode *node;
		if (astbuf1 == nullptr) {
			if (!sv_mode)
				frontend_verilog_yyerror("In pure Verilog (not SystemVerilog), parameter/localparam with an initializer must use the parameter/localparam keyword");
			node = new AstNode(AST_PARAMETER);
			node->children.push_back(AstNode::mkconst_int(0, true));
		} else {
			node = astbuf1->clone();
		}
		node->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
	}
#line 5187 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 317: /* single_defparam_decl: range rvalue '=' expr  */
#line 1507 "frontends/verilog/verilog_parser.y"
                              {
		AstNode *node = new AstNode(AST_DEFPARAM);
		node->children.push_back((yyvsp[-2].ast));
		node->children.push_back((yyvsp[0].ast));
		if ((yyvsp[-3].ast) != NULL)
			node->children.push_back((yyvsp[-3].ast));
		ast_stack.back()->children.push_back(node);
	}
#line 5200 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 318: /* $@34: %empty  */
#line 1520 "frontends/verilog/verilog_parser.y"
                    {
		static int enum_count;
		// create parent node for the enum
		astbuf2 = new AstNode(AST_ENUM);
		ast_stack.back()->children.push_back(astbuf2);
		astbuf2->str = std::string("$enum");
		astbuf2->str += std::to_string(enum_count++);
		// create the template for the names
		astbuf1 = new AstNode(AST_ENUM_ITEM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
	 }
#line 5216 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 319: /* enum_type: TOK_ENUM $@34 enum_base_type '{' enum_name_list '}'  */
#line 1530 "frontends/verilog/verilog_parser.y"
                                                 {	// create template for the enum vars
							auto tnode = astbuf1->clone();
							delete astbuf1;
							astbuf1 = tnode;
							tnode->type = AST_WIRE;
							tnode->attributes[ID::enum_type] = AstNode::mkconst_str(astbuf2->str);
							// drop constant but keep any range
							delete tnode->children[0];
							tnode->children.erase(tnode->children.begin());
							(yyval.ast) = astbuf1; }
#line 5231 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 321: /* enum_base_type: type_vec type_signing range  */
#line 1543 "frontends/verilog/verilog_parser.y"
                                        { if ((yyvsp[0].ast)) astbuf1->children.push_back((yyvsp[0].ast)); }
#line 5237 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 322: /* enum_base_type: %empty  */
#line 1544 "frontends/verilog/verilog_parser.y"
                                        { astbuf1->is_reg = true; addRange(astbuf1); }
#line 5243 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 323: /* type_atom: integer_atom_type  */
#line 1548 "frontends/verilog/verilog_parser.y"
                          {
		astbuf1->is_reg = true;
		astbuf1->is_signed = true;
		addRange(astbuf1, (yyvsp[0].integer) - 1, 0);
	}
#line 5253 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 324: /* type_vec: TOK_REG  */
#line 1554 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_reg   = true; }
#line 5259 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 325: /* type_vec: TOK_LOGIC  */
#line 1555 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_logic = true; }
#line 5265 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 326: /* type_signing: TOK_SIGNED  */
#line 1559 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_signed = true; }
#line 5271 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 327: /* type_signing: TOK_UNSIGNED  */
#line 1560 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_signed = false; }
#line 5277 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 331: /* enum_name_decl: TOK_ID opt_enum_init  */
#line 1569 "frontends/verilog/verilog_parser.y"
                             {
		// put in fn
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		delete node->children[0];
		node->children[0] = (yyvsp[0].ast) ? (yyvsp[0].ast) : new AstNode(AST_NONE);
		astbuf2->children.push_back(node);
	}
#line 5294 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 332: /* opt_enum_init: '=' basic_expr  */
#line 1584 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = (yyvsp[0].ast); }
#line 5300 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 333: /* opt_enum_init: %empty  */
#line 1585 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = NULL; }
#line 5306 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 336: /* enum_var: TOK_ID  */
#line 1593 "frontends/verilog/verilog_parser.y"
                 {
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		ast_stack.back()->children.push_back(node);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->is_enum = true;
	}
#line 5321 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 337: /* enum_decl: enum_type enum_var_list ';'  */
#line 1605 "frontends/verilog/verilog_parser.y"
                                                { delete (yyvsp[-2].ast); }
#line 5327 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 338: /* struct_decl: struct_type struct_var_list ';'  */
#line 1612 "frontends/verilog/verilog_parser.y"
                                                { delete astbuf2; }
#line 5333 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 339: /* $@35: %empty  */
#line 1615 "frontends/verilog/verilog_parser.y"
                          { astbuf2 = (yyvsp[0].ast); }
#line 5339 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 340: /* struct_type: struct_union $@35 struct_body  */
#line 1615 "frontends/verilog/verilog_parser.y"
                                                        { (yyval.ast) = astbuf2; }
#line 5345 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 341: /* struct_union: TOK_STRUCT  */
#line 1619 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = new AstNode(AST_STRUCT); }
#line 5351 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 342: /* struct_union: TOK_UNION  */
#line 1620 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = new AstNode(AST_UNION); }
#line 5357 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 345: /* opt_packed: %empty  */
#line 1628 "frontends/verilog/verilog_parser.y"
               { frontend_verilog_yyerror("Only PACKED supported at this time"); }
#line 5363 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 346: /* opt_signed_struct: TOK_SIGNED  */
#line 1631 "frontends/verilog/verilog_parser.y"
                                { astbuf2->is_signed = true; }
#line 5369 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 347: /* opt_signed_struct: TOK_UNSIGNED  */
#line 1632 "frontends/verilog/verilog_parser.y"
                                { astbuf2->is_signed = false; }
#line 5375 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 351: /* struct_member: struct_member_type member_name_list ';'  */
#line 1640 "frontends/verilog/verilog_parser.y"
                                                                { delete astbuf1; }
#line 5381 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 354: /* $@36: %empty  */
#line 1648 "frontends/verilog/verilog_parser.y"
                    {
			astbuf1->str = (yyvsp[0].string)->substr(1);
			delete (yyvsp[0].string);
			astbuf3 = astbuf1->clone();
			SET_AST_NODE_LOC(astbuf3, (yylsp[0]), (yylsp[0]));
			astbuf2->children.push_back(astbuf3);
		}
#line 5393 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 355: /* member_name: TOK_ID $@36 range  */
#line 1654 "frontends/verilog/verilog_parser.y"
                        { if ((yyvsp[0].ast)) astbuf3->children.push_back((yyvsp[0].ast)); }
#line 5399 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 356: /* $@37: %empty  */
#line 1657 "frontends/verilog/verilog_parser.y"
                    { astbuf1 = new AstNode(AST_STRUCT_ITEM); }
#line 5405 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 359: /* member_type_token: hierarchical_type_id  */
#line 1662 "frontends/verilog/verilog_parser.y"
                               {
			// use a clone of the typedef definition nodes
			auto template_node = copyTypeDefinition(*(yyvsp[0].string));
			delete (yyvsp[0].string);
			switch (template_node->type) {
			case AST_WIRE:
				template_node->type = AST_STRUCT_ITEM;
				break;
			case AST_STRUCT:
			case AST_UNION:
				break;
			default:
				frontend_verilog_yyerror("Invalid type for struct member: %s", type2str(template_node->type).c_str());
			}
			delete astbuf1;
			astbuf1 = template_node;
		}
#line 5427 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 360: /* $@38: %empty  */
#line 1679 "frontends/verilog/verilog_parser.y"
                       {
			// stash state on ast_stack
			ast_stack.push_back(astbuf2);
			astbuf2 = (yyvsp[0].ast);
		}
#line 5437 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 361: /* member_type_token: struct_union $@38 struct_body  */
#line 1683 "frontends/verilog/verilog_parser.y"
                               {
		        astbuf1 = astbuf2;
			// recover state
			astbuf2 = ast_stack.back();
			ast_stack.pop_back();
		}
#line 5448 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 363: /* member_type: type_vec type_signing range_or_multirange  */
#line 1692 "frontends/verilog/verilog_parser.y"
                                                        { if ((yyvsp[0].ast)) astbuf1->children.push_back((yyvsp[0].ast)); }
#line 5454 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 366: /* struct_var: TOK_ID  */
#line 1699 "frontends/verilog/verilog_parser.y"
                        {	auto *var_node = astbuf2->clone();
				var_node->str = *(yyvsp[0].string);
				delete (yyvsp[0].string);
				SET_AST_NODE_LOC(var_node, (yylsp[0]), (yylsp[0]));
				ast_stack.back()->children.push_back(var_node);
			}
#line 5465 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 367: /* $@39: %empty  */
#line 1712 "frontends/verilog/verilog_parser.y"
                             {
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
	}
#line 5475 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 368: /* $@40: %empty  */
#line 1716 "frontends/verilog/verilog_parser.y"
                               {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 5486 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 370: /* $@41: %empty  */
#line 1722 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(0, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5499 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 372: /* $@42: %empty  */
#line 1730 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(1, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5512 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 375: /* opt_supply_wires: opt_supply_wires ',' TOK_ID  */
#line 1741 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *wire_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-2)->clone();
		AstNode *assign_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-1)->clone();
		wire_node->str = *(yyvsp[0].string);
		assign_node->children[0]->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(wire_node);
		ast_stack.back()->children.push_back(assign_node);
		delete (yyvsp[0].string);
	}
#line 5526 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 378: /* wire_name_and_opt_assign: wire_name  */
#line 1755 "frontends/verilog/verilog_parser.y"
                  {
		bool attr_anyconst = false;
		bool attr_anyseq = false;
		bool attr_allconst = false;
		bool attr_allseq = false;
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyconst);
			ast_stack.back()->children.back()->attributes.erase(ID::anyconst);
			attr_anyconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyseq);
			ast_stack.back()->children.back()->attributes.erase(ID::anyseq);
			attr_anyseq = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allconst);
			ast_stack.back()->children.back()->attributes.erase(ID::allconst);
			attr_allconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allseq);
			ast_stack.back()->children.back()->attributes.erase(ID::allseq);
			attr_allseq = true;
		}
		if (current_wire_rand || attr_anyconst || attr_anyseq || attr_allconst || attr_allseq) {
			AstNode *wire = new AstNode(AST_IDENTIFIER);
			AstNode *fcall = new AstNode(AST_FCALL);
			wire->str = ast_stack.back()->children.back()->str;
			fcall->str = current_wire_const ? "\\$anyconst" : "\\$anyseq";
			if (attr_anyconst)
				fcall->str = "\\$anyconst";
			if (attr_anyseq)
				fcall->str = "\\$anyseq";
			if (attr_allconst)
				fcall->str = "\\$allconst";
			if (attr_allseq)
				fcall->str = "\\$allseq";
			fcall->attributes[ID::reg] = AstNode::mkconst_str(RTLIL::unescape_id(wire->str));
			ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, fcall));
		}
	}
#line 5573 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 379: /* wire_name_and_opt_assign: wire_name '=' expr  */
#line 1797 "frontends/verilog/verilog_parser.y"
                           {
		AstNode *wire = new AstNode(AST_IDENTIFIER);
		wire->str = ast_stack.back()->children.back()->str;
		if (astbuf1->is_input) {
			if (astbuf1->attributes.count(ID::defaultvalue))
				delete astbuf1->attributes.at(ID::defaultvalue);
			astbuf1->attributes[ID::defaultvalue] = (yyvsp[0].ast);
		}
		else if (astbuf1->is_reg || astbuf1->is_logic){
			AstNode *assign = new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast));
			AstNode *block = new AstNode(AST_BLOCK, assign);
			AstNode *init = new AstNode(AST_INITIAL, block);

			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(block, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(init, (yylsp[-2]), (yylsp[0]));

			ast_stack.back()->children.push_back(init);
		}
		else {
			AstNode *assign = new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast));
			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			ast_stack.back()->children.push_back(assign);
		}

	}
#line 5604 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 380: /* wire_name: TOK_ID range_or_multirange  */
#line 1825 "frontends/verilog/verilog_parser.y"
                                   {
		if (astbuf1 == nullptr)
			frontend_verilog_yyerror("Internal error - should not happen - no AST_WIRE node.");
		AstNode *node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		append_attr_clone(node, albuf);
		if (astbuf2 != NULL)
			node->children.push_back(astbuf2->clone());
		if ((yyvsp[0].ast) != NULL) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("input/output/inout ports cannot have unpacked dimensions.");
			if (!astbuf2 && !node->is_custom_type) {
				addRange(node, 0, 0, false);
			}
			rewriteAsMemoryNode(node, (yyvsp[0].ast));
		}
		if (current_function_or_task) {
			if (node->is_input || node->is_output)
				node->port_id = current_function_or_task_port_id++;
		} else if (ast_stack.back()->type == AST_GENBLOCK) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("Cannot declare module port `%s' within a generate block.", (yyvsp[-1].string)->c_str());
		} else {
			if (do_not_require_port_stubs && (node->is_input || node->is_output) && port_stubs.count(*(yyvsp[-1].string)) == 0) {
				port_stubs[*(yyvsp[-1].string)] = ++port_counter;
			}
			if (port_stubs.count(*(yyvsp[-1].string)) != 0) {
				if (!node->is_input && !node->is_output)
					frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[-1].string)->c_str());
				if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
					frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[-1].string)->c_str());
				node->port_id = port_stubs[*(yyvsp[-1].string)];
				port_stubs.erase(*(yyvsp[-1].string));
			} else {
				if (node->is_input || node->is_output)
					frontend_verilog_yyerror("Module port `%s' is not declared in module header.", (yyvsp[-1].string)->c_str());
			}
		}
		//FIXME: for some reason, TOK_ID has a location which always points to one column *after* the real last column...
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);

		delete (yyvsp[-1].string);
	}
#line 5653 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 384: /* assign_expr: lvalue '=' expr  */
#line 1877 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *node = new AstNode(AST_ASSIGN, (yyvsp[-2].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC(node, (yyloc), (yyloc));
		ast_stack.back()->children.push_back(node);
	}
#line 5663 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 386: /* type_name: TOK_USER_TYPE  */
#line 1884 "frontends/verilog/verilog_parser.y"
                                { if (isInLocalScope((yyvsp[0].string))) frontend_verilog_yyerror("Duplicate declaration of TYPEDEF '%s'", (yyvsp[0].string)->c_str()+1); }
#line 5669 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 387: /* typedef_decl: TOK_TYPEDEF non_io_wire_type range type_name range_or_multirange ';'  */
#line 1888 "frontends/verilog/verilog_parser.y"
                                                                             {
		astbuf1 = (yyvsp[-4].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[-3].ast));
		if (astbuf2)
			astbuf1->children.push_back(astbuf2);

		if ((yyvsp[-1].ast) != NULL) {
			if (!astbuf2) {
				addRange(astbuf1, 0, 0, false);
			}
			rewriteAsMemoryNode(astbuf1, (yyvsp[-1].ast));
		}
		addTypedefNode((yyvsp[-2].string), astbuf1); }
#line 5687 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 388: /* typedef_decl: TOK_TYPEDEF non_wire_data_type type_name ';'  */
#line 1901 "frontends/verilog/verilog_parser.y"
                                                         { addTypedefNode((yyvsp[-1].string), (yyvsp[-2].ast)); }
#line 5693 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 391: /* $@43: %empty  */
#line 1910 "frontends/verilog/verilog_parser.y"
                    {
		astbuf1 = new AstNode(AST_CELL);
		append_attr(astbuf1, (yyvsp[-1].al));
		astbuf1->children.push_back(new AstNode(AST_CELLTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5705 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 392: /* cell_stmt: attr TOK_ID $@43 cell_parameter_list_opt cell_list ';'  */
#line 1916 "frontends/verilog/verilog_parser.y"
                                                {
		delete astbuf1;
	}
#line 5713 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 393: /* $@44: %empty  */
#line 1919 "frontends/verilog/verilog_parser.y"
                                    {
		astbuf1 = new AstNode(AST_PRIMITIVE);
		astbuf1->str = *(yyvsp[-1].string);
		append_attr(astbuf1, (yyvsp[-2].al));
		delete (yyvsp[-1].string);
	}
#line 5724 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 394: /* cell_stmt: attr tok_prim_wrapper delay $@44 prim_list ';'  */
#line 1924 "frontends/verilog/verilog_parser.y"
                        {
		delete astbuf1;
	}
#line 5732 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 395: /* tok_prim_wrapper: TOK_PRIMITIVE  */
#line 1929 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.string) = (yyvsp[0].string);
	}
#line 5740 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 396: /* tok_prim_wrapper: TOK_OR  */
#line 1932 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = new std::string("or");
	}
#line 5748 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 399: /* $@45: %empty  */
#line 1941 "frontends/verilog/verilog_parser.y"
               {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 5760 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 400: /* single_cell: TOK_ID $@45 '(' cell_port_list ')'  */
#line 1947 "frontends/verilog/verilog_parser.y"
                                 {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-4]), (yyloc));
	}
#line 5768 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 401: /* $@46: %empty  */
#line 1950 "frontends/verilog/verilog_parser.y"
                             {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.back()->children.push_back(new AstNode(AST_CELLARRAY, (yyvsp[0].ast), astbuf2));
	}
#line 5780 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 402: /* single_cell: TOK_ID non_opt_range $@46 '(' cell_port_list ')'  */
#line 1956 "frontends/verilog/verilog_parser.y"
                                {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-5]), (yyloc));
	}
#line 5788 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 406: /* $@47: %empty  */
#line 1966 "frontends/verilog/verilog_parser.y"
                      {
		astbuf2 = astbuf1->clone();
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 5797 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 407: /* single_prim: $@47 '(' cell_port_list ')'  */
#line 1969 "frontends/verilog/verilog_parser.y"
                                 {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-3]), (yyloc));
	}
#line 5805 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 413: /* cell_parameter: expr  */
#line 1981 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_PARASET);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 5815 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 414: /* cell_parameter: '.' TOK_ID '(' ')'  */
#line 1986 "frontends/verilog/verilog_parser.y"
                           {
		// just ignore empty parameters
	}
#line 5823 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 415: /* cell_parameter: '.' TOK_ID '(' expr ')'  */
#line 1989 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *node = new AstNode(AST_PARASET);
		node->str = *(yyvsp[-3].string);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
	}
#line 5835 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 416: /* cell_port_list: cell_port_list_rules  */
#line 1998 "frontends/verilog/verilog_parser.y"
                             {
		// remove empty args from end of list
		while (!astbuf2->children.empty()) {
			AstNode *node = astbuf2->children.back();
			if (node->type != AST_ARGUMENT) break;
			if (!node->children.empty()) break;
			if (!node->str.empty()) break;
			astbuf2->children.pop_back();
			delete node;
		}

		// check port types
		bool has_positional_args = false;
		bool has_named_args = false;
		for (auto node : astbuf2->children) {
			if (node->type != AST_ARGUMENT) continue;
			if (node->str.empty())
				has_positional_args = true;
			else
				has_named_args = true;
		}

		if (has_positional_args && has_named_args)
			frontend_verilog_yyerror("Mix of positional and named cell ports.");
	}
#line 5865 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 419: /* cell_port: attr  */
#line 2028 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		free_attr((yyvsp[0].al));
	}
#line 5875 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 420: /* cell_port: attr expr  */
#line 2033 "frontends/verilog/verilog_parser.y"
                  {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
		free_attr((yyvsp[-1].al));
	}
#line 5886 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 421: /* cell_port: attr '.' TOK_ID '(' expr ')'  */
#line 2039 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-3].string);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
		free_attr((yyvsp[-5].al));
	}
#line 5899 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 422: /* cell_port: attr '.' TOK_ID '(' ')'  */
#line 2047 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-2].string);
		astbuf2->children.push_back(node);
		delete (yyvsp[-2].string);
		free_attr((yyvsp[-4].al));
	}
#line 5911 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 423: /* cell_port: attr '.' TOK_ID  */
#line 2054 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[0].string);
		astbuf2->children.push_back(node);
		node->children.push_back(new AstNode(AST_IDENTIFIER));
		node->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		free_attr((yyvsp[-2].al));
	}
#line 5925 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 424: /* cell_port: attr TOK_WILDCARD_CONNECT  */
#line 2063 "frontends/verilog/verilog_parser.y"
                                  {
		if (!sv_mode)
			frontend_verilog_yyerror("Wildcard port connections are only supported in SystemVerilog mode.");
		astbuf2->attributes[ID::wildcard_port_conns] = AstNode::mkconst_int(1, false);
	}
#line 5935 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 425: /* always_comb_or_latch: TOK_ALWAYS_COMB  */
#line 2070 "frontends/verilog/verilog_parser.y"
                        {
		(yyval.boolean) = false;
	}
#line 5943 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 426: /* always_comb_or_latch: TOK_ALWAYS_LATCH  */
#line 2073 "frontends/verilog/verilog_parser.y"
                         {
		(yyval.boolean) = true;
	}
#line 5951 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 427: /* always_or_always_ff: TOK_ALWAYS  */
#line 2078 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.boolean) = false;
	}
#line 5959 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 428: /* always_or_always_ff: TOK_ALWAYS_FF  */
#line 2081 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.boolean) = true;
	}
#line 5967 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 429: /* $@48: %empty  */
#line 2086 "frontends/verilog/verilog_parser.y"
                                 {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_ff] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 5980 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 430: /* $@49: %empty  */
#line 2093 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 5990 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 431: /* always_stmt: attr always_or_always_ff $@48 always_cond $@49 behavioral_stmt  */
#line 2097 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();

		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-4]), (yyloc));
		ast_stack.pop_back();

		SET_RULE_LOC((yyloc), (yylsp[-4]), (yyloc));
	}
#line 6004 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 432: /* $@50: %empty  */
#line 2106 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_latch] = AstNode::mkconst_int(1, false);
		else
			node->attributes[ID::always_comb] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6022 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 433: /* always_stmt: attr always_comb_or_latch $@50 behavioral_stmt  */
#line 2118 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6031 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 434: /* $@51: %empty  */
#line 2122 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_INITIAL);
		append_attr(node, (yyvsp[-1].al));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6045 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 435: /* always_stmt: attr TOK_INITIAL $@51 behavioral_stmt  */
#line 2130 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6054 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 445: /* always_event: TOK_POSEDGE expr  */
#line 2149 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_POSEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6065 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 446: /* always_event: TOK_NEGEDGE expr  */
#line 2155 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_NEGEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6076 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 447: /* always_event: expr  */
#line 2161 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_EDGE);
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6086 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 448: /* opt_label: ':' TOK_ID  */
#line 2168 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.string) = (yyvsp[0].string);
	}
#line 6094 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 449: /* opt_label: %empty  */
#line 2171 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = NULL;
	}
#line 6102 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 450: /* opt_sva_label: TOK_SVA_LABEL ':'  */
#line 2176 "frontends/verilog/verilog_parser.y"
                          {
		(yyval.string) = (yyvsp[-1].string);
	}
#line 6110 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 451: /* opt_sva_label: %empty  */
#line 2179 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = NULL;
	}
#line 6118 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 452: /* opt_property: TOK_PROPERTY  */
#line 2184 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.boolean) = true;
	}
#line 6126 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 453: /* opt_property: TOK_FINAL  */
#line 2187 "frontends/verilog/verilog_parser.y"
                  {
		(yyval.boolean) = false;
	}
#line 6134 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 454: /* opt_property: %empty  */
#line 2190 "frontends/verilog/verilog_parser.y"
               {
		(yyval.boolean) = false;
	}
#line 6142 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 455: /* $@52: %empty  */
#line 2195 "frontends/verilog/verilog_parser.y"
                       {
        AstNode *modport = new AstNode(AST_MODPORT);
        ast_stack.back()->children.push_back(modport);
        ast_stack.push_back(modport);
        modport->str = *(yyvsp[0].string);
        delete (yyvsp[0].string);
    }
#line 6154 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 456: /* $@53: %empty  */
#line 2201 "frontends/verilog/verilog_parser.y"
                        {
        ast_stack.pop_back();
        log_assert(ast_stack.size() == 2);
    }
#line 6163 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 464: /* modport_member: TOK_ID  */
#line 2217 "frontends/verilog/verilog_parser.y"
           {
        AstNode *modport_member = new AstNode(AST_MODPORTMEMBER);
        ast_stack.back()->children.push_back(modport_member);
        modport_member->str = *(yyvsp[0].string);
        modport_member->is_input = current_modport_input;
        modport_member->is_output = current_modport_output;
        delete (yyvsp[0].string);
    }
#line 6176 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 465: /* modport_type_token: TOK_INPUT  */
#line 2227 "frontends/verilog/verilog_parser.y"
              {current_modport_input = 1; current_modport_output = 0;}
#line 6182 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 466: /* modport_type_token: TOK_OUTPUT  */
#line 2227 "frontends/verilog/verilog_parser.y"
                                                                                    {current_modport_input = 0; current_modport_output = 1;}
#line 6188 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 467: /* assert: opt_sva_label TOK_ASSERT opt_property '(' expr ')' ';'  */
#line 2230 "frontends/verilog/verilog_parser.y"
                                                               {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6206 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 468: /* assert: opt_sva_label TOK_ASSUME opt_property '(' expr ')' ';'  */
#line 2243 "frontends/verilog/verilog_parser.y"
                                                               {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_ASSERT : AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6224 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 469: /* assert: opt_sva_label TOK_ASSERT opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2256 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6242 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 470: /* assert: opt_sva_label TOK_ASSUME opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2269 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_LIVE : AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6260 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 471: /* assert: opt_sva_label TOK_COVER opt_property '(' expr ')' ';'  */
#line 2282 "frontends/verilog/verilog_parser.y"
                                                              {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		if ((yyvsp[-6].string) != nullptr) {
			node->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6274 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 472: /* assert: opt_sva_label TOK_COVER opt_property '(' ')' ';'  */
#line 2291 "frontends/verilog/verilog_parser.y"
                                                         {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, (yylsp[-5]), (yylsp[-1]));
		if ((yyvsp[-5].string) != nullptr) {
			node->str = *(yyvsp[-5].string);
			delete (yyvsp[-5].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6288 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 473: /* assert: opt_sva_label TOK_COVER ';'  */
#line 2300 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[-1]));
		if ((yyvsp[-2].string) != nullptr) {
			node->str = *(yyvsp[-2].string);
			delete (yyvsp[-2].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6302 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 474: /* assert: opt_sva_label TOK_RESTRICT opt_property '(' expr ')' ';'  */
#line 2309 "frontends/verilog/verilog_parser.y"
                                                                 {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-4].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6322 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 475: /* assert: opt_sva_label TOK_RESTRICT opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2324 "frontends/verilog/verilog_parser.y"
                                                                                {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-5].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6342 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 476: /* assert_property: opt_sva_label TOK_ASSERT TOK_PROPERTY '(' expr ')' ';'  */
#line 2341 "frontends/verilog/verilog_parser.y"
                                                               {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6356 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 477: /* assert_property: opt_sva_label TOK_ASSUME TOK_PROPERTY '(' expr ')' ';'  */
#line 2350 "frontends/verilog/verilog_parser.y"
                                                               {
		AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6370 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 478: /* assert_property: opt_sva_label TOK_ASSERT TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2359 "frontends/verilog/verilog_parser.y"
                                                                              {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6384 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 479: /* assert_property: opt_sva_label TOK_ASSUME TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2368 "frontends/verilog/verilog_parser.y"
                                                                              {
		AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6398 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 480: /* assert_property: opt_sva_label TOK_COVER TOK_PROPERTY '(' expr ')' ';'  */
#line 2377 "frontends/verilog/verilog_parser.y"
                                                              {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6412 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 481: /* assert_property: opt_sva_label TOK_RESTRICT TOK_PROPERTY '(' expr ')' ';'  */
#line 2386 "frontends/verilog/verilog_parser.y"
                                                                 {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-6].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
				delete (yyvsp[-6].string);
			}
		}
	}
#line 6430 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 482: /* assert_property: opt_sva_label TOK_RESTRICT TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2399 "frontends/verilog/verilog_parser.y"
                                                                                {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-7].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
				delete (yyvsp[-7].string);
			}
		}
	}
#line 6448 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 483: /* simple_behavioral_stmt: attr lvalue '=' delay expr  */
#line 2414 "frontends/verilog/verilog_parser.y"
                                   {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6459 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 484: /* simple_behavioral_stmt: attr lvalue TOK_INCREMENT  */
#line 2420 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-1].ast), new AstNode(AST_ADD, (yyvsp[-1].ast)->clone(), AstNode::mkconst_int(1, true)));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[0]));
		append_attr(node, (yyvsp[-2].al));
	}
#line 6470 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 485: /* simple_behavioral_stmt: attr lvalue TOK_DECREMENT  */
#line 2426 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-1].ast), new AstNode(AST_SUB, (yyvsp[-1].ast)->clone(), AstNode::mkconst_int(1, true)));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[0]));
		append_attr(node, (yyvsp[-2].al));
	}
#line 6481 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 486: /* simple_behavioral_stmt: attr lvalue OP_LE delay expr  */
#line 2432 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_ASSIGN_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6492 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 487: /* simple_behavioral_stmt: attr lvalue TOK_XOR_ASSIGN delay expr  */
#line 2438 "frontends/verilog/verilog_parser.y"
                                              {
		AstNode *xor_node = new AstNode(AST_BIT_XOR, (yyvsp[-3].ast)->clone(), (yyvsp[0].ast));
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), xor_node);
		SET_AST_NODE_LOC(xor_node, (yylsp[-3]), (yylsp[0]));
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6505 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 488: /* simple_behavioral_stmt: attr lvalue TOK_OR_ASSIGN delay expr  */
#line 2446 "frontends/verilog/verilog_parser.y"
                                             {
		AstNode *or_node = new AstNode(AST_BIT_OR, (yyvsp[-3].ast)->clone(), (yyvsp[0].ast));
		SET_AST_NODE_LOC(or_node, (yylsp[-3]), (yylsp[0]));
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), or_node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6518 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 489: /* simple_behavioral_stmt: attr lvalue TOK_PLUS_ASSIGN delay expr  */
#line 2454 "frontends/verilog/verilog_parser.y"
                                               {
		AstNode *add_node = new AstNode(AST_ADD, (yyvsp[-3].ast)->clone(), (yyvsp[0].ast));
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), add_node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		SET_AST_NODE_LOC(add_node, (yylsp[-3]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6531 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 490: /* simple_behavioral_stmt: attr lvalue TOK_SUB_ASSIGN delay expr  */
#line 2462 "frontends/verilog/verilog_parser.y"
                                              {
		AstNode *sub_node = new AstNode(AST_SUB, (yyvsp[-3].ast)->clone(), (yyvsp[0].ast));
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), sub_node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		SET_AST_NODE_LOC(sub_node, (yylsp[-3]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6544 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 491: /* simple_behavioral_stmt: attr lvalue TOK_AND_ASSIGN delay expr  */
#line 2470 "frontends/verilog/verilog_parser.y"
                                              {
		AstNode *and_node = new AstNode(AST_BIT_AND, (yyvsp[-3].ast)->clone(), (yyvsp[0].ast));
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), and_node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		SET_AST_NODE_LOC(and_node, (yylsp[-3]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6557 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 500: /* behavioral_stmt: attr ';'  */
#line 2484 "frontends/verilog/verilog_parser.y"
                 {
		free_attr((yyvsp[-1].al));
	}
#line 6565 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 501: /* $@54: %empty  */
#line 2487 "frontends/verilog/verilog_parser.y"
                             {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 6578 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 502: /* behavioral_stmt: attr hierarchical_id $@54 opt_arg_list ';'  */
#line 2494 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
	}
#line 6586 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 503: /* $@55: %empty  */
#line 2497 "frontends/verilog/verilog_parser.y"
                           {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 6599 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 504: /* behavioral_stmt: attr TOK_MSG_TASKS $@55 opt_arg_list ';'  */
#line 2504 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
	}
#line 6607 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 505: /* $@56: %empty  */
#line 2507 "frontends/verilog/verilog_parser.y"
                       {
		enterTypeScope();
	}
#line 6615 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 506: /* $@57: %empty  */
#line 2509 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		if ((yyvsp[0].string) != NULL)
			node->str = *(yyvsp[0].string);
	}
#line 6628 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 507: /* behavioral_stmt: attr TOK_BEGIN $@56 opt_label $@57 behavioral_stmt_list TOK_END opt_label  */
#line 2516 "frontends/verilog/verilog_parser.y"
                                                 {
		exitTypeScope();
		if ((yyvsp[-4].string) != NULL && (yyvsp[0].string) != NULL && *(yyvsp[-4].string) != *(yyvsp[0].string))
			frontend_verilog_yyerror("Begin label (%s) and end label (%s) don't match.", (yyvsp[-4].string)->c_str()+1, (yyvsp[0].string)->c_str()+1);
		AstNode *node = ast_stack.back();
		// In SystemVerilog, unnamed blocks with block item declarations
		// create an implicit hierarchy scope
		if (sv_mode && node->str.empty())
		    for (const AstNode* child : node->children)
			if (child->type == AST_WIRE || child->type == AST_MEMORY || child->type == AST_PARAMETER
				|| child->type == AST_LOCALPARAM || child->type == AST_TYPEDEF) {
			    node->str = "$unnamed_block$" + std::to_string(autoidx++);
			    break;
			}
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		ast_stack.pop_back();
	}
#line 6652 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 508: /* $@58: %empty  */
#line 2535 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_FOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-2].al));
	}
#line 6663 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 509: /* $@59: %empty  */
#line 2540 "frontends/verilog/verilog_parser.y"
                                          {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 6671 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 510: /* $@60: %empty  */
#line 2542 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *block = new AstNode(AST_BLOCK);
		block->str = "$for_loop$" + std::to_string(autoidx++);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6682 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 511: /* behavioral_stmt: attr TOK_FOR '(' $@58 simple_behavioral_stmt ';' expr $@59 ';' simple_behavioral_stmt ')' $@60 behavioral_stmt  */
#line 2547 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-11]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 6693 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 512: /* $@61: %empty  */
#line 2553 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = new AstNode(AST_WHILE);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6708 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 513: /* behavioral_stmt: attr TOK_WHILE '(' expr ')' $@61 behavioral_stmt  */
#line 2562 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6718 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 514: /* $@62: %empty  */
#line 2567 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_REPEAT);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6733 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 515: /* behavioral_stmt: attr TOK_REPEAT '(' expr ')' $@62 behavioral_stmt  */
#line 2576 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6743 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 516: /* $@63: %empty  */
#line 2581 "frontends/verilog/verilog_parser.y"
                                 {
		AstNode *node = new AstNode(AST_CASE);
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, AstNode::mkconst_int(1, false, 1), block);
		SET_AST_NODE_LOC(cond, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back(new AstNode(AST_REDUCE_BOOL, (yyvsp[-1].ast)));
		node->children.push_back(cond);
		ast_stack.push_back(node);
		ast_stack.push_back(block);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6760 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 517: /* $@64: %empty  */
#line 2592 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 6768 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 518: /* behavioral_stmt: attr TOK_IF '(' expr ')' $@63 behavioral_stmt $@64 optional_else  */
#line 2594 "frontends/verilog/verilog_parser.y"
                        {
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 6778 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 519: /* $@65: %empty  */
#line 2599 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *node = new AstNode(AST_CASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-1]), (yylsp[-1]));
	}
#line 6790 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 520: /* behavioral_stmt: case_attr case_type '(' expr ')' $@65 opt_synopsys_attr case_body TOK_ENDCASE  */
#line 2605 "frontends/verilog/verilog_parser.y"
                                                  {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6800 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 521: /* case_attr: attr  */
#line 2612 "frontends/verilog/verilog_parser.y"
             {
		(yyval.al) = (yyvsp[0].al);
	}
#line 6808 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 522: /* case_attr: attr TOK_UNIQUE0  */
#line 2615 "frontends/verilog/verilog_parser.y"
                         {
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 6817 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 523: /* case_attr: attr TOK_PRIORITY  */
#line 2619 "frontends/verilog/verilog_parser.y"
                          {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 6826 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 524: /* case_attr: attr TOK_UNIQUE  */
#line 2623 "frontends/verilog/verilog_parser.y"
                        {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 6836 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 525: /* case_type: TOK_CASE  */
#line 2630 "frontends/verilog/verilog_parser.y"
                 {
		case_type_stack.push_back(0);
	}
#line 6844 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 526: /* case_type: TOK_CASEX  */
#line 2633 "frontends/verilog/verilog_parser.y"
                  {
		case_type_stack.push_back('x');
	}
#line 6852 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 527: /* case_type: TOK_CASEZ  */
#line 2636 "frontends/verilog/verilog_parser.y"
                  {
		case_type_stack.push_back('z');
	}
#line 6860 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 528: /* opt_synopsys_attr: opt_synopsys_attr TOK_SYNOPSYS_FULL_CASE  */
#line 2641 "frontends/verilog/verilog_parser.y"
                                                 {
		if (ast_stack.back()->attributes.count(ID::full_case) == 0)
			ast_stack.back()->attributes[ID::full_case] = AstNode::mkconst_int(1, false);
	}
#line 6869 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 529: /* opt_synopsys_attr: opt_synopsys_attr TOK_SYNOPSYS_PARALLEL_CASE  */
#line 2645 "frontends/verilog/verilog_parser.y"
                                                     {
		if (ast_stack.back()->attributes.count(ID::parallel_case) == 0)
			ast_stack.back()->attributes[ID::parallel_case] = AstNode::mkconst_int(1, false);
	}
#line 6878 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 533: /* $@66: %empty  */
#line 2656 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, new AstNode(AST_DEFAULT), block);
		SET_AST_NODE_LOC(cond, (yylsp[0]), (yylsp[0]));

		ast_stack.pop_back();
		ast_stack.back()->children.push_back(cond);
		ast_stack.push_back(block);
	}
#line 6892 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 534: /* optional_else: TOK_ELSE $@66 behavioral_stmt  */
#line 2664 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 6900 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 538: /* $@67: %empty  */
#line 2674 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 6912 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 539: /* $@68: %empty  */
#line 2680 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
		case_type_stack.push_back(0);
	}
#line 6923 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 540: /* case_item: $@67 case_select $@68 behavioral_stmt  */
#line 2685 "frontends/verilog/verilog_parser.y"
                          {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6934 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 543: /* $@69: %empty  */
#line 2697 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 6946 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 544: /* $@70: %empty  */
#line 2703 "frontends/verilog/verilog_parser.y"
                      {
		case_type_stack.push_back(0);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 6955 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 545: /* gen_case_item: $@69 case_select $@70 gen_stmt_block  */
#line 2706 "frontends/verilog/verilog_parser.y"
                         {
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6964 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 548: /* case_expr_list: TOK_DEFAULT  */
#line 2716 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_DEFAULT);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
	}
#line 6974 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 549: /* case_expr_list: TOK_SVA_LABEL  */
#line 2721 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *node = new AstNode(AST_IDENTIFIER);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 6986 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 550: /* case_expr_list: expr  */
#line 2728 "frontends/verilog/verilog_parser.y"
             {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 6994 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 551: /* case_expr_list: case_expr_list ',' expr  */
#line 2731 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7002 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 552: /* rvalue: hierarchical_id '[' expr ']' '.' rvalue  */
#line 2736 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_PREFIX, (yyvsp[-3].ast), (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-5].string);
		delete (yyvsp[-5].string);
	}
#line 7012 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 553: /* rvalue: hierarchical_id range  */
#line 2741 "frontends/verilog/verilog_parser.y"
                              {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
		if ((yyvsp[0].ast) == nullptr && ((yyval.ast)->str == "\\$initstate" ||
				(yyval.ast)->str == "\\$anyconst" || (yyval.ast)->str == "\\$anyseq" ||
				(yyval.ast)->str == "\\$allconst" || (yyval.ast)->str == "\\$allseq"))
			(yyval.ast)->type = AST_FCALL;
	}
#line 7027 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 554: /* rvalue: hierarchical_id non_opt_multirange  */
#line 2751 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
	}
#line 7038 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 555: /* lvalue: rvalue  */
#line 2759 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7046 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 556: /* lvalue: '{' lvalue_concat_list '}'  */
#line 2762 "frontends/verilog/verilog_parser.y"
                                   {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7054 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 557: /* lvalue_concat_list: expr  */
#line 2767 "frontends/verilog/verilog_parser.y"
             {
		(yyval.ast) = new AstNode(AST_CONCAT);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 7063 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 558: /* lvalue_concat_list: expr ',' lvalue_concat_list  */
#line 2771 "frontends/verilog/verilog_parser.y"
                                    {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 7072 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 565: /* single_arg: expr  */
#line 2789 "frontends/verilog/verilog_parser.y"
             {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7080 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 571: /* gen_stmt_or_module_body_stmt: attr ';'  */
#line 2800 "frontends/verilog/verilog_parser.y"
                 {
		free_attr((yyvsp[-1].al));
	}
#line 7088 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 572: /* $@71: %empty  */
#line 2806 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_GENFOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7098 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 573: /* $@72: %empty  */
#line 2810 "frontends/verilog/verilog_parser.y"
                                          {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7106 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 574: /* gen_stmt: TOK_FOR '(' $@71 simple_behavioral_stmt ';' expr $@72 ';' simple_behavioral_stmt ')' gen_stmt_block  */
#line 2812 "frontends/verilog/verilog_parser.y"
                                                        {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-10]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7115 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 575: /* $@73: %empty  */
#line 2816 "frontends/verilog/verilog_parser.y"
                            {
		AstNode *node = new AstNode(AST_GENIF);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
	}
#line 7126 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 576: /* gen_stmt: TOK_IF '(' expr ')' $@73 gen_stmt_block opt_gen_else  */
#line 2821 "frontends/verilog/verilog_parser.y"
                                      {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7135 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 577: /* $@74: %empty  */
#line 2825 "frontends/verilog/verilog_parser.y"
                               {
		AstNode *node = new AstNode(AST_GENCASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7145 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 578: /* gen_stmt: case_type '(' expr ')' $@74 gen_case_body TOK_ENDCASE  */
#line 2829 "frontends/verilog/verilog_parser.y"
                                    {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7155 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 579: /* $@75: %empty  */
#line 2834 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *node = new AstNode(AST_TECALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7167 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 580: /* gen_stmt: TOK_MSG_TASKS $@75 opt_arg_list ';'  */
#line 2840 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-3]), (yylsp[-1]));
		ast_stack.pop_back();
	}
#line 7176 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 581: /* $@76: %empty  */
#line 2846 "frontends/verilog/verilog_parser.y"
                  {
		enterTypeScope();
	}
#line 7184 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 582: /* $@77: %empty  */
#line 2848 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = (yyvsp[0].string) ? *(yyvsp[0].string) : std::string();
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7195 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 583: /* gen_block: TOK_BEGIN $@76 opt_label $@77 module_gen_body TOK_END opt_label  */
#line 2853 "frontends/verilog/verilog_parser.y"
                                            {
		exitTypeScope();
		if ((yyvsp[-4].string) != NULL && (yyvsp[0].string) != NULL && *(yyvsp[-4].string) != *(yyvsp[0].string))
			frontend_verilog_yyerror("Begin label (%s) and end label (%s) don't match.", (yyvsp[-4].string)->c_str()+1, (yyvsp[0].string)->c_str()+1);
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7209 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 584: /* $@78: %empty  */
#line 2865 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(AST_GENBLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7219 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 585: /* gen_stmt_block: $@78 gen_stmt_or_module_body_stmt  */
#line 2869 "frontends/verilog/verilog_parser.y"
                                       {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7228 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 589: /* expr: basic_expr  */
#line 2878 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7236 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 590: /* expr: basic_expr '?' attr expr ':' expr  */
#line 2881 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_TERNARY);
		(yyval.ast)->children.push_back((yyvsp[-5].ast));
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
		(yyval.ast)->children.push_back((yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-5]), (yyloc));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7249 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 591: /* basic_expr: rvalue  */
#line 2891 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7257 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 592: /* basic_expr: '(' expr ')' integral_number  */
#line 2894 "frontends/verilog/verilog_parser.y"
                                     {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants e.g. (<expr>)<constval> , while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = (yyvsp[-2].ast);
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[0].string);
	}
#line 7272 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 593: /* basic_expr: hierarchical_id integral_number  */
#line 2904 "frontends/verilog/verilog_parser.y"
                                        {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants, e.g. <ID>\'d0, while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = new AstNode(AST_IDENTIFIER);
		bits->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC(bits, (yylsp[-1]), (yylsp[-1]));
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC(val, (yylsp[0]), (yylsp[0]));
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 7291 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 594: /* basic_expr: integral_number  */
#line 2918 "frontends/verilog/verilog_parser.y"
                        {
		(yyval.ast) = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		if ((yyval.ast) == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		delete (yyvsp[0].string);
	}
#line 7303 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 595: /* basic_expr: TOK_REALVAL  */
#line 2925 "frontends/verilog/verilog_parser.y"
                    {
		(yyval.ast) = new AstNode(AST_REALVALUE);
		char *p = (char*)malloc(GetSize(*(yyvsp[0].string)) + 1), *q;
		for (int i = 0, j = 0; j < GetSize(*(yyvsp[0].string)); j++)
			if ((*(yyvsp[0].string))[j] != '_')
				p[i++] = (*(yyvsp[0].string))[j], p[i] = 0;
		(yyval.ast)->realvalue = strtod(p, &q);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		log_assert(*q == 0);
		delete (yyvsp[0].string);
		free(p);
	}
#line 7320 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 596: /* basic_expr: TOK_STRING  */
#line 2937 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.ast) = AstNode::mkconst_str(*(yyvsp[0].string));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		delete (yyvsp[0].string);
	}
#line 7330 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 597: /* $@79: %empty  */
#line 2942 "frontends/verilog/verilog_parser.y"
                             {
		AstNode *node = new AstNode(AST_FCALL);
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		append_attr(node, (yyvsp[0].al));
	}
#line 7343 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 598: /* basic_expr: hierarchical_id attr $@79 '(' arg_list optional_comma ')'  */
#line 2949 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = ast_stack.back();
		ast_stack.pop_back();
	}
#line 7352 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 599: /* basic_expr: TOK_TO_SIGNED attr '(' expr ')'  */
#line 2953 "frontends/verilog/verilog_parser.y"
                                        {
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7361 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 600: /* basic_expr: TOK_TO_UNSIGNED attr '(' expr ')'  */
#line 2957 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7370 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 601: /* basic_expr: '(' expr ')'  */
#line 2961 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7378 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 602: /* basic_expr: '(' expr ':' expr ':' expr ')'  */
#line 2964 "frontends/verilog/verilog_parser.y"
                                       {
		delete (yyvsp[-5].ast);
		(yyval.ast) = (yyvsp[-3].ast);
		delete (yyvsp[-1].ast);
	}
#line 7388 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 603: /* basic_expr: '{' concat_list '}'  */
#line 2969 "frontends/verilog/verilog_parser.y"
                            {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7396 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 604: /* basic_expr: '{' expr '{' concat_list '}' '}'  */
#line 2972 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_REPLICATE, (yyvsp[-4].ast), (yyvsp[-2].ast));
	}
#line 7404 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 605: /* basic_expr: '~' attr basic_expr  */
#line 2975 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_BIT_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7414 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 606: /* basic_expr: basic_expr '&' attr basic_expr  */
#line 2980 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7424 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 607: /* basic_expr: basic_expr OP_NAND attr basic_expr  */
#line 2985 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7434 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 608: /* basic_expr: basic_expr '|' attr basic_expr  */
#line 2990 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7444 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 609: /* basic_expr: basic_expr OP_NOR attr basic_expr  */
#line 2995 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7454 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 610: /* basic_expr: basic_expr '^' attr basic_expr  */
#line 3000 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_XOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7464 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 611: /* basic_expr: basic_expr OP_XNOR attr basic_expr  */
#line 3005 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_BIT_XNOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7474 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 612: /* basic_expr: '&' attr basic_expr  */
#line 3010 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7484 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 613: /* basic_expr: OP_NAND attr basic_expr  */
#line 3015 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
	}
#line 7495 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 614: /* basic_expr: '|' attr basic_expr  */
#line 3021 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7505 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 615: /* basic_expr: OP_NOR attr basic_expr  */
#line 3026 "frontends/verilog/verilog_parser.y"
                                               {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
	}
#line 7517 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 616: /* basic_expr: '^' attr basic_expr  */
#line 3033 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_XOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7527 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 617: /* basic_expr: OP_XNOR attr basic_expr  */
#line 3038 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_REDUCE_XNOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7537 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 618: /* basic_expr: basic_expr OP_SHL attr basic_expr  */
#line 3043 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_SHIFT_LEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7547 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 619: /* basic_expr: basic_expr OP_SHR attr basic_expr  */
#line 3048 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_SHIFT_RIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7557 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 620: /* basic_expr: basic_expr OP_SSHL attr basic_expr  */
#line 3053 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_SHIFT_SLEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7567 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 621: /* basic_expr: basic_expr OP_SSHR attr basic_expr  */
#line 3058 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_SHIFT_SRIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7577 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 622: /* basic_expr: basic_expr '<' attr basic_expr  */
#line 3063 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_LT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7587 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 623: /* basic_expr: basic_expr OP_LE attr basic_expr  */
#line 3068 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7597 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 624: /* basic_expr: basic_expr OP_EQ attr basic_expr  */
#line 3073 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7607 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 625: /* basic_expr: basic_expr OP_NE attr basic_expr  */
#line 3078 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_NE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7617 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 626: /* basic_expr: basic_expr OP_EQX attr basic_expr  */
#line 3083 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_EQX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7627 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 627: /* basic_expr: basic_expr OP_NEX attr basic_expr  */
#line 3088 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_NEX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7637 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 628: /* basic_expr: basic_expr OP_GE attr basic_expr  */
#line 3093 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_GE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7647 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 629: /* basic_expr: basic_expr '>' attr basic_expr  */
#line 3098 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_GT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7657 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 630: /* basic_expr: basic_expr '+' attr basic_expr  */
#line 3103 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_ADD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7667 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 631: /* basic_expr: basic_expr '-' attr basic_expr  */
#line 3108 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_SUB, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7677 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 632: /* basic_expr: basic_expr '*' attr basic_expr  */
#line 3113 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_MUL, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7687 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 633: /* basic_expr: basic_expr '/' attr basic_expr  */
#line 3118 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_DIV, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7697 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 634: /* basic_expr: basic_expr '%' attr basic_expr  */
#line 3123 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_MOD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7707 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 635: /* basic_expr: basic_expr OP_POW attr basic_expr  */
#line 3128 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_POW, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7717 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 636: /* basic_expr: '+' attr basic_expr  */
#line 3133 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_POS, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7727 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 637: /* basic_expr: '-' attr basic_expr  */
#line 3138 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_NEG, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7737 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 638: /* basic_expr: basic_expr OP_LAND attr basic_expr  */
#line 3143 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_LOGIC_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7747 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 639: /* basic_expr: basic_expr OP_LOR attr basic_expr  */
#line 3148 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_LOGIC_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7757 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 640: /* basic_expr: '!' attr basic_expr  */
#line 3153 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7767 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 641: /* basic_expr: TOK_SIGNED OP_CAST '(' expr ')'  */
#line 3158 "frontends/verilog/verilog_parser.y"
                                        {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 7778 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 642: /* basic_expr: TOK_UNSIGNED OP_CAST '(' expr ')'  */
#line 3164 "frontends/verilog/verilog_parser.y"
                                          {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 7789 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 643: /* basic_expr: basic_expr OP_CAST '(' expr ')'  */
#line 3170 "frontends/verilog/verilog_parser.y"
                                        {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_CAST_SIZE, (yyvsp[-4].ast), (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 7800 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 644: /* concat_list: expr  */
#line 3178 "frontends/verilog/verilog_parser.y"
             {
		(yyval.ast) = new AstNode(AST_CONCAT, (yyvsp[0].ast));
	}
#line 7808 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 645: /* concat_list: expr ',' concat_list  */
#line 3181 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 7817 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 646: /* integral_number: TOK_CONSTVAL  */
#line 3187 "frontends/verilog/verilog_parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 7823 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 647: /* integral_number: TOK_UNBASED_UNSIZED_CONSTVAL  */
#line 3188 "frontends/verilog/verilog_parser.y"
                                     { (yyval.string) = (yyvsp[0].string); }
#line 7829 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 648: /* integral_number: TOK_BASE TOK_BASED_CONSTVAL  */
#line 3189 "frontends/verilog/verilog_parser.y"
                                    {
		(yyvsp[-1].string)->append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 7839 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 649: /* integral_number: TOK_CONSTVAL TOK_BASE TOK_BASED_CONSTVAL  */
#line 3194 "frontends/verilog/verilog_parser.y"
                                                 {
		(yyvsp[-2].string)->append(*(yyvsp[-1].string)).append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-2].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 7850 "frontends/verilog/verilog_parser.tab.cc"
    break;


#line 7854 "frontends/verilog/verilog_parser.tab.cc"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == FRONTEND_VERILOG_YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != FRONTEND_VERILOG_YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= FRONTEND_VERILOG_YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == FRONTEND_VERILOG_YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = FRONTEND_VERILOG_YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != FRONTEND_VERILOG_YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

